// WARNING - DO NOT EDIT THIS FILE:
// This file was automatically generated from scripts/ShAttrib.hpp.py.
// If you wish to change it, edit that file instead.
//
// ---
//
// Sh: A GPU metaprogramming language.
//
// Copyright 2003-2006 Serious Hack Inc.
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
// MA  02110-1301, USA
//////////////////////////////////////////////////////////////////////////////

#ifndef SH_SHATTRIB_HPP
#define SH_SHATTRIB_HPP

#ifndef SH_DO_NOT_INCLUDE_GENERIC_IMPL
#  define SH_DO_NOT_INCLUDE_GENERIC_IMPL
#  include "ShGeneric.hpp"
#  undef SH_DO_NOT_INCLUDE_GENERIC_IMPL
#else
#  include "ShGeneric.hpp"
#endif
namespace SH {

/** A generic attribute (or parameter) holding N values.
 * 
 * The reason we have the Swizzle template argument is so that
 * swizzled variables, which need to be copied (i.e. have an ASN
 * statement generated) when another variable is initialized through
 * them, may otherwise be simply placed into new variables (through
 * copy constructor eliding, as per paragraph 12.8.15 of the C++
 * standard), causing variables to share ShVariableNodes when they
 * shouldn't. By making swizzled variables separate types we enforce
 * calling a conversion constructor instead, which cannot be elided.
 * If this paragraph confuses you, and you're not modifying Sh
 * internals, you may safely ignore it.
 *
 */
template<int N, ShBindingType Binding, typename T=float, ShSemanticType Semantic=SH_ATTRIB, bool Swizzled=false>
class ShAttrib : public ShGeneric<N, T> {
public:
  typedef T storage_type;
  typedef typename ShHostType<T>::type host_type; 
  typedef typename ShMemType<T>::type mem_type; 
  static const ShBindingType binding_type = Binding;
  static const ShSemanticType semantic_type = Semantic;

  typedef ShAttrib<N, SH_INPUT, T, Semantic> InputType;
  typedef ShAttrib<N, SH_OUTPUT, T, Semantic> OutputType;
  typedef ShAttrib<N, SH_INOUT, T, Semantic> InOutType;
  typedef ShAttrib<N, SH_TEMP, T, Semantic> TempType;
  typedef ShAttrib<N, SH_CONST, T, Semantic> ConstType;
  ShAttrib();
  
  template<typename T2>
  ShAttrib(const ShGeneric<N, T2>& other);
  ShAttrib(const ShAttrib<N, Binding, T, Semantic, Swizzled>& other);
  
  template<typename T2>
  ShAttrib(const ShAttrib<N, Binding, T2, Semantic, Swizzled>& other);
  ShAttrib(const ShVariableNodePtr& node, const ShSwizzle& swizzle, bool neg);
  explicit ShAttrib(const host_type data[N]);
  
  ~ShAttrib();

  
  template<typename T2>
  ShAttrib& operator=(const ShGeneric<N, T2>& other);
  
  template<typename T2>
  ShAttrib& operator=(const ShAttrib<N, Binding, T2, Semantic, Swizzled>& other);
  ShAttrib& operator=(const ShAttrib<N, Binding, T, Semantic, Swizzled>& other);

  ShAttrib& operator=(const ShProgram& prg);

  
  ShAttrib& operator++();
  
  ShAttrib& operator--();
  
  template<typename T2>
  ShAttrib& operator+=(const ShGeneric<N, T2>& right);
  
  template<typename T2>
  ShAttrib& operator-=(const ShGeneric<N, T2>& right);
  
  template<typename T2>
  ShAttrib& operator*=(const ShGeneric<N, T2>& right);
  
  template<typename T2>
  ShAttrib& operator/=(const ShGeneric<N, T2>& right);
  
  template<typename T2>
  ShAttrib& operator%=(const ShGeneric<N, T2>& right);
  ShAttrib& operator*=(host_type);
  ShAttrib& operator/=(host_type);
  ShAttrib& operator%=(host_type);
  ShAttrib& operator+=(host_type);
  ShAttrib& operator-=(host_type);
  
  template<typename T2>
  ShAttrib& operator+=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator-=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator*=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator/=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator%=(const ShGeneric<1, T2>&);
  ShAttrib<1, Binding, T, Semantic, true> operator()(int) const;
  ShAttrib<2, Binding, T, Semantic, true> operator()(int, int) const;
  ShAttrib<3, Binding, T, Semantic, true> operator()(int, int, int) const;
  ShAttrib<4, Binding, T, Semantic, true> operator()(int, int, int, int) const;
  ShAttrib<1, Binding, T, Semantic, true> operator[](int) const;
  
  template<int N2>
  ShAttrib<N2, Binding, T, Semantic, true> swiz(int indices[]) const;
  
  ShAttrib operator-() const;
  private:
    typedef ShGeneric<N, T> ParentType;
};

template<ShBindingType Binding, typename T, ShSemanticType Semantic, bool Swizzled>
class ShAttrib<1, Binding, T, Semantic, Swizzled> : public ShGeneric<1, T> {
public:
  typedef T storage_type;
  typedef typename ShHostType<T>::type host_type; 
  typedef typename ShMemType<T>::type mem_type; 
  static const ShBindingType binding_type = Binding;
  static const ShSemanticType semantic_type = Semantic;

  typedef ShAttrib<1, SH_INPUT, T, Semantic> InputType;
  typedef ShAttrib<1, SH_OUTPUT, T, Semantic> OutputType;
  typedef ShAttrib<1, SH_INOUT, T, Semantic> InOutType;
  typedef ShAttrib<1, SH_TEMP, T, Semantic> TempType;
  typedef ShAttrib<1, SH_CONST, T, Semantic> ConstType;
  ShAttrib();
  
  template<typename T2>
  ShAttrib(const ShGeneric<1, T2>& other);
  ShAttrib(const ShAttrib<1, Binding, T, Semantic, Swizzled>& other);
  
  template<typename T2>
  ShAttrib(const ShAttrib<1, Binding, T2, Semantic, Swizzled>& other);
  ShAttrib(const ShVariableNodePtr& node, const ShSwizzle& swizzle, bool neg);
  explicit ShAttrib(const host_type data[1]);
  
  ShAttrib(host_type);
  
  ~ShAttrib();

  
  template<typename T2>
  ShAttrib& operator=(const ShGeneric<1, T2>& other);
  
  template<typename T2>
  ShAttrib& operator=(const ShAttrib<1, Binding, T2, Semantic, Swizzled>& other);
  ShAttrib& operator=(const ShAttrib<1, Binding, T, Semantic, Swizzled>& other);

  ShAttrib& operator=(host_type other);

  ShAttrib& operator=(const ShProgram& prg);

  
  ShAttrib& operator++();
  
  ShAttrib& operator--();
  
  template<typename T2>
  ShAttrib& operator+=(const ShGeneric<1, T2>& right);
  
  template<typename T2>
  ShAttrib& operator-=(const ShGeneric<1, T2>& right);
  
  template<typename T2>
  ShAttrib& operator*=(const ShGeneric<1, T2>& right);
  
  template<typename T2>
  ShAttrib& operator/=(const ShGeneric<1, T2>& right);
  
  template<typename T2>
  ShAttrib& operator%=(const ShGeneric<1, T2>& right);
  ShAttrib& operator*=(host_type);
  ShAttrib& operator/=(host_type);
  ShAttrib& operator%=(host_type);
  ShAttrib& operator+=(host_type);
  ShAttrib& operator-=(host_type);
  ShAttrib<1, Binding, T, Semantic, true> operator()(int) const;
  ShAttrib<2, Binding, T, Semantic, true> operator()(int, int) const;
  ShAttrib<3, Binding, T, Semantic, true> operator()(int, int, int) const;
  ShAttrib<4, Binding, T, Semantic, true> operator()(int, int, int, int) const;
  ShAttrib<1, Binding, T, Semantic, true> operator[](int) const;
  
  template<int N2>
  ShAttrib<N2, Binding, T, Semantic, true> swiz(int indices[]) const;
  
  ShAttrib operator-() const;
  private:
    typedef ShGeneric<1, T> ParentType;
};

template<ShBindingType Binding, typename T, ShSemanticType Semantic, bool Swizzled>
class ShAttrib<2, Binding, T, Semantic, Swizzled> : public ShGeneric<2, T> {
public:
  typedef T storage_type;
  typedef typename ShHostType<T>::type host_type; 
  typedef typename ShMemType<T>::type mem_type; 
  static const ShBindingType binding_type = Binding;
  static const ShSemanticType semantic_type = Semantic;

  typedef ShAttrib<2, SH_INPUT, T, Semantic> InputType;
  typedef ShAttrib<2, SH_OUTPUT, T, Semantic> OutputType;
  typedef ShAttrib<2, SH_INOUT, T, Semantic> InOutType;
  typedef ShAttrib<2, SH_TEMP, T, Semantic> TempType;
  typedef ShAttrib<2, SH_CONST, T, Semantic> ConstType;
  ShAttrib();
  
  template<typename T2>
  ShAttrib(const ShGeneric<2, T2>& other);
  ShAttrib(const ShAttrib<2, Binding, T, Semantic, Swizzled>& other);
  
  template<typename T2>
  ShAttrib(const ShAttrib<2, Binding, T2, Semantic, Swizzled>& other);
  ShAttrib(const ShVariableNodePtr& node, const ShSwizzle& swizzle, bool neg);
  explicit ShAttrib(const host_type data[2]);
  
  ShAttrib(host_type, host_type);
  template<typename T2, typename T3>
  ShAttrib(const ShGeneric<1, T2>&, const ShGeneric<1, T3>&);
  
  ~ShAttrib();

  
  template<typename T2>
  ShAttrib& operator=(const ShGeneric<2, T2>& other);
  
  template<typename T2>
  ShAttrib& operator=(const ShAttrib<2, Binding, T2, Semantic, Swizzled>& other);
  ShAttrib& operator=(const ShAttrib<2, Binding, T, Semantic, Swizzled>& other);

  ShAttrib& operator=(const ShProgram& prg);

  
  ShAttrib& operator++();
  
  ShAttrib& operator--();
  
  template<typename T2>
  ShAttrib& operator+=(const ShGeneric<2, T2>& right);
  
  template<typename T2>
  ShAttrib& operator-=(const ShGeneric<2, T2>& right);
  
  template<typename T2>
  ShAttrib& operator*=(const ShGeneric<2, T2>& right);
  
  template<typename T2>
  ShAttrib& operator/=(const ShGeneric<2, T2>& right);
  
  template<typename T2>
  ShAttrib& operator%=(const ShGeneric<2, T2>& right);
  ShAttrib& operator*=(host_type);
  ShAttrib& operator/=(host_type);
  ShAttrib& operator%=(host_type);
  ShAttrib& operator+=(host_type);
  ShAttrib& operator-=(host_type);
  
  template<typename T2>
  ShAttrib& operator+=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator-=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator*=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator/=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator%=(const ShGeneric<1, T2>&);
  ShAttrib<1, Binding, T, Semantic, true> operator()(int) const;
  ShAttrib<2, Binding, T, Semantic, true> operator()(int, int) const;
  ShAttrib<3, Binding, T, Semantic, true> operator()(int, int, int) const;
  ShAttrib<4, Binding, T, Semantic, true> operator()(int, int, int, int) const;
  ShAttrib<1, Binding, T, Semantic, true> operator[](int) const;
  
  template<int N2>
  ShAttrib<N2, Binding, T, Semantic, true> swiz(int indices[]) const;
  
  ShAttrib operator-() const;
  private:
    typedef ShGeneric<2, T> ParentType;
};

template<ShBindingType Binding, typename T, ShSemanticType Semantic, bool Swizzled>
class ShAttrib<3, Binding, T, Semantic, Swizzled> : public ShGeneric<3, T> {
public:
  typedef T storage_type;
  typedef typename ShHostType<T>::type host_type; 
  typedef typename ShMemType<T>::type mem_type; 
  static const ShBindingType binding_type = Binding;
  static const ShSemanticType semantic_type = Semantic;

  typedef ShAttrib<3, SH_INPUT, T, Semantic> InputType;
  typedef ShAttrib<3, SH_OUTPUT, T, Semantic> OutputType;
  typedef ShAttrib<3, SH_INOUT, T, Semantic> InOutType;
  typedef ShAttrib<3, SH_TEMP, T, Semantic> TempType;
  typedef ShAttrib<3, SH_CONST, T, Semantic> ConstType;
  ShAttrib();
  
  template<typename T2>
  ShAttrib(const ShGeneric<3, T2>& other);
  ShAttrib(const ShAttrib<3, Binding, T, Semantic, Swizzled>& other);
  
  template<typename T2>
  ShAttrib(const ShAttrib<3, Binding, T2, Semantic, Swizzled>& other);
  ShAttrib(const ShVariableNodePtr& node, const ShSwizzle& swizzle, bool neg);
  explicit ShAttrib(const host_type data[3]);
  
  ShAttrib(host_type, host_type, host_type);
  template<typename T2, typename T3, typename T4>
  ShAttrib(const ShGeneric<1, T2>&, const ShGeneric<1, T3>&, const ShGeneric<1, T4>&);
  
  ~ShAttrib();

  
  template<typename T2>
  ShAttrib& operator=(const ShGeneric<3, T2>& other);
  
  template<typename T2>
  ShAttrib& operator=(const ShAttrib<3, Binding, T2, Semantic, Swizzled>& other);
  ShAttrib& operator=(const ShAttrib<3, Binding, T, Semantic, Swizzled>& other);

  ShAttrib& operator=(const ShProgram& prg);

  
  ShAttrib& operator++();
  
  ShAttrib& operator--();
  
  template<typename T2>
  ShAttrib& operator+=(const ShGeneric<3, T2>& right);
  
  template<typename T2>
  ShAttrib& operator-=(const ShGeneric<3, T2>& right);
  
  template<typename T2>
  ShAttrib& operator*=(const ShGeneric<3, T2>& right);
  
  template<typename T2>
  ShAttrib& operator/=(const ShGeneric<3, T2>& right);
  
  template<typename T2>
  ShAttrib& operator%=(const ShGeneric<3, T2>& right);
  ShAttrib& operator*=(host_type);
  ShAttrib& operator/=(host_type);
  ShAttrib& operator%=(host_type);
  ShAttrib& operator+=(host_type);
  ShAttrib& operator-=(host_type);
  
  template<typename T2>
  ShAttrib& operator+=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator-=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator*=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator/=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator%=(const ShGeneric<1, T2>&);
  ShAttrib<1, Binding, T, Semantic, true> operator()(int) const;
  ShAttrib<2, Binding, T, Semantic, true> operator()(int, int) const;
  ShAttrib<3, Binding, T, Semantic, true> operator()(int, int, int) const;
  ShAttrib<4, Binding, T, Semantic, true> operator()(int, int, int, int) const;
  ShAttrib<1, Binding, T, Semantic, true> operator[](int) const;
  
  template<int N2>
  ShAttrib<N2, Binding, T, Semantic, true> swiz(int indices[]) const;
  
  ShAttrib operator-() const;
  private:
    typedef ShGeneric<3, T> ParentType;
};

template<ShBindingType Binding, typename T, ShSemanticType Semantic, bool Swizzled>
class ShAttrib<4, Binding, T, Semantic, Swizzled> : public ShGeneric<4, T> {
public:
  typedef T storage_type;
  typedef typename ShHostType<T>::type host_type; 
  typedef typename ShMemType<T>::type mem_type; 
  static const ShBindingType binding_type = Binding;
  static const ShSemanticType semantic_type = Semantic;

  typedef ShAttrib<4, SH_INPUT, T, Semantic> InputType;
  typedef ShAttrib<4, SH_OUTPUT, T, Semantic> OutputType;
  typedef ShAttrib<4, SH_INOUT, T, Semantic> InOutType;
  typedef ShAttrib<4, SH_TEMP, T, Semantic> TempType;
  typedef ShAttrib<4, SH_CONST, T, Semantic> ConstType;
  ShAttrib();
  
  template<typename T2>
  ShAttrib(const ShGeneric<4, T2>& other);
  ShAttrib(const ShAttrib<4, Binding, T, Semantic, Swizzled>& other);
  
  template<typename T2>
  ShAttrib(const ShAttrib<4, Binding, T2, Semantic, Swizzled>& other);
  ShAttrib(const ShVariableNodePtr& node, const ShSwizzle& swizzle, bool neg);
  explicit ShAttrib(const host_type data[4]);
  
  ShAttrib(host_type, host_type, host_type, host_type);
  template<typename T2, typename T3, typename T4, typename T5>
  ShAttrib(const ShGeneric<1, T2>&, const ShGeneric<1, T3>&, const ShGeneric<1, T4>&, const ShGeneric<1, T5>&);
  
  ~ShAttrib();

  
  template<typename T2>
  ShAttrib& operator=(const ShGeneric<4, T2>& other);
  
  template<typename T2>
  ShAttrib& operator=(const ShAttrib<4, Binding, T2, Semantic, Swizzled>& other);
  ShAttrib& operator=(const ShAttrib<4, Binding, T, Semantic, Swizzled>& other);

  ShAttrib& operator=(const ShProgram& prg);

  
  ShAttrib& operator++();
  
  ShAttrib& operator--();
  
  template<typename T2>
  ShAttrib& operator+=(const ShGeneric<4, T2>& right);
  
  template<typename T2>
  ShAttrib& operator-=(const ShGeneric<4, T2>& right);
  
  template<typename T2>
  ShAttrib& operator*=(const ShGeneric<4, T2>& right);
  
  template<typename T2>
  ShAttrib& operator/=(const ShGeneric<4, T2>& right);
  
  template<typename T2>
  ShAttrib& operator%=(const ShGeneric<4, T2>& right);
  ShAttrib& operator*=(host_type);
  ShAttrib& operator/=(host_type);
  ShAttrib& operator%=(host_type);
  ShAttrib& operator+=(host_type);
  ShAttrib& operator-=(host_type);
  
  template<typename T2>
  ShAttrib& operator+=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator-=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator*=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator/=(const ShGeneric<1, T2>&);
  
  template<typename T2>
  ShAttrib& operator%=(const ShGeneric<1, T2>&);
  ShAttrib<1, Binding, T, Semantic, true> operator()(int) const;
  ShAttrib<2, Binding, T, Semantic, true> operator()(int, int) const;
  ShAttrib<3, Binding, T, Semantic, true> operator()(int, int, int) const;
  ShAttrib<4, Binding, T, Semantic, true> operator()(int, int, int, int) const;
  ShAttrib<1, Binding, T, Semantic, true> operator[](int) const;
  
  template<int N2>
  ShAttrib<N2, Binding, T, Semantic, true> swiz(int indices[]) const;
  
  ShAttrib operator-() const;
  private:
    typedef ShGeneric<4, T> ParentType;
};

typedef ShAttrib<1, SH_INPUT, ShFracUShort, SH_ATTRIB> ShInputAttrib1fus;
typedef ShAttrib<1, SH_OUTPUT, ShFracUShort, SH_ATTRIB> ShOutputAttrib1fus;
typedef ShAttrib<1, SH_INOUT, ShFracUShort, SH_ATTRIB> ShInOutAttrib1fus;
typedef ShAttrib<1, SH_TEMP, ShFracUShort, SH_ATTRIB> ShAttrib1fus;
typedef ShAttrib<1, SH_CONST, ShFracUShort, SH_ATTRIB> ShConstAttrib1fus;
typedef ShAttrib<2, SH_INPUT, ShFracUShort, SH_ATTRIB> ShInputAttrib2fus;
typedef ShAttrib<2, SH_OUTPUT, ShFracUShort, SH_ATTRIB> ShOutputAttrib2fus;
typedef ShAttrib<2, SH_INOUT, ShFracUShort, SH_ATTRIB> ShInOutAttrib2fus;
typedef ShAttrib<2, SH_TEMP, ShFracUShort, SH_ATTRIB> ShAttrib2fus;
typedef ShAttrib<2, SH_CONST, ShFracUShort, SH_ATTRIB> ShConstAttrib2fus;
typedef ShAttrib<3, SH_INPUT, ShFracUShort, SH_ATTRIB> ShInputAttrib3fus;
typedef ShAttrib<3, SH_OUTPUT, ShFracUShort, SH_ATTRIB> ShOutputAttrib3fus;
typedef ShAttrib<3, SH_INOUT, ShFracUShort, SH_ATTRIB> ShInOutAttrib3fus;
typedef ShAttrib<3, SH_TEMP, ShFracUShort, SH_ATTRIB> ShAttrib3fus;
typedef ShAttrib<3, SH_CONST, ShFracUShort, SH_ATTRIB> ShConstAttrib3fus;
typedef ShAttrib<4, SH_INPUT, ShFracUShort, SH_ATTRIB> ShInputAttrib4fus;
typedef ShAttrib<4, SH_OUTPUT, ShFracUShort, SH_ATTRIB> ShOutputAttrib4fus;
typedef ShAttrib<4, SH_INOUT, ShFracUShort, SH_ATTRIB> ShInOutAttrib4fus;
typedef ShAttrib<4, SH_TEMP, ShFracUShort, SH_ATTRIB> ShAttrib4fus;
typedef ShAttrib<4, SH_CONST, ShFracUShort, SH_ATTRIB> ShConstAttrib4fus;


typedef ShAttrib<1, SH_INPUT, short, SH_ATTRIB> ShInputAttrib1s;
typedef ShAttrib<1, SH_OUTPUT, short, SH_ATTRIB> ShOutputAttrib1s;
typedef ShAttrib<1, SH_INOUT, short, SH_ATTRIB> ShInOutAttrib1s;
typedef ShAttrib<1, SH_TEMP, short, SH_ATTRIB> ShAttrib1s;
typedef ShAttrib<1, SH_CONST, short, SH_ATTRIB> ShConstAttrib1s;
typedef ShAttrib<2, SH_INPUT, short, SH_ATTRIB> ShInputAttrib2s;
typedef ShAttrib<2, SH_OUTPUT, short, SH_ATTRIB> ShOutputAttrib2s;
typedef ShAttrib<2, SH_INOUT, short, SH_ATTRIB> ShInOutAttrib2s;
typedef ShAttrib<2, SH_TEMP, short, SH_ATTRIB> ShAttrib2s;
typedef ShAttrib<2, SH_CONST, short, SH_ATTRIB> ShConstAttrib2s;
typedef ShAttrib<3, SH_INPUT, short, SH_ATTRIB> ShInputAttrib3s;
typedef ShAttrib<3, SH_OUTPUT, short, SH_ATTRIB> ShOutputAttrib3s;
typedef ShAttrib<3, SH_INOUT, short, SH_ATTRIB> ShInOutAttrib3s;
typedef ShAttrib<3, SH_TEMP, short, SH_ATTRIB> ShAttrib3s;
typedef ShAttrib<3, SH_CONST, short, SH_ATTRIB> ShConstAttrib3s;
typedef ShAttrib<4, SH_INPUT, short, SH_ATTRIB> ShInputAttrib4s;
typedef ShAttrib<4, SH_OUTPUT, short, SH_ATTRIB> ShOutputAttrib4s;
typedef ShAttrib<4, SH_INOUT, short, SH_ATTRIB> ShInOutAttrib4s;
typedef ShAttrib<4, SH_TEMP, short, SH_ATTRIB> ShAttrib4s;
typedef ShAttrib<4, SH_CONST, short, SH_ATTRIB> ShConstAttrib4s;


typedef ShAttrib<1, SH_INPUT, ShFracUInt, SH_ATTRIB> ShInputAttrib1fui;
typedef ShAttrib<1, SH_OUTPUT, ShFracUInt, SH_ATTRIB> ShOutputAttrib1fui;
typedef ShAttrib<1, SH_INOUT, ShFracUInt, SH_ATTRIB> ShInOutAttrib1fui;
typedef ShAttrib<1, SH_TEMP, ShFracUInt, SH_ATTRIB> ShAttrib1fui;
typedef ShAttrib<1, SH_CONST, ShFracUInt, SH_ATTRIB> ShConstAttrib1fui;
typedef ShAttrib<2, SH_INPUT, ShFracUInt, SH_ATTRIB> ShInputAttrib2fui;
typedef ShAttrib<2, SH_OUTPUT, ShFracUInt, SH_ATTRIB> ShOutputAttrib2fui;
typedef ShAttrib<2, SH_INOUT, ShFracUInt, SH_ATTRIB> ShInOutAttrib2fui;
typedef ShAttrib<2, SH_TEMP, ShFracUInt, SH_ATTRIB> ShAttrib2fui;
typedef ShAttrib<2, SH_CONST, ShFracUInt, SH_ATTRIB> ShConstAttrib2fui;
typedef ShAttrib<3, SH_INPUT, ShFracUInt, SH_ATTRIB> ShInputAttrib3fui;
typedef ShAttrib<3, SH_OUTPUT, ShFracUInt, SH_ATTRIB> ShOutputAttrib3fui;
typedef ShAttrib<3, SH_INOUT, ShFracUInt, SH_ATTRIB> ShInOutAttrib3fui;
typedef ShAttrib<3, SH_TEMP, ShFracUInt, SH_ATTRIB> ShAttrib3fui;
typedef ShAttrib<3, SH_CONST, ShFracUInt, SH_ATTRIB> ShConstAttrib3fui;
typedef ShAttrib<4, SH_INPUT, ShFracUInt, SH_ATTRIB> ShInputAttrib4fui;
typedef ShAttrib<4, SH_OUTPUT, ShFracUInt, SH_ATTRIB> ShOutputAttrib4fui;
typedef ShAttrib<4, SH_INOUT, ShFracUInt, SH_ATTRIB> ShInOutAttrib4fui;
typedef ShAttrib<4, SH_TEMP, ShFracUInt, SH_ATTRIB> ShAttrib4fui;
typedef ShAttrib<4, SH_CONST, ShFracUInt, SH_ATTRIB> ShConstAttrib4fui;


typedef ShAttrib<1, SH_INPUT, ShFracByte, SH_ATTRIB> ShInputAttrib1fb;
typedef ShAttrib<1, SH_OUTPUT, ShFracByte, SH_ATTRIB> ShOutputAttrib1fb;
typedef ShAttrib<1, SH_INOUT, ShFracByte, SH_ATTRIB> ShInOutAttrib1fb;
typedef ShAttrib<1, SH_TEMP, ShFracByte, SH_ATTRIB> ShAttrib1fb;
typedef ShAttrib<1, SH_CONST, ShFracByte, SH_ATTRIB> ShConstAttrib1fb;
typedef ShAttrib<2, SH_INPUT, ShFracByte, SH_ATTRIB> ShInputAttrib2fb;
typedef ShAttrib<2, SH_OUTPUT, ShFracByte, SH_ATTRIB> ShOutputAttrib2fb;
typedef ShAttrib<2, SH_INOUT, ShFracByte, SH_ATTRIB> ShInOutAttrib2fb;
typedef ShAttrib<2, SH_TEMP, ShFracByte, SH_ATTRIB> ShAttrib2fb;
typedef ShAttrib<2, SH_CONST, ShFracByte, SH_ATTRIB> ShConstAttrib2fb;
typedef ShAttrib<3, SH_INPUT, ShFracByte, SH_ATTRIB> ShInputAttrib3fb;
typedef ShAttrib<3, SH_OUTPUT, ShFracByte, SH_ATTRIB> ShOutputAttrib3fb;
typedef ShAttrib<3, SH_INOUT, ShFracByte, SH_ATTRIB> ShInOutAttrib3fb;
typedef ShAttrib<3, SH_TEMP, ShFracByte, SH_ATTRIB> ShAttrib3fb;
typedef ShAttrib<3, SH_CONST, ShFracByte, SH_ATTRIB> ShConstAttrib3fb;
typedef ShAttrib<4, SH_INPUT, ShFracByte, SH_ATTRIB> ShInputAttrib4fb;
typedef ShAttrib<4, SH_OUTPUT, ShFracByte, SH_ATTRIB> ShOutputAttrib4fb;
typedef ShAttrib<4, SH_INOUT, ShFracByte, SH_ATTRIB> ShInOutAttrib4fb;
typedef ShAttrib<4, SH_TEMP, ShFracByte, SH_ATTRIB> ShAttrib4fb;
typedef ShAttrib<4, SH_CONST, ShFracByte, SH_ATTRIB> ShConstAttrib4fb;


typedef ShAttrib<1, SH_INPUT, int, SH_ATTRIB> ShInputAttrib1i;
typedef ShAttrib<1, SH_OUTPUT, int, SH_ATTRIB> ShOutputAttrib1i;
typedef ShAttrib<1, SH_INOUT, int, SH_ATTRIB> ShInOutAttrib1i;
typedef ShAttrib<1, SH_TEMP, int, SH_ATTRIB> ShAttrib1i;
typedef ShAttrib<1, SH_CONST, int, SH_ATTRIB> ShConstAttrib1i;
typedef ShAttrib<2, SH_INPUT, int, SH_ATTRIB> ShInputAttrib2i;
typedef ShAttrib<2, SH_OUTPUT, int, SH_ATTRIB> ShOutputAttrib2i;
typedef ShAttrib<2, SH_INOUT, int, SH_ATTRIB> ShInOutAttrib2i;
typedef ShAttrib<2, SH_TEMP, int, SH_ATTRIB> ShAttrib2i;
typedef ShAttrib<2, SH_CONST, int, SH_ATTRIB> ShConstAttrib2i;
typedef ShAttrib<3, SH_INPUT, int, SH_ATTRIB> ShInputAttrib3i;
typedef ShAttrib<3, SH_OUTPUT, int, SH_ATTRIB> ShOutputAttrib3i;
typedef ShAttrib<3, SH_INOUT, int, SH_ATTRIB> ShInOutAttrib3i;
typedef ShAttrib<3, SH_TEMP, int, SH_ATTRIB> ShAttrib3i;
typedef ShAttrib<3, SH_CONST, int, SH_ATTRIB> ShConstAttrib3i;
typedef ShAttrib<4, SH_INPUT, int, SH_ATTRIB> ShInputAttrib4i;
typedef ShAttrib<4, SH_OUTPUT, int, SH_ATTRIB> ShOutputAttrib4i;
typedef ShAttrib<4, SH_INOUT, int, SH_ATTRIB> ShInOutAttrib4i;
typedef ShAttrib<4, SH_TEMP, int, SH_ATTRIB> ShAttrib4i;
typedef ShAttrib<4, SH_CONST, int, SH_ATTRIB> ShConstAttrib4i;


typedef ShAttrib<1, SH_INPUT, double, SH_ATTRIB> ShInputAttrib1d;
typedef ShAttrib<1, SH_OUTPUT, double, SH_ATTRIB> ShOutputAttrib1d;
typedef ShAttrib<1, SH_INOUT, double, SH_ATTRIB> ShInOutAttrib1d;
typedef ShAttrib<1, SH_TEMP, double, SH_ATTRIB> ShAttrib1d;
typedef ShAttrib<1, SH_CONST, double, SH_ATTRIB> ShConstAttrib1d;
typedef ShAttrib<2, SH_INPUT, double, SH_ATTRIB> ShInputAttrib2d;
typedef ShAttrib<2, SH_OUTPUT, double, SH_ATTRIB> ShOutputAttrib2d;
typedef ShAttrib<2, SH_INOUT, double, SH_ATTRIB> ShInOutAttrib2d;
typedef ShAttrib<2, SH_TEMP, double, SH_ATTRIB> ShAttrib2d;
typedef ShAttrib<2, SH_CONST, double, SH_ATTRIB> ShConstAttrib2d;
typedef ShAttrib<3, SH_INPUT, double, SH_ATTRIB> ShInputAttrib3d;
typedef ShAttrib<3, SH_OUTPUT, double, SH_ATTRIB> ShOutputAttrib3d;
typedef ShAttrib<3, SH_INOUT, double, SH_ATTRIB> ShInOutAttrib3d;
typedef ShAttrib<3, SH_TEMP, double, SH_ATTRIB> ShAttrib3d;
typedef ShAttrib<3, SH_CONST, double, SH_ATTRIB> ShConstAttrib3d;
typedef ShAttrib<4, SH_INPUT, double, SH_ATTRIB> ShInputAttrib4d;
typedef ShAttrib<4, SH_OUTPUT, double, SH_ATTRIB> ShOutputAttrib4d;
typedef ShAttrib<4, SH_INOUT, double, SH_ATTRIB> ShInOutAttrib4d;
typedef ShAttrib<4, SH_TEMP, double, SH_ATTRIB> ShAttrib4d;
typedef ShAttrib<4, SH_CONST, double, SH_ATTRIB> ShConstAttrib4d;


typedef ShAttrib<1, SH_INPUT, unsigned char, SH_ATTRIB> ShInputAttrib1ub;
typedef ShAttrib<1, SH_OUTPUT, unsigned char, SH_ATTRIB> ShOutputAttrib1ub;
typedef ShAttrib<1, SH_INOUT, unsigned char, SH_ATTRIB> ShInOutAttrib1ub;
typedef ShAttrib<1, SH_TEMP, unsigned char, SH_ATTRIB> ShAttrib1ub;
typedef ShAttrib<1, SH_CONST, unsigned char, SH_ATTRIB> ShConstAttrib1ub;
typedef ShAttrib<2, SH_INPUT, unsigned char, SH_ATTRIB> ShInputAttrib2ub;
typedef ShAttrib<2, SH_OUTPUT, unsigned char, SH_ATTRIB> ShOutputAttrib2ub;
typedef ShAttrib<2, SH_INOUT, unsigned char, SH_ATTRIB> ShInOutAttrib2ub;
typedef ShAttrib<2, SH_TEMP, unsigned char, SH_ATTRIB> ShAttrib2ub;
typedef ShAttrib<2, SH_CONST, unsigned char, SH_ATTRIB> ShConstAttrib2ub;
typedef ShAttrib<3, SH_INPUT, unsigned char, SH_ATTRIB> ShInputAttrib3ub;
typedef ShAttrib<3, SH_OUTPUT, unsigned char, SH_ATTRIB> ShOutputAttrib3ub;
typedef ShAttrib<3, SH_INOUT, unsigned char, SH_ATTRIB> ShInOutAttrib3ub;
typedef ShAttrib<3, SH_TEMP, unsigned char, SH_ATTRIB> ShAttrib3ub;
typedef ShAttrib<3, SH_CONST, unsigned char, SH_ATTRIB> ShConstAttrib3ub;
typedef ShAttrib<4, SH_INPUT, unsigned char, SH_ATTRIB> ShInputAttrib4ub;
typedef ShAttrib<4, SH_OUTPUT, unsigned char, SH_ATTRIB> ShOutputAttrib4ub;
typedef ShAttrib<4, SH_INOUT, unsigned char, SH_ATTRIB> ShInOutAttrib4ub;
typedef ShAttrib<4, SH_TEMP, unsigned char, SH_ATTRIB> ShAttrib4ub;
typedef ShAttrib<4, SH_CONST, unsigned char, SH_ATTRIB> ShConstAttrib4ub;


typedef ShAttrib<1, SH_INPUT, float, SH_ATTRIB> ShInputAttrib1f;
typedef ShAttrib<1, SH_OUTPUT, float, SH_ATTRIB> ShOutputAttrib1f;
typedef ShAttrib<1, SH_INOUT, float, SH_ATTRIB> ShInOutAttrib1f;
typedef ShAttrib<1, SH_TEMP, float, SH_ATTRIB> ShAttrib1f;
typedef ShAttrib<1, SH_CONST, float, SH_ATTRIB> ShConstAttrib1f;
typedef ShAttrib<2, SH_INPUT, float, SH_ATTRIB> ShInputAttrib2f;
typedef ShAttrib<2, SH_OUTPUT, float, SH_ATTRIB> ShOutputAttrib2f;
typedef ShAttrib<2, SH_INOUT, float, SH_ATTRIB> ShInOutAttrib2f;
typedef ShAttrib<2, SH_TEMP, float, SH_ATTRIB> ShAttrib2f;
typedef ShAttrib<2, SH_CONST, float, SH_ATTRIB> ShConstAttrib2f;
typedef ShAttrib<3, SH_INPUT, float, SH_ATTRIB> ShInputAttrib3f;
typedef ShAttrib<3, SH_OUTPUT, float, SH_ATTRIB> ShOutputAttrib3f;
typedef ShAttrib<3, SH_INOUT, float, SH_ATTRIB> ShInOutAttrib3f;
typedef ShAttrib<3, SH_TEMP, float, SH_ATTRIB> ShAttrib3f;
typedef ShAttrib<3, SH_CONST, float, SH_ATTRIB> ShConstAttrib3f;
typedef ShAttrib<4, SH_INPUT, float, SH_ATTRIB> ShInputAttrib4f;
typedef ShAttrib<4, SH_OUTPUT, float, SH_ATTRIB> ShOutputAttrib4f;
typedef ShAttrib<4, SH_INOUT, float, SH_ATTRIB> ShInOutAttrib4f;
typedef ShAttrib<4, SH_TEMP, float, SH_ATTRIB> ShAttrib4f;
typedef ShAttrib<4, SH_CONST, float, SH_ATTRIB> ShConstAttrib4f;


typedef ShAttrib<1, SH_INPUT, char, SH_ATTRIB> ShInputAttrib1b;
typedef ShAttrib<1, SH_OUTPUT, char, SH_ATTRIB> ShOutputAttrib1b;
typedef ShAttrib<1, SH_INOUT, char, SH_ATTRIB> ShInOutAttrib1b;
typedef ShAttrib<1, SH_TEMP, char, SH_ATTRIB> ShAttrib1b;
typedef ShAttrib<1, SH_CONST, char, SH_ATTRIB> ShConstAttrib1b;
typedef ShAttrib<2, SH_INPUT, char, SH_ATTRIB> ShInputAttrib2b;
typedef ShAttrib<2, SH_OUTPUT, char, SH_ATTRIB> ShOutputAttrib2b;
typedef ShAttrib<2, SH_INOUT, char, SH_ATTRIB> ShInOutAttrib2b;
typedef ShAttrib<2, SH_TEMP, char, SH_ATTRIB> ShAttrib2b;
typedef ShAttrib<2, SH_CONST, char, SH_ATTRIB> ShConstAttrib2b;
typedef ShAttrib<3, SH_INPUT, char, SH_ATTRIB> ShInputAttrib3b;
typedef ShAttrib<3, SH_OUTPUT, char, SH_ATTRIB> ShOutputAttrib3b;
typedef ShAttrib<3, SH_INOUT, char, SH_ATTRIB> ShInOutAttrib3b;
typedef ShAttrib<3, SH_TEMP, char, SH_ATTRIB> ShAttrib3b;
typedef ShAttrib<3, SH_CONST, char, SH_ATTRIB> ShConstAttrib3b;
typedef ShAttrib<4, SH_INPUT, char, SH_ATTRIB> ShInputAttrib4b;
typedef ShAttrib<4, SH_OUTPUT, char, SH_ATTRIB> ShOutputAttrib4b;
typedef ShAttrib<4, SH_INOUT, char, SH_ATTRIB> ShInOutAttrib4b;
typedef ShAttrib<4, SH_TEMP, char, SH_ATTRIB> ShAttrib4b;
typedef ShAttrib<4, SH_CONST, char, SH_ATTRIB> ShConstAttrib4b;


typedef ShAttrib<1, SH_INPUT, unsigned short, SH_ATTRIB> ShInputAttrib1us;
typedef ShAttrib<1, SH_OUTPUT, unsigned short, SH_ATTRIB> ShOutputAttrib1us;
typedef ShAttrib<1, SH_INOUT, unsigned short, SH_ATTRIB> ShInOutAttrib1us;
typedef ShAttrib<1, SH_TEMP, unsigned short, SH_ATTRIB> ShAttrib1us;
typedef ShAttrib<1, SH_CONST, unsigned short, SH_ATTRIB> ShConstAttrib1us;
typedef ShAttrib<2, SH_INPUT, unsigned short, SH_ATTRIB> ShInputAttrib2us;
typedef ShAttrib<2, SH_OUTPUT, unsigned short, SH_ATTRIB> ShOutputAttrib2us;
typedef ShAttrib<2, SH_INOUT, unsigned short, SH_ATTRIB> ShInOutAttrib2us;
typedef ShAttrib<2, SH_TEMP, unsigned short, SH_ATTRIB> ShAttrib2us;
typedef ShAttrib<2, SH_CONST, unsigned short, SH_ATTRIB> ShConstAttrib2us;
typedef ShAttrib<3, SH_INPUT, unsigned short, SH_ATTRIB> ShInputAttrib3us;
typedef ShAttrib<3, SH_OUTPUT, unsigned short, SH_ATTRIB> ShOutputAttrib3us;
typedef ShAttrib<3, SH_INOUT, unsigned short, SH_ATTRIB> ShInOutAttrib3us;
typedef ShAttrib<3, SH_TEMP, unsigned short, SH_ATTRIB> ShAttrib3us;
typedef ShAttrib<3, SH_CONST, unsigned short, SH_ATTRIB> ShConstAttrib3us;
typedef ShAttrib<4, SH_INPUT, unsigned short, SH_ATTRIB> ShInputAttrib4us;
typedef ShAttrib<4, SH_OUTPUT, unsigned short, SH_ATTRIB> ShOutputAttrib4us;
typedef ShAttrib<4, SH_INOUT, unsigned short, SH_ATTRIB> ShInOutAttrib4us;
typedef ShAttrib<4, SH_TEMP, unsigned short, SH_ATTRIB> ShAttrib4us;
typedef ShAttrib<4, SH_CONST, unsigned short, SH_ATTRIB> ShConstAttrib4us;


typedef ShAttrib<1, SH_INPUT, ShFracUByte, SH_ATTRIB> ShInputAttrib1fub;
typedef ShAttrib<1, SH_OUTPUT, ShFracUByte, SH_ATTRIB> ShOutputAttrib1fub;
typedef ShAttrib<1, SH_INOUT, ShFracUByte, SH_ATTRIB> ShInOutAttrib1fub;
typedef ShAttrib<1, SH_TEMP, ShFracUByte, SH_ATTRIB> ShAttrib1fub;
typedef ShAttrib<1, SH_CONST, ShFracUByte, SH_ATTRIB> ShConstAttrib1fub;
typedef ShAttrib<2, SH_INPUT, ShFracUByte, SH_ATTRIB> ShInputAttrib2fub;
typedef ShAttrib<2, SH_OUTPUT, ShFracUByte, SH_ATTRIB> ShOutputAttrib2fub;
typedef ShAttrib<2, SH_INOUT, ShFracUByte, SH_ATTRIB> ShInOutAttrib2fub;
typedef ShAttrib<2, SH_TEMP, ShFracUByte, SH_ATTRIB> ShAttrib2fub;
typedef ShAttrib<2, SH_CONST, ShFracUByte, SH_ATTRIB> ShConstAttrib2fub;
typedef ShAttrib<3, SH_INPUT, ShFracUByte, SH_ATTRIB> ShInputAttrib3fub;
typedef ShAttrib<3, SH_OUTPUT, ShFracUByte, SH_ATTRIB> ShOutputAttrib3fub;
typedef ShAttrib<3, SH_INOUT, ShFracUByte, SH_ATTRIB> ShInOutAttrib3fub;
typedef ShAttrib<3, SH_TEMP, ShFracUByte, SH_ATTRIB> ShAttrib3fub;
typedef ShAttrib<3, SH_CONST, ShFracUByte, SH_ATTRIB> ShConstAttrib3fub;
typedef ShAttrib<4, SH_INPUT, ShFracUByte, SH_ATTRIB> ShInputAttrib4fub;
typedef ShAttrib<4, SH_OUTPUT, ShFracUByte, SH_ATTRIB> ShOutputAttrib4fub;
typedef ShAttrib<4, SH_INOUT, ShFracUByte, SH_ATTRIB> ShInOutAttrib4fub;
typedef ShAttrib<4, SH_TEMP, ShFracUByte, SH_ATTRIB> ShAttrib4fub;
typedef ShAttrib<4, SH_CONST, ShFracUByte, SH_ATTRIB> ShConstAttrib4fub;


typedef ShAttrib<1, SH_INPUT, ShHalf, SH_ATTRIB> ShInputAttrib1h;
typedef ShAttrib<1, SH_OUTPUT, ShHalf, SH_ATTRIB> ShOutputAttrib1h;
typedef ShAttrib<1, SH_INOUT, ShHalf, SH_ATTRIB> ShInOutAttrib1h;
typedef ShAttrib<1, SH_TEMP, ShHalf, SH_ATTRIB> ShAttrib1h;
typedef ShAttrib<1, SH_CONST, ShHalf, SH_ATTRIB> ShConstAttrib1h;
typedef ShAttrib<2, SH_INPUT, ShHalf, SH_ATTRIB> ShInputAttrib2h;
typedef ShAttrib<2, SH_OUTPUT, ShHalf, SH_ATTRIB> ShOutputAttrib2h;
typedef ShAttrib<2, SH_INOUT, ShHalf, SH_ATTRIB> ShInOutAttrib2h;
typedef ShAttrib<2, SH_TEMP, ShHalf, SH_ATTRIB> ShAttrib2h;
typedef ShAttrib<2, SH_CONST, ShHalf, SH_ATTRIB> ShConstAttrib2h;
typedef ShAttrib<3, SH_INPUT, ShHalf, SH_ATTRIB> ShInputAttrib3h;
typedef ShAttrib<3, SH_OUTPUT, ShHalf, SH_ATTRIB> ShOutputAttrib3h;
typedef ShAttrib<3, SH_INOUT, ShHalf, SH_ATTRIB> ShInOutAttrib3h;
typedef ShAttrib<3, SH_TEMP, ShHalf, SH_ATTRIB> ShAttrib3h;
typedef ShAttrib<3, SH_CONST, ShHalf, SH_ATTRIB> ShConstAttrib3h;
typedef ShAttrib<4, SH_INPUT, ShHalf, SH_ATTRIB> ShInputAttrib4h;
typedef ShAttrib<4, SH_OUTPUT, ShHalf, SH_ATTRIB> ShOutputAttrib4h;
typedef ShAttrib<4, SH_INOUT, ShHalf, SH_ATTRIB> ShInOutAttrib4h;
typedef ShAttrib<4, SH_TEMP, ShHalf, SH_ATTRIB> ShAttrib4h;
typedef ShAttrib<4, SH_CONST, ShHalf, SH_ATTRIB> ShConstAttrib4h;


typedef ShAttrib<1, SH_INPUT, ShFracShort, SH_ATTRIB> ShInputAttrib1fs;
typedef ShAttrib<1, SH_OUTPUT, ShFracShort, SH_ATTRIB> ShOutputAttrib1fs;
typedef ShAttrib<1, SH_INOUT, ShFracShort, SH_ATTRIB> ShInOutAttrib1fs;
typedef ShAttrib<1, SH_TEMP, ShFracShort, SH_ATTRIB> ShAttrib1fs;
typedef ShAttrib<1, SH_CONST, ShFracShort, SH_ATTRIB> ShConstAttrib1fs;
typedef ShAttrib<2, SH_INPUT, ShFracShort, SH_ATTRIB> ShInputAttrib2fs;
typedef ShAttrib<2, SH_OUTPUT, ShFracShort, SH_ATTRIB> ShOutputAttrib2fs;
typedef ShAttrib<2, SH_INOUT, ShFracShort, SH_ATTRIB> ShInOutAttrib2fs;
typedef ShAttrib<2, SH_TEMP, ShFracShort, SH_ATTRIB> ShAttrib2fs;
typedef ShAttrib<2, SH_CONST, ShFracShort, SH_ATTRIB> ShConstAttrib2fs;
typedef ShAttrib<3, SH_INPUT, ShFracShort, SH_ATTRIB> ShInputAttrib3fs;
typedef ShAttrib<3, SH_OUTPUT, ShFracShort, SH_ATTRIB> ShOutputAttrib3fs;
typedef ShAttrib<3, SH_INOUT, ShFracShort, SH_ATTRIB> ShInOutAttrib3fs;
typedef ShAttrib<3, SH_TEMP, ShFracShort, SH_ATTRIB> ShAttrib3fs;
typedef ShAttrib<3, SH_CONST, ShFracShort, SH_ATTRIB> ShConstAttrib3fs;
typedef ShAttrib<4, SH_INPUT, ShFracShort, SH_ATTRIB> ShInputAttrib4fs;
typedef ShAttrib<4, SH_OUTPUT, ShFracShort, SH_ATTRIB> ShOutputAttrib4fs;
typedef ShAttrib<4, SH_INOUT, ShFracShort, SH_ATTRIB> ShInOutAttrib4fs;
typedef ShAttrib<4, SH_TEMP, ShFracShort, SH_ATTRIB> ShAttrib4fs;
typedef ShAttrib<4, SH_CONST, ShFracShort, SH_ATTRIB> ShConstAttrib4fs;


typedef ShAttrib<1, SH_INPUT, ShFracInt, SH_ATTRIB> ShInputAttrib1fi;
typedef ShAttrib<1, SH_OUTPUT, ShFracInt, SH_ATTRIB> ShOutputAttrib1fi;
typedef ShAttrib<1, SH_INOUT, ShFracInt, SH_ATTRIB> ShInOutAttrib1fi;
typedef ShAttrib<1, SH_TEMP, ShFracInt, SH_ATTRIB> ShAttrib1fi;
typedef ShAttrib<1, SH_CONST, ShFracInt, SH_ATTRIB> ShConstAttrib1fi;
typedef ShAttrib<2, SH_INPUT, ShFracInt, SH_ATTRIB> ShInputAttrib2fi;
typedef ShAttrib<2, SH_OUTPUT, ShFracInt, SH_ATTRIB> ShOutputAttrib2fi;
typedef ShAttrib<2, SH_INOUT, ShFracInt, SH_ATTRIB> ShInOutAttrib2fi;
typedef ShAttrib<2, SH_TEMP, ShFracInt, SH_ATTRIB> ShAttrib2fi;
typedef ShAttrib<2, SH_CONST, ShFracInt, SH_ATTRIB> ShConstAttrib2fi;
typedef ShAttrib<3, SH_INPUT, ShFracInt, SH_ATTRIB> ShInputAttrib3fi;
typedef ShAttrib<3, SH_OUTPUT, ShFracInt, SH_ATTRIB> ShOutputAttrib3fi;
typedef ShAttrib<3, SH_INOUT, ShFracInt, SH_ATTRIB> ShInOutAttrib3fi;
typedef ShAttrib<3, SH_TEMP, ShFracInt, SH_ATTRIB> ShAttrib3fi;
typedef ShAttrib<3, SH_CONST, ShFracInt, SH_ATTRIB> ShConstAttrib3fi;
typedef ShAttrib<4, SH_INPUT, ShFracInt, SH_ATTRIB> ShInputAttrib4fi;
typedef ShAttrib<4, SH_OUTPUT, ShFracInt, SH_ATTRIB> ShOutputAttrib4fi;
typedef ShAttrib<4, SH_INOUT, ShFracInt, SH_ATTRIB> ShInOutAttrib4fi;
typedef ShAttrib<4, SH_TEMP, ShFracInt, SH_ATTRIB> ShAttrib4fi;
typedef ShAttrib<4, SH_CONST, ShFracInt, SH_ATTRIB> ShConstAttrib4fi;


typedef ShAttrib<1, SH_INPUT, unsigned int, SH_ATTRIB> ShInputAttrib1ui;
typedef ShAttrib<1, SH_OUTPUT, unsigned int, SH_ATTRIB> ShOutputAttrib1ui;
typedef ShAttrib<1, SH_INOUT, unsigned int, SH_ATTRIB> ShInOutAttrib1ui;
typedef ShAttrib<1, SH_TEMP, unsigned int, SH_ATTRIB> ShAttrib1ui;
typedef ShAttrib<1, SH_CONST, unsigned int, SH_ATTRIB> ShConstAttrib1ui;
typedef ShAttrib<2, SH_INPUT, unsigned int, SH_ATTRIB> ShInputAttrib2ui;
typedef ShAttrib<2, SH_OUTPUT, unsigned int, SH_ATTRIB> ShOutputAttrib2ui;
typedef ShAttrib<2, SH_INOUT, unsigned int, SH_ATTRIB> ShInOutAttrib2ui;
typedef ShAttrib<2, SH_TEMP, unsigned int, SH_ATTRIB> ShAttrib2ui;
typedef ShAttrib<2, SH_CONST, unsigned int, SH_ATTRIB> ShConstAttrib2ui;
typedef ShAttrib<3, SH_INPUT, unsigned int, SH_ATTRIB> ShInputAttrib3ui;
typedef ShAttrib<3, SH_OUTPUT, unsigned int, SH_ATTRIB> ShOutputAttrib3ui;
typedef ShAttrib<3, SH_INOUT, unsigned int, SH_ATTRIB> ShInOutAttrib3ui;
typedef ShAttrib<3, SH_TEMP, unsigned int, SH_ATTRIB> ShAttrib3ui;
typedef ShAttrib<3, SH_CONST, unsigned int, SH_ATTRIB> ShConstAttrib3ui;
typedef ShAttrib<4, SH_INPUT, unsigned int, SH_ATTRIB> ShInputAttrib4ui;
typedef ShAttrib<4, SH_OUTPUT, unsigned int, SH_ATTRIB> ShOutputAttrib4ui;
typedef ShAttrib<4, SH_INOUT, unsigned int, SH_ATTRIB> ShInOutAttrib4ui;
typedef ShAttrib<4, SH_TEMP, unsigned int, SH_ATTRIB> ShAttrib4ui;
typedef ShAttrib<4, SH_CONST, unsigned int, SH_ATTRIB> ShConstAttrib4ui;



} // namespace SH
#include "ShGenericImpl.hpp"
#include "ShAttribImpl.hpp"

#endif // SH_SHATTRIB_HPP
