// Sh: A GPU metaprogramming language.
//
// Copyright 2003-2006 Serious Hack Inc.
// 
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
// MA  02110-1301, USA
//////////////////////////////////////////////////////////////////////////////
#ifndef SH_HPP
#define SH_HPP

#include "ShDllExport.hpp"
#include "ShException.hpp"
#include "ShContext.hpp"
#include "ShProgramNode.hpp"
#include "ShProgramSet.hpp"
#include "ShProgram.hpp"
#include "ShSyntax.hpp"
#include "ShHalf.hpp"
#include "ShFraction.hpp"
#include "ShAttrib.hpp"
#include "ShMatrix.hpp"
#include "ShVector.hpp"
#include "ShPoint.hpp"
#include "ShColor.hpp"
#include "ShTexCoord.hpp"
#include "ShNormal.hpp"
#include "ShPosition.hpp"
#include "ShLib.hpp"
#include "ShLibAttrib.hpp"
#include "ShLibVector.hpp"
#include "ShLibPoint.hpp"
#include "ShLibColor.hpp"
#include "ShLibTexCoord.hpp"
#include "ShLibNormal.hpp"
#include "ShLibPosition.hpp"
#include "ShMemory.hpp"
#include "ShArray.hpp"
#include "ShTable.hpp"
#include "ShTexture.hpp"
#include "ShWrap.hpp"
#include "ShInterp.hpp"
#include "ShMIPFilter.hpp"
#include "ShBackend.hpp"
#include "ShImage.hpp"
#include "ShImage3D.hpp"
#include "ShAlgebra.hpp"
#include "ShNibbles.hpp"
#include "ShManipulator.hpp"
#include "ShFixedManipulator.hpp"
#include "ShChannelNode.hpp"
#include "ShChannel.hpp"
#include "ShStream.hpp"
#include "ShRecord.hpp"
#include "ShQuaternion.hpp"
#include "ShVariant.hpp"
#include "ShTypeInfo.hpp"
#include "ShMemoryDep.hpp"
#include "ShPalette.hpp"

/** \namespace SH
 * \brief The main Sh namespace.
 *
 * All Sh classes, functions and objects reside within this namespace.
 */

/** \file sh.hpp
 * \brief The main Sh include file.
 * You should only have to include this file to use Sh.
 */


#endif
