#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram abs_a_f_4f_callabs_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = abs(a);
  } SH_END;

  abs_a_f_4f_callabs_test0.name("abs_a_f_4f_callabs_test0");
  last_test = "abs_a_f_4f_callabs_test0";
  {  // f_4f_callabs_test0
    ShAttrib<4, SH_CONST, float> a(float(-8.0), float(-8.9), float(-8.5), float(-8.1));
    ShAttrib<4, SH_CONST, float> expected(float(8.0), float(8.9), float(8.5), float(8.1));

    try {
      if (test.run(abs_a_f_4f_callabs_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram abs_a_f_4f_callabs_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = abs(a);
  } SH_END;

  abs_a_f_4f_callabs_test1.name("abs_a_f_4f_callabs_test1");
  last_test = "abs_a_f_4f_callabs_test1";
  {  // f_4f_callabs_test1
    ShAttrib<4, SH_CONST, float> a(float(-0.0), float(-0.5), float(0.0), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.5), float(0.0), float(0.5));

    try {
      if (test.run(abs_a_f_4f_callabs_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram abs_a_f_4f_callabs_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = abs(a);
  } SH_END;

  abs_a_f_4f_callabs_test2.name("abs_a_f_4f_callabs_test2");
  last_test = "abs_a_f_4f_callabs_test2";
  {  // f_4f_callabs_test2
    ShAttrib<4, SH_CONST, float> a(float(8.0), float(8.9), float(8.5), float(8.1));
    ShAttrib<4, SH_CONST, float> expected(float(8.0), float(8.9), float(8.5), float(8.1));

    try {
      if (test.run(abs_a_f_4f_callabs_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram abs_a_i_4i_callabs_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = abs(a);
  } SH_END;

  abs_a_i_4i_callabs_test3.name("abs_a_i_4i_callabs_test3");
  last_test = "abs_a_i_4i_callabs_test3";
  {  // i_4i_callabs_test3
    ShAttrib<4, SH_CONST, int> a(int(-8.0), int(-7.0), int(-9.0), int(-6.0));
    ShAttrib<4, SH_CONST, int> expected(int(8.0), int(7.0), int(9.0), int(6.0));

    try {
      if (test.run(abs_a_i_4i_callabs_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram abs_a_i_4i_callabs_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = abs(a);
  } SH_END;

  abs_a_i_4i_callabs_test4.name("abs_a_i_4i_callabs_test4");
  last_test = "abs_a_i_4i_callabs_test4";
  {  // i_4i_callabs_test4
    ShAttrib<4, SH_CONST, int> a(int(-0.0), int(-1.0), int(0.0), int(1.0));
    ShAttrib<4, SH_CONST, int> expected(int(0.0), int(1.0), int(0.0), int(1.0));

    try {
      if (test.run(abs_a_i_4i_callabs_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram abs_a_i_4i_callabs_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = abs(a);
  } SH_END;

  abs_a_i_4i_callabs_test5.name("abs_a_i_4i_callabs_test5");
  last_test = "abs_a_i_4i_callabs_test5";
  {  // i_4i_callabs_test5
    ShAttrib<4, SH_CONST, int> a(int(8.0), int(7.0), int(9.0), int(6.0));
    ShAttrib<4, SH_CONST, int> expected(int(8.0), int(7.0), int(9.0), int(6.0));

    try {
      if (test.run(abs_a_i_4i_callabs_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_callabs_test0
    last_test = "f_4f_callabs_test0";
    ShAttrib<4, SH_CONST, float> a(float(-8.0), float(-8.9), float(-8.5), float(-8.1));
    ShAttrib<4, SH_CONST, float> expected(float(8.0), float(8.9), float(8.5), float(8.1));

    ShAttrib<4, SH_TEMP, float> out;
    out = abs(a);

    try {
      if (test.check("f_4f_callabs_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callabs_test1
    last_test = "f_4f_callabs_test1";
    ShAttrib<4, SH_CONST, float> a(float(-0.0), float(-0.5), float(0.0), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.5), float(0.0), float(0.5));

    ShAttrib<4, SH_TEMP, float> out;
    out = abs(a);

    try {
      if (test.check("f_4f_callabs_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callabs_test2
    last_test = "f_4f_callabs_test2";
    ShAttrib<4, SH_CONST, float> a(float(8.0), float(8.9), float(8.5), float(8.1));
    ShAttrib<4, SH_CONST, float> expected(float(8.0), float(8.9), float(8.5), float(8.1));

    ShAttrib<4, SH_TEMP, float> out;
    out = abs(a);

    try {
      if (test.check("f_4f_callabs_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callabs_test3
    last_test = "i_4i_callabs_test3";
    ShAttrib<4, SH_CONST, int> a(int(-8.0), int(-7.0), int(-9.0), int(-6.0));
    ShAttrib<4, SH_CONST, int> expected(int(8.0), int(7.0), int(9.0), int(6.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = abs(a);

    try {
      if (test.check("i_4i_callabs_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callabs_test4
    last_test = "i_4i_callabs_test4";
    ShAttrib<4, SH_CONST, int> a(int(-0.0), int(-1.0), int(0.0), int(1.0));
    ShAttrib<4, SH_CONST, int> expected(int(0.0), int(1.0), int(0.0), int(1.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = abs(a);

    try {
      if (test.check("i_4i_callabs_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_callabs_test5
    last_test = "i_4i_callabs_test5";
    ShAttrib<4, SH_CONST, int> a(int(8.0), int(7.0), int(9.0), int(6.0));
    ShAttrib<4, SH_CONST, int> expected(int(8.0), int(7.0), int(9.0), int(6.0));

    ShAttrib<4, SH_TEMP, int> out;
    out = abs(a);

    try {
      if (test.check("i_4i_callabs_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

