#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram ceil_a_f_4f_callceil_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = ceil(a);
  } SH_END;

  ceil_a_f_4f_callceil_test0.name("ceil_a_f_4f_callceil_test0");
  last_test = "ceil_a_f_4f_callceil_test0";
  {  // f_4f_callceil_test0
    ShAttrib<4, SH_CONST, float> a(float(3.0), float(3.1), float(3.5), float(3.9));
    ShAttrib<4, SH_CONST, float> expected(float(3.0), float(4.0), float(4.0), float(4.0));

    try {
      if (test.run(ceil_a_f_4f_callceil_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ceil_a_f_4f_callceil_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = ceil(a);
  } SH_END;

  ceil_a_f_4f_callceil_test1.name("ceil_a_f_4f_callceil_test1");
  last_test = "ceil_a_f_4f_callceil_test1";
  {  // f_4f_callceil_test1
    ShAttrib<4, SH_CONST, float> a(float(-3.0), float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<4, SH_CONST, float> expected(float(-3.0), float(-3.0), float(-3.0), float(-3.0));

    try {
      if (test.run(ceil_a_f_4f_callceil_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_callceil_test0
    last_test = "f_4f_callceil_test0";
    ShAttrib<4, SH_CONST, float> a(float(3.0), float(3.1), float(3.5), float(3.9));
    ShAttrib<4, SH_CONST, float> expected(float(3.0), float(4.0), float(4.0), float(4.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = ceil(a);

    try {
      if (test.check("f_4f_callceil_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callceil_test1
    last_test = "f_4f_callceil_test1";
    ShAttrib<4, SH_CONST, float> a(float(-3.0), float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<4, SH_CONST, float> expected(float(-3.0), float(-3.0), float(-3.0), float(-3.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = ceil(a);

    try {
      if (test.check("f_4f_callceil_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

