#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram clamp_a_f_4f_4f_4f_callclamp_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = clamp(a, b, c);
  } SH_END;

  clamp_a_f_4f_4f_4f_callclamp_test0.name("clamp_a_f_4f_4f_4f_callclamp_test0");
  last_test = "clamp_a_f_4f_4f_4f_callclamp_test0";
  {  // f_4f_4f_4f_callclamp_test0
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.5), float(1.0), float(1.5));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> c(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.5), float(1.0), float(1.0));

    try {
      if (test.run(clamp_a_f_4f_4f_4f_callclamp_test0, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram clamp_a_f_4f_4f_4f_callclamp_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = clamp(a, b, c);
  } SH_END;

  clamp_a_f_4f_4f_4f_callclamp_test1.name("clamp_a_f_4f_4f_4f_callclamp_test1");
  last_test = "clamp_a_f_4f_4f_4f_callclamp_test1";
  {  // f_4f_4f_4f_callclamp_test1
    ShAttrib<4, SH_CONST, float> a(float(-5.2), float(-1.0), float(-0.5), float(-0.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> c(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(clamp_a_f_4f_4f_4f_callclamp_test1, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram clamp_a_f_4f_4f_4f_callclamp_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = clamp(a, b, c);
  } SH_END;

  clamp_a_f_4f_4f_4f_callclamp_test2.name("clamp_a_f_4f_4f_4f_callclamp_test2");
  last_test = "clamp_a_f_4f_4f_4f_callclamp_test2";
  {  // f_4f_4f_4f_callclamp_test2
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.1), float(5.0), float(100));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> c(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    try {
      if (test.run(clamp_a_f_4f_4f_4f_callclamp_test2, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram clamp_a_f_4f_4f_4f_callclamp_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = clamp(a, b, c);
  } SH_END;

  clamp_a_f_4f_4f_4f_callclamp_test3.name("clamp_a_f_4f_4f_4f_callclamp_test3");
  last_test = "clamp_a_f_4f_4f_4f_callclamp_test3";
  {  // f_4f_4f_4f_callclamp_test3
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.5), float(1.0), float(1.5));
    ShAttrib<4, SH_CONST, float> b(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> c(float(1.2), float(1.2), float(1.2), float(1.2));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.2));

    try {
      if (test.run(clamp_a_f_4f_4f_4f_callclamp_test3, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram clamp_a_f_4f_4f_4f_callclamp_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = clamp(a, b, c);
  } SH_END;

  clamp_a_f_4f_4f_4f_callclamp_test4.name("clamp_a_f_4f_4f_4f_callclamp_test4");
  last_test = "clamp_a_f_4f_4f_4f_callclamp_test4";
  {  // f_4f_4f_4f_callclamp_test4
    ShAttrib<4, SH_CONST, float> a(float(-5.2), float(-1.0), float(-0.5), float(-0.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.5), float(-0.5), float(-0.5), float(-0.5));
    ShAttrib<4, SH_CONST, float> c(float(-0.4), float(-0.4), float(-0.4), float(-0.4));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(-0.5), float(-0.5), float(-0.4));

    try {
      if (test.run(clamp_a_f_4f_4f_4f_callclamp_test4, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram clamp_a_f_4f_4f_4f_callclamp_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = clamp(a, b, c);
  } SH_END;

  clamp_a_f_4f_4f_4f_callclamp_test5.name("clamp_a_f_4f_4f_4f_callclamp_test5");
  last_test = "clamp_a_f_4f_4f_4f_callclamp_test5";
  {  // f_4f_4f_4f_callclamp_test5
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.1), float(5.0), float(100));
    ShAttrib<4, SH_CONST, float> b(float(5.0), float(5.0), float(5.0), float(5.0));
    ShAttrib<4, SH_CONST, float> c(float(10.0), float(10.0), float(10.0), float(10.0));
    ShAttrib<4, SH_CONST, float> expected(float(5.0), float(5.0), float(5.0), float(10.0));

    try {
      if (test.run(clamp_a_f_4f_4f_4f_callclamp_test5, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram clamp_a_f_4f_f_f_callclamp_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = clamp(a, b, c);
  } SH_END;

  clamp_a_f_4f_f_f_callclamp_test6.name("clamp_a_f_4f_f_f_callclamp_test6");
  last_test = "clamp_a_f_4f_f_f_callclamp_test6";
  {  // f_4f_f_f_callclamp_test6
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(5.0), float(10), float(100));
    ShAttrib<1, SH_CONST, float> b(float(5.0));
    ShAttrib<1, SH_CONST, float> c(float(10.0));
    ShAttrib<4, SH_CONST, float> expected(float(5.0), float(5.0), float(10.0), float(10.0));

    try {
      if (test.run(clamp_a_f_4f_f_f_callclamp_test6, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pos_a_f_4f_callpos_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pos(a);
  } SH_END;

  pos_a_f_4f_callpos_test0.name("pos_a_f_4f_callpos_test0");
  last_test = "pos_a_f_4f_callpos_test0";
  {  // f_4f_callpos_test0
    ShAttrib<4, SH_CONST, float> a(float(3.0), float(3.1), float(3.5), float(3.9));
    ShAttrib<4, SH_CONST, float> expected(float(3.0), float(3.1), float(3.5), float(3.9));

    try {
      if (test.run(pos_a_f_4f_callpos_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pos_a_f_4f_callpos_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pos(a);
  } SH_END;

  pos_a_f_4f_callpos_test1.name("pos_a_f_4f_callpos_test1");
  last_test = "pos_a_f_4f_callpos_test1";
  {  // f_4f_callpos_test1
    ShAttrib<4, SH_CONST, float> a(float(-0.5), float(-0.0), float(0.5), float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0.5), float(1.0));

    try {
      if (test.run(pos_a_f_4f_callpos_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pos_a_f_4f_callpos_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pos(a);
  } SH_END;

  pos_a_f_4f_callpos_test2.name("pos_a_f_4f_callpos_test2");
  last_test = "pos_a_f_4f_callpos_test2";
  {  // f_4f_callpos_test2
    ShAttrib<4, SH_CONST, float> a(float(-3.0), float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0), float(0));

    try {
      if (test.run(pos_a_f_4f_callpos_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sat_a_f_4f_callsat_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sat(a);
  } SH_END;

  sat_a_f_4f_callsat_test0.name("sat_a_f_4f_callsat_test0");
  last_test = "sat_a_f_4f_callsat_test0";
  {  // f_4f_callsat_test0
    ShAttrib<4, SH_CONST, float> a(float(3.0), float(3.1), float(3.5), float(3.9));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(1), float(1));

    try {
      if (test.run(sat_a_f_4f_callsat_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sat_a_f_4f_callsat_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sat(a);
  } SH_END;

  sat_a_f_4f_callsat_test1.name("sat_a_f_4f_callsat_test1");
  last_test = "sat_a_f_4f_callsat_test1";
  {  // f_4f_callsat_test1
    ShAttrib<4, SH_CONST, float> a(float(-0.5), float(-0.0), float(0.5), float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(-0.0), float(0.5), float(1.0));

    try {
      if (test.run(sat_a_f_4f_callsat_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sat_a_f_4f_callsat_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sat(a);
  } SH_END;

  sat_a_f_4f_callsat_test2.name("sat_a_f_4f_callsat_test2");
  last_test = "sat_a_f_4f_callsat_test2";
  {  // f_4f_callsat_test2
    ShAttrib<4, SH_CONST, float> a(float(-3.0), float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<4, SH_CONST, float> expected(float(-3.0), float(-3.1), float(-3.5), float(-3.9));

    try {
      if (test.run(sat_a_f_4f_callsat_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_4f_4f_callclamp_test0
    last_test = "f_4f_4f_4f_callclamp_test0";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.5), float(1.0), float(1.5));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> c(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.5), float(1.0), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = clamp(a, b, c);

    try {
      if (test.check("f_4f_4f_4f_callclamp_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_4f_callclamp_test1
    last_test = "f_4f_4f_4f_callclamp_test1";
    ShAttrib<4, SH_CONST, float> a(float(-5.2), float(-1.0), float(-0.5), float(-0.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> c(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0), float(0.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = clamp(a, b, c);

    try {
      if (test.check("f_4f_4f_4f_callclamp_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_4f_callclamp_test2
    last_test = "f_4f_4f_4f_callclamp_test2";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.1), float(5.0), float(100));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> c(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = clamp(a, b, c);

    try {
      if (test.check("f_4f_4f_4f_callclamp_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_4f_callclamp_test3
    last_test = "f_4f_4f_4f_callclamp_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.5), float(1.0), float(1.5));
    ShAttrib<4, SH_CONST, float> b(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> c(float(1.2), float(1.2), float(1.2), float(1.2));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.2));

    ShAttrib<4, SH_TEMP, float> out;
    out = clamp(a, b, c);

    try {
      if (test.check("f_4f_4f_4f_callclamp_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_4f_callclamp_test4
    last_test = "f_4f_4f_4f_callclamp_test4";
    ShAttrib<4, SH_CONST, float> a(float(-5.2), float(-1.0), float(-0.5), float(-0.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.5), float(-0.5), float(-0.5), float(-0.5));
    ShAttrib<4, SH_CONST, float> c(float(-0.4), float(-0.4), float(-0.4), float(-0.4));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(-0.5), float(-0.5), float(-0.4));

    ShAttrib<4, SH_TEMP, float> out;
    out = clamp(a, b, c);

    try {
      if (test.check("f_4f_4f_4f_callclamp_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_4f_callclamp_test5
    last_test = "f_4f_4f_4f_callclamp_test5";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.1), float(5.0), float(100));
    ShAttrib<4, SH_CONST, float> b(float(5.0), float(5.0), float(5.0), float(5.0));
    ShAttrib<4, SH_CONST, float> c(float(10.0), float(10.0), float(10.0), float(10.0));
    ShAttrib<4, SH_CONST, float> expected(float(5.0), float(5.0), float(5.0), float(10.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = clamp(a, b, c);

    try {
      if (test.check("f_4f_4f_4f_callclamp_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_f_f_callclamp_test6
    last_test = "f_4f_f_f_callclamp_test6";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(5.0), float(10), float(100));
    ShAttrib<1, SH_CONST, float> b(float(5.0));
    ShAttrib<1, SH_CONST, float> c(float(10.0));
    ShAttrib<4, SH_CONST, float> expected(float(5.0), float(5.0), float(10.0), float(10.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = clamp(a, b, c);

    try {
      if (test.check("f_4f_f_f_callclamp_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callpos_test0
    last_test = "f_4f_callpos_test0";
    ShAttrib<4, SH_CONST, float> a(float(3.0), float(3.1), float(3.5), float(3.9));
    ShAttrib<4, SH_CONST, float> expected(float(3.0), float(3.1), float(3.5), float(3.9));

    ShAttrib<4, SH_TEMP, float> out;
    out = pos(a);

    try {
      if (test.check("f_4f_callpos_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callpos_test1
    last_test = "f_4f_callpos_test1";
    ShAttrib<4, SH_CONST, float> a(float(-0.5), float(-0.0), float(0.5), float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0.5), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pos(a);

    try {
      if (test.check("f_4f_callpos_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callpos_test2
    last_test = "f_4f_callpos_test2";
    ShAttrib<4, SH_CONST, float> a(float(-3.0), float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0), float(0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pos(a);

    try {
      if (test.check("f_4f_callpos_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsat_test0
    last_test = "f_4f_callsat_test0";
    ShAttrib<4, SH_CONST, float> a(float(3.0), float(3.1), float(3.5), float(3.9));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(1), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = sat(a);

    try {
      if (test.check("f_4f_callsat_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsat_test1
    last_test = "f_4f_callsat_test1";
    ShAttrib<4, SH_CONST, float> a(float(-0.5), float(-0.0), float(0.5), float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.5), float(-0.0), float(0.5), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = sat(a);

    try {
      if (test.check("f_4f_callsat_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsat_test2
    last_test = "f_4f_callsat_test2";
    ShAttrib<4, SH_CONST, float> a(float(-3.0), float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<4, SH_CONST, float> expected(float(-3.0), float(-3.1), float(-3.5), float(-3.9));

    ShAttrib<4, SH_TEMP, float> out;
    out = sat(a);

    try {
      if (test.check("f_4f_callsat_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

