#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram div_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a / b;
  } SH_END;

  div_a_f_3f_3f_infix_test0.name("div_a_f_3f_3f_infix_test0");
  last_test = "div_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.25), float(0.4));

    try {
      if (test.run(div_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_f_3f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a / b;
  } SH_END;

  div_a_f_3f_1f_infix_test1.name("div_a_f_3f_1f_infix_test1");
  last_test = "div_a_f_3f_1f_infix_test1";
  {  // f_3f_1f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.142857142857), float(0.285714285714), float(0.428571428571));

    try {
      if (test.run(div_a_f_3f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_f_1f_1f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a / b;
  } SH_END;

  div_a_f_1f_1f_infix_test2.name("div_a_f_1f_1f_infix_test2");
  last_test = "div_a_f_1f_1f_infix_test2";
  {  // f_1f_1f_infix_test2
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.142857142857));

    try {
      if (test.run(div_a_f_1f_1f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a / b;
  } SH_END;

  div_a_f_3f_3f_infix_test3.name("div_a_f_3f_3f_infix_test3");
  last_test = "div_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-1.0), float(-1.0));

    try {
      if (test.run(div_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_i_2s_2f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, short> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, int> out;
    out = a / b;
  } SH_END;

  div_a_i_2s_2f_infix_test4.name("div_a_i_2s_2f_infix_test4");
  last_test = "div_a_i_2s_2f_infix_test4";
  {  // i_2s_2f_infix_test4
    ShAttrib<2, SH_CONST, short> a(short(1), short(2));
    ShAttrib<2, SH_CONST, float> b(float(3), float(3));
    ShAttrib<2, SH_CONST, int> expected(int(0), int(0));

    try {
      if (test.run(div_a_i_2s_2f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_i_4i_4i_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = a / b;
  } SH_END;

  div_a_i_4i_4i_infix_test5.name("div_a_i_4i_4i_infix_test5");
  last_test = "div_a_i_4i_4i_infix_test5";
  {  // i_4i_4i_infix_test5
    ShAttrib<4, SH_CONST, int> a(int(0), int(1), int(2), int(3));
    ShAttrib<4, SH_CONST, int> b(int(4), int(4), int(4), int(4));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(0), int(0), int(0));

    try {
      if (test.run(div_a_i_4i_4i_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_i_3i_3i_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a / b;
  } SH_END;

  div_a_i_3i_3i_infix_test6.name("div_a_i_3i_3i_infix_test6");
  last_test = "div_a_i_3i_3i_infix_test6";
  {  // i_3i_3i_infix_test6
    ShAttrib<3, SH_CONST, int> a(int(5), int(6), int(7));
    ShAttrib<3, SH_CONST, int> b(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(div_a_i_3i_3i_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_i_4i_4i_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = a / b;
  } SH_END;

  div_a_i_4i_4i_infix_test7.name("div_a_i_4i_4i_infix_test7");
  last_test = "div_a_i_4i_4i_infix_test7";
  {  // i_4i_4i_infix_test7
    ShAttrib<4, SH_CONST, int> a(int(8), int(9), int(10), int(11));
    ShAttrib<4, SH_CONST, int> b(int(4), int(4), int(4), int(4));
    ShAttrib<4, SH_CONST, int> expected(int(2), int(2), int(2), int(2));

    try {
      if (test.run(div_a_i_4i_4i_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_f_2f_2f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = a / b;
  } SH_END;

  div_a_f_2f_2f_infix_test8.name("div_a_f_2f_2f_infix_test8");
  last_test = "div_a_f_2f_2f_infix_test8";
  {  // f_2f_2f_infix_test8
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<2, SH_CONST, float> b(float(3), float(3));
    ShAttrib<2, SH_CONST, float> expected(float(0.333333333333), float(0.666666666667));

    try {
      if (test.run(div_a_f_2f_2f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_s_2s_2f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, short> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, short> out;
    out = a / b;
  } SH_END;

  div_a_s_2s_2f_infix_test9.name("div_a_s_2s_2f_infix_test9");
  last_test = "div_a_s_2s_2f_infix_test9";
  {  // s_2s_2f_infix_test9
    ShAttrib<2, SH_CONST, short> a(short(1), short(2));
    ShAttrib<2, SH_CONST, float> b(float(3.0), float(3.0));
    ShAttrib<2, SH_CONST, short> expected(short(0.333333333333), short(0.666666666667));

    try {
      if (test.run(div_a_s_2s_2f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_i_3i_3i_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a / b;
  } SH_END;

  div_a_i_3i_3i_infix_test10.name("div_a_i_3i_3i_infix_test10");
  last_test = "div_a_i_3i_3i_infix_test10";
  {  // i_3i_3i_infix_test10
    ShAttrib<3, SH_CONST, int> a(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> b(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(div_a_i_3i_3i_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_f_3f_3f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a / b;
  } SH_END;

  div_a_f_3f_3f_infix_test11.name("div_a_f_3f_3f_infix_test11");
  last_test = "div_a_f_3f_3f_infix_test11";
  {  // f_3f_3f_infix_test11
    ShAttrib<3, SH_CONST, float> a(float(1), float(0.5), float(2));
    ShAttrib<3, SH_CONST, float> b(float(1), float(0.5), float(2));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1.0), float(1));

    try {
      if (test.run(div_a_f_3f_3f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_f_3f_3f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a / b;
  } SH_END;

  div_a_f_3f_3f_infix_test12.name("div_a_f_3f_3f_infix_test12");
  last_test = "div_a_f_3f_3f_infix_test12";
  {  // f_3f_3f_infix_test12
    ShAttrib<3, SH_CONST, float> a(float(64), float(64), float(64));
    ShAttrib<3, SH_CONST, float> b(float(64), float(64), float(64));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    try {
      if (test.run(div_a_f_3f_3f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_f_3f_f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a / b;
  } SH_END;

  div_a_f_3f_f_infix_test13.name("div_a_f_3f_f_infix_test13");
  last_test = "div_a_f_3f_f_infix_test13";
  {  // f_3f_f_infix_test13
    ShAttrib<3, SH_CONST, float> a(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<1, SH_CONST, float> b(float(0.3));
    ShAttrib<3, SH_CONST, float> expected(float(-13.3333333333), float(-16.6666666667), float(-20.0));

    try {
      if (test.run(div_a_f_3f_f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_f_1f_3f_infix_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a / b;
  } SH_END;

  div_a_f_1f_3f_infix_test14.name("div_a_f_1f_3f_infix_test14");
  last_test = "div_a_f_1f_3f_infix_test14";
  {  // f_1f_3f_infix_test14
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.333333333333), float(0.25), float(0.2));

    try {
      if (test.run(div_a_f_1f_3f_infix_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram div_a_f_f_3f_infix_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a / b;
  } SH_END;

  div_a_f_f_3f_infix_test15.name("div_a_f_f_3f_infix_test15");
  last_test = "div_a_f_f_3f_infix_test15";
  {  // f_f_3f_infix_test15
    ShAttrib<1, SH_CONST, float> a(float(1.2));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(5.1), float(0.6));
    ShAttrib<3, SH_CONST, float> expected(float(-0.3), float(0.235294117647), float(2.0));

    try {
      if (test.run(div_a_f_f_3f_infix_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a /= b;
  } SH_END;

  mdiv_a_f_3f_3f_infix_test0.name("mdiv_a_f_3f_3f_infix_test0");
  last_test = "mdiv_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.25), float(0.4));

    try {
      if (test.run(mdiv_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_f_3f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a /= b;
  } SH_END;

  mdiv_a_f_3f_1f_infix_test1.name("mdiv_a_f_3f_1f_infix_test1");
  last_test = "mdiv_a_f_3f_1f_infix_test1";
  {  // f_3f_1f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.142857142857), float(0.285714285714), float(0.428571428571));

    try {
      if (test.run(mdiv_a_f_3f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_f_1f_1f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a /= b;
  } SH_END;

  mdiv_a_f_1f_1f_infix_test2.name("mdiv_a_f_1f_1f_infix_test2");
  last_test = "mdiv_a_f_1f_1f_infix_test2";
  {  // f_1f_1f_infix_test2
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.142857142857));

    try {
      if (test.run(mdiv_a_f_1f_1f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a /= b;
  } SH_END;

  mdiv_a_f_3f_3f_infix_test3.name("mdiv_a_f_3f_3f_infix_test3");
  last_test = "mdiv_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-1.0), float(-1.0));

    try {
      if (test.run(mdiv_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_i_2s_2f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, short> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, int> out;
    out = a /= b;
  } SH_END;

  mdiv_a_i_2s_2f_infix_test4.name("mdiv_a_i_2s_2f_infix_test4");
  last_test = "mdiv_a_i_2s_2f_infix_test4";
  {  // i_2s_2f_infix_test4
    ShAttrib<2, SH_CONST, short> a(short(1), short(2));
    ShAttrib<2, SH_CONST, float> b(float(3), float(3));
    ShAttrib<2, SH_CONST, int> expected(int(0), int(0));

    try {
      if (test.run(mdiv_a_i_2s_2f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_i_4i_4i_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = a /= b;
  } SH_END;

  mdiv_a_i_4i_4i_infix_test5.name("mdiv_a_i_4i_4i_infix_test5");
  last_test = "mdiv_a_i_4i_4i_infix_test5";
  {  // i_4i_4i_infix_test5
    ShAttrib<4, SH_CONST, int> a(int(0), int(1), int(2), int(3));
    ShAttrib<4, SH_CONST, int> b(int(4), int(4), int(4), int(4));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(0), int(0), int(0));

    try {
      if (test.run(mdiv_a_i_4i_4i_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_i_3i_3i_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a /= b;
  } SH_END;

  mdiv_a_i_3i_3i_infix_test6.name("mdiv_a_i_3i_3i_infix_test6");
  last_test = "mdiv_a_i_3i_3i_infix_test6";
  {  // i_3i_3i_infix_test6
    ShAttrib<3, SH_CONST, int> a(int(5), int(6), int(7));
    ShAttrib<3, SH_CONST, int> b(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(mdiv_a_i_3i_3i_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_i_4i_4i_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = a /= b;
  } SH_END;

  mdiv_a_i_4i_4i_infix_test7.name("mdiv_a_i_4i_4i_infix_test7");
  last_test = "mdiv_a_i_4i_4i_infix_test7";
  {  // i_4i_4i_infix_test7
    ShAttrib<4, SH_CONST, int> a(int(8), int(9), int(10), int(11));
    ShAttrib<4, SH_CONST, int> b(int(4), int(4), int(4), int(4));
    ShAttrib<4, SH_CONST, int> expected(int(2), int(2), int(2), int(2));

    try {
      if (test.run(mdiv_a_i_4i_4i_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_f_2f_2f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = a /= b;
  } SH_END;

  mdiv_a_f_2f_2f_infix_test8.name("mdiv_a_f_2f_2f_infix_test8");
  last_test = "mdiv_a_f_2f_2f_infix_test8";
  {  // f_2f_2f_infix_test8
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<2, SH_CONST, float> b(float(3), float(3));
    ShAttrib<2, SH_CONST, float> expected(float(0.333333333333), float(0.666666666667));

    try {
      if (test.run(mdiv_a_f_2f_2f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_s_2s_2f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, short> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, short> out;
    out = a /= b;
  } SH_END;

  mdiv_a_s_2s_2f_infix_test9.name("mdiv_a_s_2s_2f_infix_test9");
  last_test = "mdiv_a_s_2s_2f_infix_test9";
  {  // s_2s_2f_infix_test9
    ShAttrib<2, SH_CONST, short> a(short(1), short(2));
    ShAttrib<2, SH_CONST, float> b(float(3.0), float(3.0));
    ShAttrib<2, SH_CONST, short> expected(short(0.333333333333), short(0.666666666667));

    try {
      if (test.run(mdiv_a_s_2s_2f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_i_3i_3i_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a /= b;
  } SH_END;

  mdiv_a_i_3i_3i_infix_test10.name("mdiv_a_i_3i_3i_infix_test10");
  last_test = "mdiv_a_i_3i_3i_infix_test10";
  {  // i_3i_3i_infix_test10
    ShAttrib<3, SH_CONST, int> a(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> b(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(mdiv_a_i_3i_3i_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_f_3f_3f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a /= b;
  } SH_END;

  mdiv_a_f_3f_3f_infix_test11.name("mdiv_a_f_3f_3f_infix_test11");
  last_test = "mdiv_a_f_3f_3f_infix_test11";
  {  // f_3f_3f_infix_test11
    ShAttrib<3, SH_CONST, float> a(float(1), float(0.5), float(2));
    ShAttrib<3, SH_CONST, float> b(float(1), float(0.5), float(2));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1.0), float(1));

    try {
      if (test.run(mdiv_a_f_3f_3f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_f_3f_3f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a /= b;
  } SH_END;

  mdiv_a_f_3f_3f_infix_test12.name("mdiv_a_f_3f_3f_infix_test12");
  last_test = "mdiv_a_f_3f_3f_infix_test12";
  {  // f_3f_3f_infix_test12
    ShAttrib<3, SH_CONST, float> a(float(64), float(64), float(64));
    ShAttrib<3, SH_CONST, float> b(float(64), float(64), float(64));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    try {
      if (test.run(mdiv_a_f_3f_3f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mdiv_a_f_3f_f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a /= b;
  } SH_END;

  mdiv_a_f_3f_f_infix_test13.name("mdiv_a_f_3f_f_infix_test13");
  last_test = "mdiv_a_f_3f_f_infix_test13";
  {  // f_3f_f_infix_test13
    ShAttrib<3, SH_CONST, float> a(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<1, SH_CONST, float> b(float(0.3));
    ShAttrib<3, SH_CONST, float> expected(float(-13.3333333333), float(-16.6666666667), float(-20.0));

    try {
      if (test.run(mdiv_a_f_3f_f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.25), float(0.4));

    ShAttrib<3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_1f_infix_test1
    last_test = "f_3f_1f_infix_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.142857142857), float(0.285714285714), float(0.428571428571));

    ShAttrib<3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test2
    last_test = "f_1f_1f_infix_test2";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.142857142857));

    ShAttrib<1, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_1f_1f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-1.0), float(-1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_2s_2f_infix_test4
    last_test = "i_2s_2f_infix_test4";
    ShAttrib<2, SH_CONST, short> a(short(1), short(2));
    ShAttrib<2, SH_CONST, float> b(float(3), float(3));
    ShAttrib<2, SH_CONST, int> expected(int(0), int(0));

    ShAttrib<2, SH_TEMP, int> out;
    out = a / b;

    try {
      if (test.check("i_2s_2f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_infix_test5
    last_test = "i_4i_4i_infix_test5";
    ShAttrib<4, SH_CONST, int> a(int(0), int(1), int(2), int(3));
    ShAttrib<4, SH_CONST, int> b(int(4), int(4), int(4), int(4));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(0), int(0), int(0));

    ShAttrib<4, SH_TEMP, int> out;
    out = a / b;

    try {
      if (test.check("i_4i_4i_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test6
    last_test = "i_3i_3i_infix_test6";
    ShAttrib<3, SH_CONST, int> a(int(5), int(6), int(7));
    ShAttrib<3, SH_CONST, int> b(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a / b;

    try {
      if (test.check("i_3i_3i_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_infix_test7
    last_test = "i_4i_4i_infix_test7";
    ShAttrib<4, SH_CONST, int> a(int(8), int(9), int(10), int(11));
    ShAttrib<4, SH_CONST, int> b(int(4), int(4), int(4), int(4));
    ShAttrib<4, SH_CONST, int> expected(int(2), int(2), int(2), int(2));

    ShAttrib<4, SH_TEMP, int> out;
    out = a / b;

    try {
      if (test.check("i_4i_4i_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_infix_test8
    last_test = "f_2f_2f_infix_test8";
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<2, SH_CONST, float> b(float(3), float(3));
    ShAttrib<2, SH_CONST, float> expected(float(0.333333333333), float(0.666666666667));

    ShAttrib<2, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_2f_2f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // s_2s_2f_infix_test9
    last_test = "s_2s_2f_infix_test9";
    ShAttrib<2, SH_CONST, short> a(short(1), short(2));
    ShAttrib<2, SH_CONST, float> b(float(3.0), float(3.0));
    ShAttrib<2, SH_CONST, short> expected(short(0.333333333333), short(0.666666666667));

    ShAttrib<2, SH_TEMP, short> out;
    out = a / b;

    try {
      if (test.check("s_2s_2f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test10
    last_test = "i_3i_3i_infix_test10";
    ShAttrib<3, SH_CONST, int> a(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> b(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a / b;

    try {
      if (test.check("i_3i_3i_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test11
    last_test = "f_3f_3f_infix_test11";
    ShAttrib<3, SH_CONST, float> a(float(1), float(0.5), float(2));
    ShAttrib<3, SH_CONST, float> b(float(1), float(0.5), float(2));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1.0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_3f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test12
    last_test = "f_3f_3f_infix_test12";
    ShAttrib<3, SH_CONST, float> a(float(64), float(64), float(64));
    ShAttrib<3, SH_CONST, float> b(float(64), float(64), float(64));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_3f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test13
    last_test = "f_3f_f_infix_test13";
    ShAttrib<3, SH_CONST, float> a(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<1, SH_CONST, float> b(float(0.3));
    ShAttrib<3, SH_CONST, float> expected(float(-13.3333333333), float(-16.6666666667), float(-20.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_3f_f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_3f_infix_test14
    last_test = "f_1f_3f_infix_test14";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.333333333333), float(0.25), float(0.2));

    ShAttrib<3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_1f_3f_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test15
    last_test = "f_f_3f_infix_test15";
    ShAttrib<1, SH_CONST, float> a(float(1.2));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(5.1), float(0.6));
    ShAttrib<3, SH_CONST, float> expected(float(-0.3), float(0.235294117647), float(2.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a / b;

    try {
      if (test.check("f_f_3f_infix_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.25), float(0.4));

    ShAttrib<3, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_1f_infix_test1
    last_test = "f_3f_1f_infix_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.142857142857), float(0.285714285714), float(0.428571428571));

    ShAttrib<3, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test2
    last_test = "f_1f_1f_infix_test2";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.142857142857));

    ShAttrib<1, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_1f_1f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-1.0), float(-1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_2s_2f_infix_test4
    last_test = "i_2s_2f_infix_test4";
    ShAttrib<2, SH_CONST, short> a(short(1), short(2));
    ShAttrib<2, SH_CONST, float> b(float(3), float(3));
    ShAttrib<2, SH_CONST, int> expected(int(0), int(0));

    ShAttrib<2, SH_TEMP, int> out;
    out = a /= b;

    try {
      if (test.check("i_2s_2f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_infix_test5
    last_test = "i_4i_4i_infix_test5";
    ShAttrib<4, SH_CONST, int> a(int(0), int(1), int(2), int(3));
    ShAttrib<4, SH_CONST, int> b(int(4), int(4), int(4), int(4));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(0), int(0), int(0));

    ShAttrib<4, SH_TEMP, int> out;
    out = a /= b;

    try {
      if (test.check("i_4i_4i_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test6
    last_test = "i_3i_3i_infix_test6";
    ShAttrib<3, SH_CONST, int> a(int(5), int(6), int(7));
    ShAttrib<3, SH_CONST, int> b(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a /= b;

    try {
      if (test.check("i_3i_3i_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_infix_test7
    last_test = "i_4i_4i_infix_test7";
    ShAttrib<4, SH_CONST, int> a(int(8), int(9), int(10), int(11));
    ShAttrib<4, SH_CONST, int> b(int(4), int(4), int(4), int(4));
    ShAttrib<4, SH_CONST, int> expected(int(2), int(2), int(2), int(2));

    ShAttrib<4, SH_TEMP, int> out;
    out = a /= b;

    try {
      if (test.check("i_4i_4i_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_infix_test8
    last_test = "f_2f_2f_infix_test8";
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<2, SH_CONST, float> b(float(3), float(3));
    ShAttrib<2, SH_CONST, float> expected(float(0.333333333333), float(0.666666666667));

    ShAttrib<2, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_2f_2f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // s_2s_2f_infix_test9
    last_test = "s_2s_2f_infix_test9";
    ShAttrib<2, SH_CONST, short> a(short(1), short(2));
    ShAttrib<2, SH_CONST, float> b(float(3.0), float(3.0));
    ShAttrib<2, SH_CONST, short> expected(short(0.333333333333), short(0.666666666667));

    ShAttrib<2, SH_TEMP, short> out;
    out = a /= b;

    try {
      if (test.check("s_2s_2f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test10
    last_test = "i_3i_3i_infix_test10";
    ShAttrib<3, SH_CONST, int> a(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> b(int(4), int(4), int(4));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a /= b;

    try {
      if (test.check("i_3i_3i_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test11
    last_test = "f_3f_3f_infix_test11";
    ShAttrib<3, SH_CONST, float> a(float(1), float(0.5), float(2));
    ShAttrib<3, SH_CONST, float> b(float(1), float(0.5), float(2));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1.0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_3f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test12
    last_test = "f_3f_3f_infix_test12";
    ShAttrib<3, SH_CONST, float> a(float(64), float(64), float(64));
    ShAttrib<3, SH_CONST, float> b(float(64), float(64), float(64));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_3f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test13
    last_test = "f_3f_f_infix_test13";
    ShAttrib<3, SH_CONST, float> a(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<1, SH_CONST, float> b(float(0.3));
    ShAttrib<3, SH_CONST, float> expected(float(-13.3333333333), float(-16.6666666667), float(-20.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a /= b;

    try {
      if (test.check("f_3f_f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

