#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram dot_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a | b;
  } SH_END;

  dot_a_f_3f_3f_infix_test0.name("dot_a_f_3f_3f_infix_test0");
  last_test = "dot_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(14.0));

    try {
      if (test.run(dot_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram dot_a_f_3f_3f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a | b;
  } SH_END;

  dot_a_f_3f_3f_infix_test1.name("dot_a_f_3f_3f_infix_test1");
  last_test = "dot_a_f_3f_3f_infix_test1";
  {  // f_3f_3f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(1.0), float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    try {
      if (test.run(dot_a_f_3f_3f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram dot_a_f_3f_3f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a | b;
  } SH_END;

  dot_a_f_3f_3f_infix_test2.name("dot_a_f_3f_3f_infix_test2");
  last_test = "dot_a_f_3f_3f_infix_test2";
  {  // f_3f_3f_infix_test2
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(1.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(dot_a_f_3f_3f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram dot_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a | b;
  } SH_END;

  dot_a_f_3f_3f_infix_test3.name("dot_a_f_3f_3f_infix_test3");
  last_test = "dot_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(-1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.5), float(-1.5), float(-6.0));
    ShAttrib<1, SH_CONST, float> expected(float(-4.25));

    try {
      if (test.run(dot_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram dot_a_i_3i_3i_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a | b;
  } SH_END;

  dot_a_i_3i_3i_infix_test4.name("dot_a_i_3i_3i_infix_test4");
  last_test = "dot_a_i_3i_3i_infix_test4";
  {  // i_3i_3i_infix_test4
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(1.0), int(2.0), int(3.0));
    ShAttrib<1, SH_CONST, int> expected(int(14.0));

    try {
      if (test.run(dot_a_i_3i_3i_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram dot_a_i_3i_3i_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a | b;
  } SH_END;

  dot_a_i_3i_3i_infix_test5.name("dot_a_i_3i_3i_infix_test5");
  last_test = "dot_a_i_3i_3i_infix_test5";
  {  // i_3i_3i_infix_test5
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(1.0), int(1.0));
    ShAttrib<3, SH_CONST, int> b(int(1.0), int(1.0), int(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(3.0));

    try {
      if (test.run(dot_a_i_3i_3i_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram dot_a_i_3i_3i_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a | b;
  } SH_END;

  dot_a_i_3i_3i_infix_test6.name("dot_a_i_3i_3i_infix_test6");
  last_test = "dot_a_i_3i_3i_infix_test6";
  {  // i_3i_3i_infix_test6
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> b(int(0.0), int(1.0), int(0.0));
    ShAttrib<1, SH_CONST, int> expected(int(0.0));

    try {
      if (test.run(dot_a_i_3i_3i_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram dot_a_i_3i_3i_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a | b;
  } SH_END;

  dot_a_i_3i_3i_infix_test7.name("dot_a_i_3i_3i_infix_test7");
  last_test = "dot_a_i_3i_3i_infix_test7";
  {  // i_3i_3i_infix_test7
    ShAttrib<3, SH_CONST, int> a(int(7.0), int(-1.0), int(1.0));
    ShAttrib<3, SH_CONST, int> b(int(7.0), int(-1.0), int(-6.0));
    ShAttrib<1, SH_CONST, int> expected(int(44.0));

    try {
      if (test.run(dot_a_i_3i_3i_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(14.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a | b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test1
    last_test = "f_3f_3f_infix_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(1.0), float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a | b;

    try {
      if (test.check("f_3f_3f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test2
    last_test = "f_3f_3f_infix_test2";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(1.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a | b;

    try {
      if (test.check("f_3f_3f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(-1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.5), float(-1.5), float(-6.0));
    ShAttrib<1, SH_CONST, float> expected(float(-4.25));

    ShAttrib<1, SH_TEMP, float> out;
    out = a | b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test4
    last_test = "i_3i_3i_infix_test4";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(1.0), int(2.0), int(3.0));
    ShAttrib<1, SH_CONST, int> expected(int(14.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a | b;

    try {
      if (test.check("i_3i_3i_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test5
    last_test = "i_3i_3i_infix_test5";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(1.0), int(1.0));
    ShAttrib<3, SH_CONST, int> b(int(1.0), int(1.0), int(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(3.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a | b;

    try {
      if (test.check("i_3i_3i_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test6
    last_test = "i_3i_3i_infix_test6";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> b(int(0.0), int(1.0), int(0.0));
    ShAttrib<1, SH_CONST, int> expected(int(0.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a | b;

    try {
      if (test.check("i_3i_3i_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test7
    last_test = "i_3i_3i_infix_test7";
    ShAttrib<3, SH_CONST, int> a(int(7.0), int(-1.0), int(1.0));
    ShAttrib<3, SH_CONST, int> b(int(7.0), int(-1.0), int(-6.0));
    ShAttrib<1, SH_CONST, int> expected(int(44.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a | b;

    try {
      if (test.check("i_3i_3i_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

