#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram floor_a_f_4f_callfloor_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = floor(a);
  } SH_END;

  floor_a_f_4f_callfloor_test0.name("floor_a_f_4f_callfloor_test0");
  last_test = "floor_a_f_4f_callfloor_test0";
  {  // f_4f_callfloor_test0
    ShAttrib<4, SH_CONST, float> a(float(3.0), float(3.1), float(3.5), float(3.9));
    ShAttrib<4, SH_CONST, float> expected(float(3.0), float(3.0), float(3.0), float(3.0));

    try {
      if (test.run(floor_a_f_4f_callfloor_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram floor_a_f_4f_callfloor_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = floor(a);
  } SH_END;

  floor_a_f_4f_callfloor_test1.name("floor_a_f_4f_callfloor_test1");
  last_test = "floor_a_f_4f_callfloor_test1";
  {  // f_4f_callfloor_test1
    ShAttrib<4, SH_CONST, float> a(float(-3.0), float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<4, SH_CONST, float> expected(float(-3.0), float(-4.0), float(-4.0), float(-4.0));

    try {
      if (test.run(floor_a_f_4f_callfloor_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram floor_a_f_f_callfloor_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = floor(a);
  } SH_END;

  floor_a_f_f_callfloor_test2.name("floor_a_f_f_callfloor_test2");
  last_test = "floor_a_f_f_callfloor_test2";
  {  // f_f_callfloor_test2
    ShAttrib<1, SH_CONST, float> a(float(-0.75));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    try {
      if (test.run(floor_a_f_f_callfloor_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram floor_a_f_f_callfloor_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = floor(a);
  } SH_END;

  floor_a_f_f_callfloor_test3.name("floor_a_f_f_callfloor_test3");
  last_test = "floor_a_f_f_callfloor_test3";
  {  // f_f_callfloor_test3
    ShAttrib<1, SH_CONST, float> a(float(0.75));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(floor_a_f_f_callfloor_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram floor_a_f_f_callfloor_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = floor(a);
  } SH_END;

  floor_a_f_f_callfloor_test4.name("floor_a_f_f_callfloor_test4");
  last_test = "floor_a_f_f_callfloor_test4";
  {  // f_f_callfloor_test4
    ShAttrib<1, SH_CONST, float> a(float(0.2));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(floor_a_f_f_callfloor_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram floor_a_f_f_callfloor_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = floor(a);
  } SH_END;

  floor_a_f_f_callfloor_test5.name("floor_a_f_f_callfloor_test5");
  last_test = "floor_a_f_f_callfloor_test5";
  {  // f_f_callfloor_test5
    ShAttrib<1, SH_CONST, float> a(float(-0.2));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    try {
      if (test.run(floor_a_f_f_callfloor_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_callfloor_test0
    last_test = "f_4f_callfloor_test0";
    ShAttrib<4, SH_CONST, float> a(float(3.0), float(3.1), float(3.5), float(3.9));
    ShAttrib<4, SH_CONST, float> expected(float(3.0), float(3.0), float(3.0), float(3.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = floor(a);

    try {
      if (test.check("f_4f_callfloor_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callfloor_test1
    last_test = "f_4f_callfloor_test1";
    ShAttrib<4, SH_CONST, float> a(float(-3.0), float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<4, SH_CONST, float> expected(float(-3.0), float(-4.0), float(-4.0), float(-4.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = floor(a);

    try {
      if (test.check("f_4f_callfloor_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_callfloor_test2
    last_test = "f_f_callfloor_test2";
    ShAttrib<1, SH_CONST, float> a(float(-0.75));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = floor(a);

    try {
      if (test.check("f_f_callfloor_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_callfloor_test3
    last_test = "f_f_callfloor_test3";
    ShAttrib<1, SH_CONST, float> a(float(0.75));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = floor(a);

    try {
      if (test.check("f_f_callfloor_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_callfloor_test4
    last_test = "f_f_callfloor_test4";
    ShAttrib<1, SH_CONST, float> a(float(0.2));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = floor(a);

    try {
      if (test.check("f_f_callfloor_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_callfloor_test5
    last_test = "f_f_callfloor_test5";
    ShAttrib<1, SH_CONST, float> a(float(-0.2));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = floor(a);

    try {
      if (test.check("f_f_callfloor_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

