#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram lit_a_f_1f_1f_1f_calllit_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test0.name("lit_a_f_1f_1f_1f_calllit_test0");
  last_test = "lit_a_f_1f_1f_1f_calllit_test0";
  {  // f_1f_1f_1f_calllit_test0
    ShAttrib<1, SH_CONST, float> a(float(0.75));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(10.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.75), float(0.0009765625), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test0, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test1.name("lit_a_f_1f_1f_1f_calllit_test1");
  last_test = "lit_a_f_1f_1f_1f_calllit_test1";
  {  // f_1f_1f_1f_calllit_test1
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(50.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.5), float(8.881784197e-16), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test1, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test2.name("lit_a_f_1f_1f_1f_calllit_test2");
  last_test = "lit_a_f_1f_1f_1f_calllit_test2";
  {  // f_1f_1f_1f_calllit_test2
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.75));
    ShAttrib<1, SH_CONST, float> c(float(100.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.5), float(3.20720218538e-13), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test2, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test3.name("lit_a_f_1f_1f_1f_calllit_test3");
  last_test = "lit_a_f_1f_1f_1f_calllit_test3";
  {  // f_1f_1f_1f_calllit_test3
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.75));
    ShAttrib<1, SH_CONST, float> c(float(100.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.5), float(3.20720218538e-13), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test3, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test4.name("lit_a_f_1f_1f_1f_calllit_test4");
  last_test = "lit_a_f_1f_1f_1f_calllit_test4";
  {  // f_1f_1f_1f_calllit_test4
    ShAttrib<1, SH_CONST, float> a(float(0.01));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(30.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.01), float(1e-60), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test4, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test5.name("lit_a_f_1f_1f_1f_calllit_test5");
  last_test = "lit_a_f_1f_1f_1f_calllit_test5";
  {  // f_1f_1f_1f_calllit_test5
    ShAttrib<1, SH_CONST, float> a(float(0.99));
    ShAttrib<1, SH_CONST, float> b(float(0.99));
    ShAttrib<1, SH_CONST, float> c(float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.99), float(0.9509900499), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test5, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test6.name("lit_a_f_1f_1f_1f_calllit_test6");
  last_test = "lit_a_f_1f_1f_1f_calllit_test6";
  {  // f_1f_1f_1f_calllit_test6
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-3.0));
    ShAttrib<1, SH_CONST, float> c(float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1.0), float(0.0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test6, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test7.name("lit_a_f_1f_1f_1f_calllit_test7");
  last_test = "lit_a_f_1f_1f_1f_calllit_test7";
  {  // f_1f_1f_1f_calllit_test7
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-3.0));
    ShAttrib<1, SH_CONST, float> c(float(2.5));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1.0), float(0.0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test7, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test8.name("lit_a_f_1f_1f_1f_calllit_test8");
  last_test = "lit_a_f_1f_1f_1f_calllit_test8";
  {  // f_1f_1f_1f_calllit_test8
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(-1.5));
    ShAttrib<1, SH_CONST, float> c(float(5.5));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.5), float(0.0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test8, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test9.name("lit_a_f_1f_1f_1f_calllit_test9");
  last_test = "lit_a_f_1f_1f_1f_calllit_test9";
  {  // f_1f_1f_1f_calllit_test9
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1.0), float(1.0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test9, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test10.name("lit_a_f_1f_1f_1f_calllit_test10");
  last_test = "lit_a_f_1f_1f_1f_calllit_test10";
  {  // f_1f_1f_1f_calllit_test10
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> b(float(-1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test10, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test11.name("lit_a_f_1f_1f_1f_calllit_test11");
  last_test = "lit_a_f_1f_1f_1f_calllit_test11";
  {  // f_1f_1f_1f_calllit_test11
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(2.0), float(1.0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test11, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test12.name("lit_a_f_1f_1f_1f_calllit_test12");
  last_test = "lit_a_f_1f_1f_1f_calllit_test12";
  {  // f_1f_1f_1f_calllit_test12
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(2.0), float(1.0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test12, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test13.name("lit_a_f_1f_1f_1f_calllit_test13");
  last_test = "lit_a_f_1f_1f_1f_calllit_test13";
  {  // f_1f_1f_1f_calllit_test13
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test13, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test14.name("lit_a_f_1f_1f_1f_calllit_test14");
  last_test = "lit_a_f_1f_1f_1f_calllit_test14";
  {  // f_1f_1f_1f_calllit_test14
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<1, SH_CONST, float> c(float(2.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test14, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test15.name("lit_a_f_1f_1f_1f_calllit_test15");
  last_test = "lit_a_f_1f_1f_1f_calllit_test15";
  {  // f_1f_1f_1f_calllit_test15
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test15, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test16.name("lit_a_f_1f_1f_1f_calllit_test16");
  last_test = "lit_a_f_1f_1f_1f_calllit_test16";
  {  // f_1f_1f_1f_calllit_test16
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(2.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test16, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test17.name("lit_a_f_1f_1f_1f_calllit_test17");
  last_test = "lit_a_f_1f_1f_1f_calllit_test17";
  {  // f_1f_1f_1f_calllit_test17
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1.0), float(1.0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test17, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test18.name("lit_a_f_1f_1f_1f_calllit_test18");
  last_test = "lit_a_f_1f_1f_1f_calllit_test18";
  {  // f_1f_1f_1f_calllit_test18
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(2.0), float(1.0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test18, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test19.name("lit_a_f_1f_1f_1f_calllit_test19");
  last_test = "lit_a_f_1f_1f_1f_calllit_test19";
  {  // f_1f_1f_1f_calllit_test19
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1.0), float(0.0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test19, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test20.name("lit_a_f_1f_1f_1f_calllit_test20");
  last_test = "lit_a_f_1f_1f_1f_calllit_test20";
  {  // f_1f_1f_1f_calllit_test20
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(2.0), float(0.0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test20, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test21.name("lit_a_f_1f_1f_1f_calllit_test21");
  last_test = "lit_a_f_1f_1f_1f_calllit_test21";
  {  // f_1f_1f_1f_calllit_test21
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(2.0), float(0.5), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test21, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test22 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test22.name("lit_a_f_1f_1f_1f_calllit_test22");
  last_test = "lit_a_f_1f_1f_1f_calllit_test22";
  {  // f_1f_1f_1f_calllit_test22
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test22, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test23 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test23.name("lit_a_f_1f_1f_1f_calllit_test23");
  last_test = "lit_a_f_1f_1f_1f_calllit_test23";
  {  // f_1f_1f_1f_calllit_test23
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test23, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test24 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test24.name("lit_a_f_1f_1f_1f_calllit_test24");
  last_test = "lit_a_f_1f_1f_1f_calllit_test24";
  {  // f_1f_1f_1f_calllit_test24
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(-128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test24, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test25 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test25.name("lit_a_f_1f_1f_1f_calllit_test25");
  last_test = "lit_a_f_1f_1f_1f_calllit_test25";
  {  // f_1f_1f_1f_calllit_test25
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(-130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test25, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test26 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test26.name("lit_a_f_1f_1f_1f_calllit_test26");
  last_test = "lit_a_f_1f_1f_1f_calllit_test26";
  {  // f_1f_1f_1f_calllit_test26
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(-5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test26, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test27 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test27.name("lit_a_f_1f_1f_1f_calllit_test27");
  last_test = "lit_a_f_1f_1f_1f_calllit_test27";
  {  // f_1f_1f_1f_calllit_test27
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test27, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test28 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test28.name("lit_a_f_1f_1f_1f_calllit_test28");
  last_test = "lit_a_f_1f_1f_1f_calllit_test28";
  {  // f_1f_1f_1f_calllit_test28
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test28, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test29 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test29.name("lit_a_f_1f_1f_1f_calllit_test29");
  last_test = "lit_a_f_1f_1f_1f_calllit_test29";
  {  // f_1f_1f_1f_calllit_test29
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test29, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test30 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test30.name("lit_a_f_1f_1f_1f_calllit_test30");
  last_test = "lit_a_f_1f_1f_1f_calllit_test30";
  {  // f_1f_1f_1f_calllit_test30
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(-128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test30, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test31 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test31.name("lit_a_f_1f_1f_1f_calllit_test31");
  last_test = "lit_a_f_1f_1f_1f_calllit_test31";
  {  // f_1f_1f_1f_calllit_test31
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(-130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test31, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test32 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test32.name("lit_a_f_1f_1f_1f_calllit_test32");
  last_test = "lit_a_f_1f_1f_1f_calllit_test32";
  {  // f_1f_1f_1f_calllit_test32
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(-5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test32, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test33 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test33.name("lit_a_f_1f_1f_1f_calllit_test33");
  last_test = "lit_a_f_1f_1f_1f_calllit_test33";
  {  // f_1f_1f_1f_calllit_test33
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test33, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test34 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test34.name("lit_a_f_1f_1f_1f_calllit_test34");
  last_test = "lit_a_f_1f_1f_1f_calllit_test34";
  {  // f_1f_1f_1f_calllit_test34
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test34, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test35 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test35.name("lit_a_f_1f_1f_1f_calllit_test35");
  last_test = "lit_a_f_1f_1f_1f_calllit_test35";
  {  // f_1f_1f_1f_calllit_test35
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test35, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test36 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test36.name("lit_a_f_1f_1f_1f_calllit_test36");
  last_test = "lit_a_f_1f_1f_1f_calllit_test36";
  {  // f_1f_1f_1f_calllit_test36
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(-128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test36, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test37 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test37.name("lit_a_f_1f_1f_1f_calllit_test37");
  last_test = "lit_a_f_1f_1f_1f_calllit_test37";
  {  // f_1f_1f_1f_calllit_test37
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(-130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test37, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test38 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test38.name("lit_a_f_1f_1f_1f_calllit_test38");
  last_test = "lit_a_f_1f_1f_1f_calllit_test38";
  {  // f_1f_1f_1f_calllit_test38
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(-5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test38, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test39 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test39.name("lit_a_f_1f_1f_1f_calllit_test39");
  last_test = "lit_a_f_1f_1f_1f_calllit_test39";
  {  // f_1f_1f_1f_calllit_test39
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test39, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test40 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test40.name("lit_a_f_1f_1f_1f_calllit_test40");
  last_test = "lit_a_f_1f_1f_1f_calllit_test40";
  {  // f_1f_1f_1f_calllit_test40
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test40, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lit_a_f_1f_1f_1f_calllit_test41 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_INPUT, float> c;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = lit(a, b, c);
  } SH_END;

  lit_a_f_1f_1f_1f_calllit_test41.name("lit_a_f_1f_1f_1f_calllit_test41");
  last_test = "lit_a_f_1f_1f_1f_calllit_test41";
  {  // f_1f_1f_1f_calllit_test41
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    try {
      if (test.run(lit_a_f_1f_1f_1f_calllit_test41, a, b, c, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram normalize_a_f_3f_callnormalize_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = normalize(a);
  } SH_END;

  normalize_a_f_3f_callnormalize_test0.name("normalize_a_f_3f_callnormalize_test0");
  last_test = "normalize_a_f_3f_callnormalize_test0";
  {  // f_3f_callnormalize_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(0.0), float(0.0));

    try {
      if (test.run(normalize_a_f_3f_callnormalize_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram normalize_a_f_3f_callnormalize_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = normalize(a);
  } SH_END;

  normalize_a_f_3f_callnormalize_test1.name("normalize_a_f_3f_callnormalize_test1");
  last_test = "normalize_a_f_3f_callnormalize_test1";
  {  // f_3f_callnormalize_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.267261241912), float(0.534522483825), float(0.801783725737));

    try {
      if (test.run(normalize_a_f_3f_callnormalize_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram normalize_a_f_3f_callnormalize_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = normalize(a);
  } SH_END;

  normalize_a_f_3f_callnormalize_test2.name("normalize_a_f_3f_callnormalize_test2");
  last_test = "normalize_a_f_3f_callnormalize_test2";
  {  // f_3f_callnormalize_test2
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.57735026919), float(0.57735026919), float(0.57735026919));

    try {
      if (test.run(normalize_a_f_3f_callnormalize_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram normalize_a_f_3f_callnormalize_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = normalize(a);
  } SH_END;

  normalize_a_f_3f_callnormalize_test3.name("normalize_a_f_3f_callnormalize_test3");
  last_test = "normalize_a_f_3f_callnormalize_test3";
  {  // f_3f_callnormalize_test3
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.707106781187), float(0.0), float(0.707106781187));

    try {
      if (test.run(normalize_a_f_3f_callnormalize_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram normalize_a_f_3f_callnormalize_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = normalize(a);
  } SH_END;

  normalize_a_f_3f_callnormalize_test4.name("normalize_a_f_3f_callnormalize_test4");
  last_test = "normalize_a_f_3f_callnormalize_test4";
  {  // f_3f_callnormalize_test4
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(-1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.333333333333), float(-0.666666666667), float(0.666666666667));

    try {
      if (test.run(normalize_a_f_3f_callnormalize_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram normalize_a_f_4f_callnormalize_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = normalize(a);
  } SH_END;

  normalize_a_f_4f_callnormalize_test5.name("normalize_a_f_4f_callnormalize_test5");
  last_test = "normalize_a_f_4f_callnormalize_test5";
  {  // f_4f_callnormalize_test5
    ShAttrib<4, SH_CONST, float> a(float(0.005), float(-1.0), float(1.0), float(5));
    ShAttrib<4, SH_CONST, float> expected(float(0.000962250003163), float(-0.192450000633), float(0.192450000633), float(0.962250003163));

    try {
      if (test.run(normalize_a_f_4f_callnormalize_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram normalize_a_f_1f_callnormalize_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = normalize(a);
  } SH_END;

  normalize_a_f_1f_callnormalize_test6.name("normalize_a_f_1f_callnormalize_test6");
  last_test = "normalize_a_f_1f_callnormalize_test6";
  {  // f_1f_callnormalize_test6
    ShAttrib<1, SH_CONST, float> a(float(-0.023));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    try {
      if (test.run(normalize_a_f_1f_callnormalize_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram faceforward_a_f_3f_3f_callfaceforward_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = faceforward(a, b);
  } SH_END;

  faceforward_a_f_3f_3f_callfaceforward_test0.name("faceforward_a_f_3f_3f_callfaceforward_test0");
  last_test = "faceforward_a_f_3f_3f_callfaceforward_test0";
  {  // f_3f_3f_callfaceforward_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    try {
      if (test.run(faceforward_a_f_3f_3f_callfaceforward_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram faceforward_a_f_3f_3f_callfaceforward_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = faceforward(a, b);
  } SH_END;

  faceforward_a_f_3f_3f_callfaceforward_test1.name("faceforward_a_f_3f_3f_callfaceforward_test1");
  last_test = "faceforward_a_f_3f_3f_callfaceforward_test1";
  {  // f_3f_3f_callfaceforward_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    try {
      if (test.run(faceforward_a_f_3f_3f_callfaceforward_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram faceforward_a_f_3f_3f_callfaceforward_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = faceforward(a, b);
  } SH_END;

  faceforward_a_f_3f_3f_callfaceforward_test2.name("faceforward_a_f_3f_3f_callfaceforward_test2");
  last_test = "faceforward_a_f_3f_3f_callfaceforward_test2";
  {  // f_3f_3f_callfaceforward_test2
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-2.0), float(-3.0));

    try {
      if (test.run(faceforward_a_f_3f_3f_callfaceforward_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram faceforward_a_f_3f_3f_callfaceforward_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = faceforward(a, b);
  } SH_END;

  faceforward_a_f_3f_3f_callfaceforward_test3.name("faceforward_a_f_3f_3f_callfaceforward_test3");
  last_test = "faceforward_a_f_3f_3f_callfaceforward_test3";
  {  // f_3f_3f_callfaceforward_test3
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.0), float(-0.0), float(-0.0));

    try {
      if (test.run(faceforward_a_f_3f_3f_callfaceforward_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram faceforward_a_f_3f_3f_callfaceforward_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = faceforward(a, b);
  } SH_END;

  faceforward_a_f_3f_3f_callfaceforward_test4.name("faceforward_a_f_3f_3f_callfaceforward_test4");
  last_test = "faceforward_a_f_3f_3f_callfaceforward_test4";
  {  // f_3f_3f_callfaceforward_test4
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.5), float(2.0), float(4.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.5), float(2.0), float(4.0));

    try {
      if (test.run(faceforward_a_f_3f_3f_callfaceforward_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram faceforward_a_f_3f_3f_callfaceforward_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = faceforward(a, b);
  } SH_END;

  faceforward_a_f_3f_3f_callfaceforward_test5.name("faceforward_a_f_3f_3f_callfaceforward_test5");
  last_test = "faceforward_a_f_3f_3f_callfaceforward_test5";
  {  // f_3f_3f_callfaceforward_test5
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(1.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.0), float(-1.0), float(-0.0));

    try {
      if (test.run(faceforward_a_f_3f_3f_callfaceforward_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram faceforward_a_f_3f_3f_callfaceforward_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = faceforward(a, b);
  } SH_END;

  faceforward_a_f_3f_3f_callfaceforward_test6.name("faceforward_a_f_3f_3f_callfaceforward_test6");
  last_test = "faceforward_a_f_3f_3f_callfaceforward_test6";
  {  // f_3f_3f_callfaceforward_test6
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(-1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.5), float(-1.5), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.5), float(1.5), float(6.0));

    try {
      if (test.run(faceforward_a_f_3f_3f_callfaceforward_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram faceforward_a_f_3f_3f_callfaceforward_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = faceforward(a, b);
  } SH_END;

  faceforward_a_f_3f_3f_callfaceforward_test7.name("faceforward_a_f_3f_3f_callfaceforward_test7");
  last_test = "faceforward_a_f_3f_3f_callfaceforward_test7";
  {  // f_3f_3f_callfaceforward_test7
    ShAttrib<3, SH_CONST, float> a(float(-0.5), float(-1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.5), float(1.5), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.5), float(-1.5), float(6.0));

    try {
      if (test.run(faceforward_a_f_3f_3f_callfaceforward_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_1f_1f_1f_calllit_test0
    last_test = "f_1f_1f_1f_calllit_test0";
    ShAttrib<1, SH_CONST, float> a(float(0.75));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(10.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.75), float(0.0009765625), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test1
    last_test = "f_1f_1f_1f_calllit_test1";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(50.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.5), float(8.881784197e-16), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test2
    last_test = "f_1f_1f_1f_calllit_test2";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.75));
    ShAttrib<1, SH_CONST, float> c(float(100.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.5), float(3.20720218538e-13), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test3
    last_test = "f_1f_1f_1f_calllit_test3";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.75));
    ShAttrib<1, SH_CONST, float> c(float(100.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.5), float(3.20720218538e-13), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test4
    last_test = "f_1f_1f_1f_calllit_test4";
    ShAttrib<1, SH_CONST, float> a(float(0.01));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(30.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.01), float(1e-60), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test5
    last_test = "f_1f_1f_1f_calllit_test5";
    ShAttrib<1, SH_CONST, float> a(float(0.99));
    ShAttrib<1, SH_CONST, float> b(float(0.99));
    ShAttrib<1, SH_CONST, float> c(float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.99), float(0.9509900499), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test6
    last_test = "f_1f_1f_1f_calllit_test6";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-3.0));
    ShAttrib<1, SH_CONST, float> c(float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1.0), float(0.0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test7
    last_test = "f_1f_1f_1f_calllit_test7";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-3.0));
    ShAttrib<1, SH_CONST, float> c(float(2.5));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1.0), float(0.0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test8
    last_test = "f_1f_1f_1f_calllit_test8";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(-1.5));
    ShAttrib<1, SH_CONST, float> c(float(5.5));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.5), float(0.0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test9
    last_test = "f_1f_1f_1f_calllit_test9";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1.0), float(1.0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test10
    last_test = "f_1f_1f_1f_calllit_test10";
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> b(float(-1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test11
    last_test = "f_1f_1f_1f_calllit_test11";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(2.0), float(1.0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test12
    last_test = "f_1f_1f_1f_calllit_test12";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(0.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(2.0), float(1.0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test13
    last_test = "f_1f_1f_1f_calllit_test13";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test14
    last_test = "f_1f_1f_1f_calllit_test14";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<1, SH_CONST, float> c(float(2.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test15
    last_test = "f_1f_1f_1f_calllit_test15";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test16
    last_test = "f_1f_1f_1f_calllit_test16";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(2.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test17
    last_test = "f_1f_1f_1f_calllit_test17";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1.0), float(1.0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test18
    last_test = "f_1f_1f_1f_calllit_test18";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(2.0), float(1.0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test19
    last_test = "f_1f_1f_1f_calllit_test19";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1.0), float(0.0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test20
    last_test = "f_1f_1f_1f_calllit_test20";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(2.0), float(0.0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test21
    last_test = "f_1f_1f_1f_calllit_test21";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(2.0), float(0.5), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test22
    last_test = "f_1f_1f_1f_calllit_test22";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test22", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test23
    last_test = "f_1f_1f_1f_calllit_test23";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test23", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test24
    last_test = "f_1f_1f_1f_calllit_test24";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(-128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test24", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test25
    last_test = "f_1f_1f_1f_calllit_test25";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(-130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test25", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test26
    last_test = "f_1f_1f_1f_calllit_test26";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(-5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test26", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test27
    last_test = "f_1f_1f_1f_calllit_test27";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test27", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test28
    last_test = "f_1f_1f_1f_calllit_test28";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test28", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test29
    last_test = "f_1f_1f_1f_calllit_test29";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> c(float(5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test29", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test30
    last_test = "f_1f_1f_1f_calllit_test30";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(-128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test30", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test31
    last_test = "f_1f_1f_1f_calllit_test31";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(-130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test31", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test32
    last_test = "f_1f_1f_1f_calllit_test32";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(-5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test32", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test33
    last_test = "f_1f_1f_1f_calllit_test33";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test33", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test34
    last_test = "f_1f_1f_1f_calllit_test34";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test34", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test35
    last_test = "f_1f_1f_1f_calllit_test35";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<1, SH_CONST, float> c(float(5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test35", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test36
    last_test = "f_1f_1f_1f_calllit_test36";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(-128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test36", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test37
    last_test = "f_1f_1f_1f_calllit_test37";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(-130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test37", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test38
    last_test = "f_1f_1f_1f_calllit_test38";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(-5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test38", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test39
    last_test = "f_1f_1f_1f_calllit_test39";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(128));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test39", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test40
    last_test = "f_1f_1f_1f_calllit_test40";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(130));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test40", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_1f_calllit_test41
    last_test = "f_1f_1f_1f_calllit_test41";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0.01));
    ShAttrib<1, SH_CONST, float> c(float(5000));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0.0), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = lit(a, b, c);

    try {
      if (test.check("f_1f_1f_1f_calllit_test41", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callnormalize_test0
    last_test = "f_3f_callnormalize_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = normalize(a);

    try {
      if (test.check("f_3f_callnormalize_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callnormalize_test1
    last_test = "f_3f_callnormalize_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.267261241912), float(0.534522483825), float(0.801783725737));

    ShAttrib<3, SH_TEMP, float> out;
    out = normalize(a);

    try {
      if (test.check("f_3f_callnormalize_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callnormalize_test2
    last_test = "f_3f_callnormalize_test2";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.57735026919), float(0.57735026919), float(0.57735026919));

    ShAttrib<3, SH_TEMP, float> out;
    out = normalize(a);

    try {
      if (test.check("f_3f_callnormalize_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callnormalize_test3
    last_test = "f_3f_callnormalize_test3";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.707106781187), float(0.0), float(0.707106781187));

    ShAttrib<3, SH_TEMP, float> out;
    out = normalize(a);

    try {
      if (test.check("f_3f_callnormalize_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callnormalize_test4
    last_test = "f_3f_callnormalize_test4";
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(-1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.333333333333), float(-0.666666666667), float(0.666666666667));

    ShAttrib<3, SH_TEMP, float> out;
    out = normalize(a);

    try {
      if (test.check("f_3f_callnormalize_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callnormalize_test5
    last_test = "f_4f_callnormalize_test5";
    ShAttrib<4, SH_CONST, float> a(float(0.005), float(-1.0), float(1.0), float(5));
    ShAttrib<4, SH_CONST, float> expected(float(0.000962250003163), float(-0.192450000633), float(0.192450000633), float(0.962250003163));

    ShAttrib<4, SH_TEMP, float> out;
    out = normalize(a);

    try {
      if (test.check("f_4f_callnormalize_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callnormalize_test6
    last_test = "f_1f_callnormalize_test6";
    ShAttrib<1, SH_CONST, float> a(float(-0.023));
    ShAttrib<1, SH_CONST, float> expected(float(-1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = normalize(a);

    try {
      if (test.check("f_1f_callnormalize_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_callfaceforward_test0
    last_test = "f_3f_3f_callfaceforward_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = faceforward(a, b);

    try {
      if (test.check("f_3f_3f_callfaceforward_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_callfaceforward_test1
    last_test = "f_3f_3f_callfaceforward_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = faceforward(a, b);

    try {
      if (test.check("f_3f_3f_callfaceforward_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_callfaceforward_test2
    last_test = "f_3f_3f_callfaceforward_test2";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-2.0), float(-3.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = faceforward(a, b);

    try {
      if (test.check("f_3f_3f_callfaceforward_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_callfaceforward_test3
    last_test = "f_3f_3f_callfaceforward_test3";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.0), float(-0.0), float(-0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = faceforward(a, b);

    try {
      if (test.check("f_3f_3f_callfaceforward_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_callfaceforward_test4
    last_test = "f_3f_3f_callfaceforward_test4";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.5), float(2.0), float(4.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.5), float(2.0), float(4.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = faceforward(a, b);

    try {
      if (test.check("f_3f_3f_callfaceforward_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_callfaceforward_test5
    last_test = "f_3f_3f_callfaceforward_test5";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.0), float(1.0), float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.0), float(-1.0), float(-0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = faceforward(a, b);

    try {
      if (test.check("f_3f_3f_callfaceforward_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_callfaceforward_test6
    last_test = "f_3f_3f_callfaceforward_test6";
    ShAttrib<3, SH_CONST, float> a(float(0.5), float(-1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.5), float(-1.5), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.5), float(1.5), float(6.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = faceforward(a, b);

    try {
      if (test.check("f_3f_3f_callfaceforward_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_callfaceforward_test7
    last_test = "f_3f_3f_callfaceforward_test7";
    ShAttrib<3, SH_CONST, float> a(float(-0.5), float(-1.0), float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(0.5), float(1.5), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.5), float(-1.5), float(6.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = faceforward(a, b);

    try {
      if (test.check("f_3f_3f_callfaceforward_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

