#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram log_a_f_4f_calllog_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log(a);
  } SH_END;

  log_a_f_4f_calllog_test0.name("log_a_f_4f_calllog_test0");
  last_test = "log_a_f_4f_calllog_test0";
  {  // f_4f_calllog_test0
    ShAttrib<4, SH_CONST, float> a(float(0.0001), float(1.0), float(2.0), float(4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-9.21034037198), float(0.0), float(0.69314718056), float(1.38629436112));

    try {
      if (test.run(log_a_f_4f_calllog_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log_a_f_4f_calllog_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log(a);
  } SH_END;

  log_a_f_4f_calllog_test1.name("log_a_f_4f_calllog_test1");
  last_test = "log_a_f_4f_calllog_test1";
  {  // f_4f_calllog_test1
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(-2.30258509299), float(-1.38629436112), float(-1.20397280433), float(-0.69314718056));

    try {
      if (test.run(log_a_f_4f_calllog_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log_a_f_4f_calllog_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log(a);
  } SH_END;

  log_a_f_4f_calllog_test2.name("log_a_f_4f_calllog_test2");
  last_test = "log_a_f_4f_calllog_test2";
  {  // f_4f_calllog_test2
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(10.0), float(30.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.832909122935), float(1.33500106673), float(2.30258509299), float(3.40119738166));

    try {
      if (test.run(log_a_f_4f_calllog_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log_a_f_4f_calllog_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log(a);
  } SH_END;

  log_a_f_4f_calllog_test3.name("log_a_f_4f_calllog_test3");
  last_test = "log_a_f_4f_calllog_test3";
  {  // f_4f_calllog_test3
    ShAttrib<4, SH_CONST, float> a(float(0.95), float(1.1), float(2.9), float(5000.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.0512932943876), float(0.0953101798043), float(1.06471073699), float(8.51719319142));

    try {
      if (test.run(log_a_f_4f_calllog_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log2_a_f_4f_calllog2_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log2(a);
  } SH_END;

  log2_a_f_4f_calllog2_test0.name("log2_a_f_4f_calllog2_test0");
  last_test = "log2_a_f_4f_calllog2_test0";
  {  // f_4f_calllog2_test0
    ShAttrib<4, SH_CONST, float> a(float(0.0001), float(1.0), float(2.0), float(4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-13.2877123795), float(0.0), float(1.0), float(2.0));

    try {
      if (test.run(log2_a_f_4f_calllog2_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log2_a_f_4f_calllog2_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log2(a);
  } SH_END;

  log2_a_f_4f_calllog2_test1.name("log2_a_f_4f_calllog2_test1");
  last_test = "log2_a_f_4f_calllog2_test1";
  {  // f_4f_calllog2_test1
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(-3.32192809489), float(-2.0), float(-1.73696559417), float(-1.0));

    try {
      if (test.run(log2_a_f_4f_calllog2_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log2_a_f_4f_calllog2_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log2(a);
  } SH_END;

  log2_a_f_4f_calllog2_test2.name("log2_a_f_4f_calllog2_test2");
  last_test = "log2_a_f_4f_calllog2_test2";
  {  // f_4f_calllog2_test2
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(10.0), float(30.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.20163386117), float(1.92599941856), float(3.32192809489), float(4.90689059561));

    try {
      if (test.run(log2_a_f_4f_calllog2_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log2_a_f_4f_calllog2_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log2(a);
  } SH_END;

  log2_a_f_4f_calllog2_test3.name("log2_a_f_4f_calllog2_test3");
  last_test = "log2_a_f_4f_calllog2_test3";
  {  // f_4f_calllog2_test3
    ShAttrib<4, SH_CONST, float> a(float(0.95), float(1.1), float(2.9), float(5000.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.0740005814438), float(0.13750352375), float(1.53605290024), float(12.2877123795));

    try {
      if (test.run(log2_a_f_4f_calllog2_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log10_a_f_4f_calllog10_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log10(a);
  } SH_END;

  log10_a_f_4f_calllog10_test0.name("log10_a_f_4f_calllog10_test0");
  last_test = "log10_a_f_4f_calllog10_test0";
  {  // f_4f_calllog10_test0
    ShAttrib<4, SH_CONST, float> a(float(0.0001), float(1.0), float(2.0), float(4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-4.0), float(0.0), float(0.301029995664), float(0.602059991328));

    try {
      if (test.run(log10_a_f_4f_calllog10_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log10_a_f_4f_calllog10_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log10(a);
  } SH_END;

  log10_a_f_4f_calllog10_test1.name("log10_a_f_4f_calllog10_test1");
  last_test = "log10_a_f_4f_calllog10_test1";
  {  // f_4f_calllog10_test1
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(-1.0), float(-0.602059991328), float(-0.52287874528), float(-0.301029995664));

    try {
      if (test.run(log10_a_f_4f_calllog10_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log10_a_f_4f_calllog10_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log10(a);
  } SH_END;

  log10_a_f_4f_calllog10_test2.name("log10_a_f_4f_calllog10_test2");
  last_test = "log10_a_f_4f_calllog10_test2";
  {  // f_4f_calllog10_test2
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(10.0), float(30.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.361727836018), float(0.579783596617), float(1.0), float(1.47712125472));

    try {
      if (test.run(log10_a_f_4f_calllog10_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram log10_a_f_4f_calllog10_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = log10(a);
  } SH_END;

  log10_a_f_4f_calllog10_test3.name("log10_a_f_4f_calllog10_test3");
  last_test = "log10_a_f_4f_calllog10_test3";
  {  // f_4f_calllog10_test3
    ShAttrib<4, SH_CONST, float> a(float(0.95), float(1.1), float(2.9), float(5000.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.0222763947112), float(0.0413926851582), float(0.462397997899), float(3.69897000434));

    try {
      if (test.run(log10_a_f_4f_calllog10_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_calllog_test0
    last_test = "f_4f_calllog_test0";
    ShAttrib<4, SH_CONST, float> a(float(0.0001), float(1.0), float(2.0), float(4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-9.21034037198), float(0.0), float(0.69314718056), float(1.38629436112));

    ShAttrib<4, SH_TEMP, float> out;
    out = log(a);

    try {
      if (test.check("f_4f_calllog_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog_test1
    last_test = "f_4f_calllog_test1";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(-2.30258509299), float(-1.38629436112), float(-1.20397280433), float(-0.69314718056));

    ShAttrib<4, SH_TEMP, float> out;
    out = log(a);

    try {
      if (test.check("f_4f_calllog_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog_test2
    last_test = "f_4f_calllog_test2";
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(10.0), float(30.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.832909122935), float(1.33500106673), float(2.30258509299), float(3.40119738166));

    ShAttrib<4, SH_TEMP, float> out;
    out = log(a);

    try {
      if (test.check("f_4f_calllog_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog_test3
    last_test = "f_4f_calllog_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.95), float(1.1), float(2.9), float(5000.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.0512932943876), float(0.0953101798043), float(1.06471073699), float(8.51719319142));

    ShAttrib<4, SH_TEMP, float> out;
    out = log(a);

    try {
      if (test.check("f_4f_calllog_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog2_test0
    last_test = "f_4f_calllog2_test0";
    ShAttrib<4, SH_CONST, float> a(float(0.0001), float(1.0), float(2.0), float(4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-13.2877123795), float(0.0), float(1.0), float(2.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = log2(a);

    try {
      if (test.check("f_4f_calllog2_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog2_test1
    last_test = "f_4f_calllog2_test1";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(-3.32192809489), float(-2.0), float(-1.73696559417), float(-1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = log2(a);

    try {
      if (test.check("f_4f_calllog2_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog2_test2
    last_test = "f_4f_calllog2_test2";
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(10.0), float(30.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.20163386117), float(1.92599941856), float(3.32192809489), float(4.90689059561));

    ShAttrib<4, SH_TEMP, float> out;
    out = log2(a);

    try {
      if (test.check("f_4f_calllog2_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog2_test3
    last_test = "f_4f_calllog2_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.95), float(1.1), float(2.9), float(5000.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.0740005814438), float(0.13750352375), float(1.53605290024), float(12.2877123795));

    ShAttrib<4, SH_TEMP, float> out;
    out = log2(a);

    try {
      if (test.check("f_4f_calllog2_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog10_test0
    last_test = "f_4f_calllog10_test0";
    ShAttrib<4, SH_CONST, float> a(float(0.0001), float(1.0), float(2.0), float(4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-4.0), float(0.0), float(0.301029995664), float(0.602059991328));

    ShAttrib<4, SH_TEMP, float> out;
    out = log10(a);

    try {
      if (test.check("f_4f_calllog10_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog10_test1
    last_test = "f_4f_calllog10_test1";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(-1.0), float(-0.602059991328), float(-0.52287874528), float(-0.301029995664));

    ShAttrib<4, SH_TEMP, float> out;
    out = log10(a);

    try {
      if (test.check("f_4f_calllog10_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog10_test2
    last_test = "f_4f_calllog10_test2";
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(10.0), float(30.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.361727836018), float(0.579783596617), float(1.0), float(1.47712125472));

    ShAttrib<4, SH_TEMP, float> out;
    out = log10(a);

    try {
      if (test.check("f_4f_calllog10_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllog10_test3
    last_test = "f_4f_calllog10_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.95), float(1.1), float(2.9), float(5000.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.0222763947112), float(0.0413926851582), float(0.462397997899), float(3.69897000434));

    ShAttrib<4, SH_TEMP, float> out;
    out = log10(a);

    try {
      if (test.check("f_4f_calllog10_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

