#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram sort_a_f_4f_callsort_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sort(a);
  } SH_END;

  sort_a_f_4f_callsort_test0.name("sort_a_f_4f_callsort_test0");
  last_test = "sort_a_f_4f_callsort_test0";
  {  // f_4f_callsort_test0
    ShAttrib<4, SH_CONST, float> a(float(1.9), float(0.1), float(0.5), float(0.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.1), float(0.5), float(1.9));

    try {
      if (test.run(sort_a_f_4f_callsort_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sort_a_f_4f_callsort_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sort(a);
  } SH_END;

  sort_a_f_4f_callsort_test1.name("sort_a_f_4f_callsort_test1");
  last_test = "sort_a_f_4f_callsort_test1";
  {  // f_4f_callsort_test1
    ShAttrib<4, SH_CONST, float> a(float(-1.5), float(-2.1), float(-3.5), float(-4.4));
    ShAttrib<4, SH_CONST, float> expected(float(-4.4), float(-3.5), float(-2.1), float(-1.5));

    try {
      if (test.run(sort_a_f_4f_callsort_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sort_a_f_4f_callsort_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sort(a);
  } SH_END;

  sort_a_f_4f_callsort_test2.name("sort_a_f_4f_callsort_test2");
  last_test = "sort_a_f_4f_callsort_test2";
  {  // f_4f_callsort_test2
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(1.0), float(4.0), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0), float(4.0));

    try {
      if (test.run(sort_a_f_4f_callsort_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sort_a_f_4f_callsort_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sort(a);
  } SH_END;

  sort_a_f_4f_callsort_test3.name("sort_a_f_4f_callsort_test3");
  last_test = "sort_a_f_4f_callsort_test3";
  {  // f_4f_callsort_test3
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0), float(4.0));

    try {
      if (test.run(sort_a_f_4f_callsort_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sort_a_f_4f_callsort_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sort(a);
  } SH_END;

  sort_a_f_4f_callsort_test4.name("sort_a_f_4f_callsort_test4");
  last_test = "sort_a_f_4f_callsort_test4";
  {  // f_4f_callsort_test4
    ShAttrib<4, SH_CONST, float> a(float(6.7), float(0), float(-2.1), float(-1.5));
    ShAttrib<4, SH_CONST, float> expected(float(-2.1), float(-1.5), float(0.0), float(6.7));

    try {
      if (test.run(sort_a_f_4f_callsort_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cast_a_f_3f_callcast3_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = cast<3>(a);
  } SH_END;

  cast_a_f_3f_callcast3_test0.name("cast_a_f_3f_callcast3_test0");
  last_test = "cast_a_f_3f_callcast3_test0";
  {  // f_3f_callcast3_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    try {
      if (test.run(cast_a_f_3f_callcast3_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cast_a_f_4f_callcast3_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = cast<3>(a);
  } SH_END;

  cast_a_f_4f_callcast3_test1.name("cast_a_f_4f_callcast3_test1");
  last_test = "cast_a_f_4f_callcast3_test1";
  {  // f_4f_callcast3_test1
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    try {
      if (test.run(cast_a_f_4f_callcast3_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cast_a_f_2f_callcast3_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = cast<3>(a);
  } SH_END;

  cast_a_f_2f_callcast3_test2.name("cast_a_f_2f_callcast3_test2");
  last_test = "cast_a_f_2f_callcast3_test2";
  {  // f_2f_callcast3_test2
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(0.0));

    try {
      if (test.run(cast_a_f_2f_callcast3_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram cast_a_f_1f_callcast3_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = cast<3>(a);
  } SH_END;

  cast_a_f_1f_callcast3_test3.name("cast_a_f_1f_callcast3_test3");
  last_test = "cast_a_f_1f_callcast3_test3";
  {  // f_1f_callcast3_test3
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(0.0), float(0.0));

    try {
      if (test.run(cast_a_f_1f_callcast3_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram fillcast_a_f_3f_callfillcast3_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = fillcast<3>(a);
  } SH_END;

  fillcast_a_f_3f_callfillcast3_test0.name("fillcast_a_f_3f_callfillcast3_test0");
  last_test = "fillcast_a_f_3f_callfillcast3_test0";
  {  // f_3f_callfillcast3_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    try {
      if (test.run(fillcast_a_f_3f_callfillcast3_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram fillcast_a_f_4f_callfillcast3_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = fillcast<3>(a);
  } SH_END;

  fillcast_a_f_4f_callfillcast3_test1.name("fillcast_a_f_4f_callfillcast3_test1");
  last_test = "fillcast_a_f_4f_callfillcast3_test1";
  {  // f_4f_callfillcast3_test1
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    try {
      if (test.run(fillcast_a_f_4f_callfillcast3_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram fillcast_a_f_2f_callfillcast3_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = fillcast<3>(a);
  } SH_END;

  fillcast_a_f_2f_callfillcast3_test2.name("fillcast_a_f_2f_callfillcast3_test2");
  last_test = "fillcast_a_f_2f_callfillcast3_test2";
  {  // f_2f_callfillcast3_test2
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(2.0));

    try {
      if (test.run(fillcast_a_f_2f_callfillcast3_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram fillcast_a_f_1f_callfillcast3_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = fillcast<3>(a);
  } SH_END;

  fillcast_a_f_1f_callfillcast3_test3.name("fillcast_a_f_1f_callfillcast3_test3");
  last_test = "fillcast_a_f_1f_callfillcast3_test3";
  {  // f_1f_callfillcast3_test3
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0));

    try {
      if (test.run(fillcast_a_f_1f_callfillcast3_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_callsort_test0
    last_test = "f_4f_callsort_test0";
    ShAttrib<4, SH_CONST, float> a(float(1.9), float(0.1), float(0.5), float(0.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.1), float(0.5), float(1.9));

    ShAttrib<4, SH_TEMP, float> out;
    out = sort(a);

    try {
      if (test.check("f_4f_callsort_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsort_test1
    last_test = "f_4f_callsort_test1";
    ShAttrib<4, SH_CONST, float> a(float(-1.5), float(-2.1), float(-3.5), float(-4.4));
    ShAttrib<4, SH_CONST, float> expected(float(-4.4), float(-3.5), float(-2.1), float(-1.5));

    ShAttrib<4, SH_TEMP, float> out;
    out = sort(a);

    try {
      if (test.check("f_4f_callsort_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsort_test2
    last_test = "f_4f_callsort_test2";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(1.0), float(4.0), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0), float(4.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = sort(a);

    try {
      if (test.check("f_4f_callsort_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsort_test3
    last_test = "f_4f_callsort_test3";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0), float(4.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = sort(a);

    try {
      if (test.check("f_4f_callsort_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsort_test4
    last_test = "f_4f_callsort_test4";
    ShAttrib<4, SH_CONST, float> a(float(6.7), float(0), float(-2.1), float(-1.5));
    ShAttrib<4, SH_CONST, float> expected(float(-2.1), float(-1.5), float(0.0), float(6.7));

    ShAttrib<4, SH_TEMP, float> out;
    out = sort(a);

    try {
      if (test.check("f_4f_callsort_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callcast3_test0
    last_test = "f_3f_callcast3_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = cast<3>(a);

    try {
      if (test.check("f_3f_callcast3_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callcast3_test1
    last_test = "f_4f_callcast3_test1";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = cast<3>(a);

    try {
      if (test.check("f_4f_callcast3_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_callcast3_test2
    last_test = "f_2f_callcast3_test2";
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = cast<3>(a);

    try {
      if (test.check("f_2f_callcast3_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callcast3_test3
    last_test = "f_1f_callcast3_test3";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = cast<3>(a);

    try {
      if (test.check("f_1f_callcast3_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callfillcast3_test0
    last_test = "f_3f_callfillcast3_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = fillcast<3>(a);

    try {
      if (test.check("f_3f_callfillcast3_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callfillcast3_test1
    last_test = "f_4f_callfillcast3_test1";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(3.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = fillcast<3>(a);

    try {
      if (test.check("f_4f_callfillcast3_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_callfillcast3_test2
    last_test = "f_2f_callfillcast3_test2";
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(2.0), float(2.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = fillcast<3>(a);

    try {
      if (test.check("f_2f_callfillcast3_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_callfillcast3_test3
    last_test = "f_1f_callfillcast3_test3";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = fillcast<3>(a);

    try {
      if (test.check("f_1f_callfillcast3_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

