#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram mod_a_i_2i_2f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, int> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, int> out;
    out = a % b;
  } SH_END;

  mod_a_i_2i_2f_infix_test0.name("mod_a_i_2i_2f_infix_test0");
  last_test = "mod_a_i_2i_2f_infix_test0";
  {  // i_2i_2f_infix_test0
    ShAttrib<2, SH_CONST, int> a(int(3), int(3));
    ShAttrib<2, SH_CONST, float> b(float(4), float(2));
    ShAttrib<2, SH_CONST, int> expected(int(3), int(1));

    try {
      if (test.run(mod_a_i_2i_2f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_i_3i_3i_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a % b;
  } SH_END;

  mod_a_i_3i_3i_infix_test1.name("mod_a_i_3i_3i_infix_test1");
  last_test = "mod_a_i_3i_3i_infix_test1";
  {  // i_3i_3i_infix_test1
    ShAttrib<3, SH_CONST, int> a(int(-3), int(-3), int(-3));
    ShAttrib<3, SH_CONST, int> b(int(4), int(3), int(2));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    try {
      if (test.run(mod_a_i_3i_3i_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_i_3i_3i_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a % b;
  } SH_END;

  mod_a_i_3i_3i_infix_test2.name("mod_a_i_3i_3i_infix_test2");
  last_test = "mod_a_i_3i_3i_infix_test2";
  {  // i_3i_3i_infix_test2
    ShAttrib<3, SH_CONST, int> a(int(3), int(3), int(3));
    ShAttrib<3, SH_CONST, int> b(int(-4), int(-3), int(-2));
    ShAttrib<3, SH_CONST, int> expected(int(-1), int(0), int(-1));

    try {
      if (test.run(mod_a_i_3i_3i_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_i_2i_2f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, int> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, int> out;
    out = a % b;
  } SH_END;

  mod_a_i_2i_2f_infix_test3.name("mod_a_i_2i_2f_infix_test3");
  last_test = "mod_a_i_2i_2f_infix_test3";
  {  // i_2i_2f_infix_test3
    ShAttrib<2, SH_CONST, int> a(int(-3), int(-3));
    ShAttrib<2, SH_CONST, float> b(float(-4), float(-2));
    ShAttrib<2, SH_CONST, int> expected(int(-3), int(-1));

    try {
      if (test.run(mod_a_i_2i_2f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_2f_2f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_2f_2f_infix_test4.name("mod_a_f_2f_2f_infix_test4");
  last_test = "mod_a_f_2f_2f_infix_test4";
  {  // f_2f_2f_infix_test4
    ShAttrib<2, SH_CONST, float> a(float(3.0), float(3.0));
    ShAttrib<2, SH_CONST, float> b(float(4.0), float(2.0));
    ShAttrib<2, SH_CONST, float> expected(float(3.0), float(1.0));

    try {
      if (test.run(mod_a_f_2f_2f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_3f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_3f_3f_infix_test5.name("mod_a_f_3f_3f_infix_test5");
  last_test = "mod_a_f_3f_3f_infix_test5";
  {  // f_3f_3f_infix_test5
    ShAttrib<3, SH_CONST, float> a(float(-3.0), float(-3.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(-0.0), float(1.0));

    try {
      if (test.run(mod_a_f_3f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_3f_3f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_3f_3f_infix_test6.name("mod_a_f_3f_3f_infix_test6");
  last_test = "mod_a_f_3f_3f_infix_test6";
  {  // f_3f_3f_infix_test6
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(3.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(0.0), float(-1.0));

    try {
      if (test.run(mod_a_f_3f_3f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_2f_2f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_2f_2f_infix_test7.name("mod_a_f_2f_2f_infix_test7");
  last_test = "mod_a_f_2f_2f_infix_test7";
  {  // f_2f_2f_infix_test7
    ShAttrib<2, SH_CONST, float> a(float(-3.0), float(-3.0));
    ShAttrib<2, SH_CONST, float> b(float(-4.0), float(-2.0));
    ShAttrib<2, SH_CONST, float> expected(float(-3.0), float(-1.0));

    try {
      if (test.run(mod_a_f_2f_2f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_3f_3f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_3f_3f_infix_test8.name("mod_a_f_3f_3f_infix_test8");
  last_test = "mod_a_f_3f_3f_infix_test8";
  {  // f_3f_3f_infix_test8
    ShAttrib<3, SH_CONST, float> a(float(3.1), float(3.5), float(3.9));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(3.1), float(0.5), float(1.9));

    try {
      if (test.run(mod_a_f_3f_3f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_3f_3f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_3f_3f_infix_test9.name("mod_a_f_3f_3f_infix_test9");
  last_test = "mod_a_f_3f_3f_infix_test9";
  {  // f_3f_3f_infix_test9
    ShAttrib<3, SH_CONST, float> a(float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.9), float(2.5), float(0.1));

    try {
      if (test.run(mod_a_f_3f_3f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_3f_3f_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_3f_3f_infix_test10.name("mod_a_f_3f_3f_infix_test10");
  last_test = "mod_a_f_3f_3f_infix_test10";
  {  // f_3f_3f_infix_test10
    ShAttrib<3, SH_CONST, float> a(float(3.1), float(3.5), float(3.9));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.9), float(-2.5), float(-0.1));

    try {
      if (test.run(mod_a_f_3f_3f_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_3f_3f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_3f_3f_infix_test11.name("mod_a_f_3f_3f_infix_test11");
  last_test = "mod_a_f_3f_3f_infix_test11";
  {  // f_3f_3f_infix_test11
    ShAttrib<3, SH_CONST, float> a(float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-3.1), float(-0.5), float(-1.9));

    try {
      if (test.run(mod_a_f_3f_3f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_4f_4f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_4f_4f_infix_test12.name("mod_a_f_4f_4f_infix_test12");
  last_test = "mod_a_f_4f_4f_infix_test12";
  {  // f_4f_4f_infix_test12
    ShAttrib<4, SH_CONST, float> a(float(2), float(-2), float(0.5), float(-0.5));
    ShAttrib<4, SH_CONST, float> b(float(2), float(-2), float(0.5), float(-0.5));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0.0), float(-0.0));

    try {
      if (test.run(mod_a_f_4f_4f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_i_2i_2f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, int> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, int> out;
    out = a % b;
  } SH_END;

  mod_a_i_2i_2f_infix_test13.name("mod_a_i_2i_2f_infix_test13");
  last_test = "mod_a_i_2i_2f_infix_test13";
  {  // i_2i_2f_infix_test13
    ShAttrib<2, SH_CONST, int> a(int(64), int(-64));
    ShAttrib<2, SH_CONST, float> b(float(64), float(-64));
    ShAttrib<2, SH_CONST, int> expected(int(0), int(0));

    try {
      if (test.run(mod_a_i_2i_2f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_3f_f_infix_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_3f_f_infix_test14.name("mod_a_f_3f_f_infix_test14");
  last_test = "mod_a_f_3f_f_infix_test14";
  {  // f_3f_f_infix_test14
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(5.0), float(2.4));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.4));

    try {
      if (test.run(mod_a_f_3f_f_infix_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_3f_f_infix_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_3f_f_infix_test15.name("mod_a_f_3f_f_infix_test15");
  last_test = "mod_a_f_3f_f_infix_test15";
  {  // f_3f_f_infix_test15
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(5.0), float(2.4));
    ShAttrib<1, SH_CONST, float> b(float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(-0.1));

    try {
      if (test.run(mod_a_f_3f_f_infix_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_f_3f_infix_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_f_3f_infix_test16.name("mod_a_f_f_3f_infix_test16");
  last_test = "mod_a_f_f_3f_infix_test16";
  {  // f_f_3f_infix_test16
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(5.0), float(2.4));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(3.0), float(0.6));

    try {
      if (test.run(mod_a_f_f_3f_infix_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mod_a_f_f_3f_infix_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a % b;
  } SH_END;

  mod_a_f_f_3f_infix_test17.name("mod_a_f_f_3f_infix_test17");
  last_test = "mod_a_f_f_3f_infix_test17";
  {  // f_f_3f_infix_test17
    ShAttrib<1, SH_CONST, float> a(float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(5.0), float(2.4));
    ShAttrib<3, SH_CONST, float> expected(float(-0.0), float(2.0), float(1.8));

    try {
      if (test.run(mod_a_f_f_3f_infix_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_i_2i_2f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, int> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, int> out;
    out = a %= b;
  } SH_END;

  mmod_a_i_2i_2f_infix_test0.name("mmod_a_i_2i_2f_infix_test0");
  last_test = "mmod_a_i_2i_2f_infix_test0";
  {  // i_2i_2f_infix_test0
    ShAttrib<2, SH_CONST, int> a(int(3), int(3));
    ShAttrib<2, SH_CONST, float> b(float(4), float(2));
    ShAttrib<2, SH_CONST, int> expected(int(3), int(1));

    try {
      if (test.run(mmod_a_i_2i_2f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_i_3i_3i_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a %= b;
  } SH_END;

  mmod_a_i_3i_3i_infix_test1.name("mmod_a_i_3i_3i_infix_test1");
  last_test = "mmod_a_i_3i_3i_infix_test1";
  {  // i_3i_3i_infix_test1
    ShAttrib<3, SH_CONST, int> a(int(-3), int(-3), int(-3));
    ShAttrib<3, SH_CONST, int> b(int(4), int(3), int(2));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    try {
      if (test.run(mmod_a_i_3i_3i_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_i_3i_3i_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a %= b;
  } SH_END;

  mmod_a_i_3i_3i_infix_test2.name("mmod_a_i_3i_3i_infix_test2");
  last_test = "mmod_a_i_3i_3i_infix_test2";
  {  // i_3i_3i_infix_test2
    ShAttrib<3, SH_CONST, int> a(int(3), int(3), int(3));
    ShAttrib<3, SH_CONST, int> b(int(-4), int(-3), int(-2));
    ShAttrib<3, SH_CONST, int> expected(int(-1), int(0), int(-1));

    try {
      if (test.run(mmod_a_i_3i_3i_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_i_2i_2f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, int> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, int> out;
    out = a %= b;
  } SH_END;

  mmod_a_i_2i_2f_infix_test3.name("mmod_a_i_2i_2f_infix_test3");
  last_test = "mmod_a_i_2i_2f_infix_test3";
  {  // i_2i_2f_infix_test3
    ShAttrib<2, SH_CONST, int> a(int(-3), int(-3));
    ShAttrib<2, SH_CONST, float> b(float(-4), float(-2));
    ShAttrib<2, SH_CONST, int> expected(int(-3), int(-1));

    try {
      if (test.run(mmod_a_i_2i_2f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_2f_2f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_2f_2f_infix_test4.name("mmod_a_f_2f_2f_infix_test4");
  last_test = "mmod_a_f_2f_2f_infix_test4";
  {  // f_2f_2f_infix_test4
    ShAttrib<2, SH_CONST, float> a(float(3.0), float(3.0));
    ShAttrib<2, SH_CONST, float> b(float(4.0), float(2.0));
    ShAttrib<2, SH_CONST, float> expected(float(3.0), float(1.0));

    try {
      if (test.run(mmod_a_f_2f_2f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_3f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_3f_3f_infix_test5.name("mmod_a_f_3f_3f_infix_test5");
  last_test = "mmod_a_f_3f_3f_infix_test5";
  {  // f_3f_3f_infix_test5
    ShAttrib<3, SH_CONST, float> a(float(-3.0), float(-3.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(-0.0), float(1.0));

    try {
      if (test.run(mmod_a_f_3f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_3f_3f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_3f_3f_infix_test6.name("mmod_a_f_3f_3f_infix_test6");
  last_test = "mmod_a_f_3f_3f_infix_test6";
  {  // f_3f_3f_infix_test6
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(3.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(0.0), float(-1.0));

    try {
      if (test.run(mmod_a_f_3f_3f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_2f_2f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_2f_2f_infix_test7.name("mmod_a_f_2f_2f_infix_test7");
  last_test = "mmod_a_f_2f_2f_infix_test7";
  {  // f_2f_2f_infix_test7
    ShAttrib<2, SH_CONST, float> a(float(-3.0), float(-3.0));
    ShAttrib<2, SH_CONST, float> b(float(-4.0), float(-2.0));
    ShAttrib<2, SH_CONST, float> expected(float(-3.0), float(-1.0));

    try {
      if (test.run(mmod_a_f_2f_2f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_3f_3f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_3f_3f_infix_test8.name("mmod_a_f_3f_3f_infix_test8");
  last_test = "mmod_a_f_3f_3f_infix_test8";
  {  // f_3f_3f_infix_test8
    ShAttrib<3, SH_CONST, float> a(float(3.1), float(3.5), float(3.9));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(3.1), float(0.5), float(1.9));

    try {
      if (test.run(mmod_a_f_3f_3f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_3f_3f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_3f_3f_infix_test9.name("mmod_a_f_3f_3f_infix_test9");
  last_test = "mmod_a_f_3f_3f_infix_test9";
  {  // f_3f_3f_infix_test9
    ShAttrib<3, SH_CONST, float> a(float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.9), float(2.5), float(0.1));

    try {
      if (test.run(mmod_a_f_3f_3f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_3f_3f_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_3f_3f_infix_test10.name("mmod_a_f_3f_3f_infix_test10");
  last_test = "mmod_a_f_3f_3f_infix_test10";
  {  // f_3f_3f_infix_test10
    ShAttrib<3, SH_CONST, float> a(float(3.1), float(3.5), float(3.9));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.9), float(-2.5), float(-0.1));

    try {
      if (test.run(mmod_a_f_3f_3f_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_3f_3f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_3f_3f_infix_test11.name("mmod_a_f_3f_3f_infix_test11");
  last_test = "mmod_a_f_3f_3f_infix_test11";
  {  // f_3f_3f_infix_test11
    ShAttrib<3, SH_CONST, float> a(float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-3.1), float(-0.5), float(-1.9));

    try {
      if (test.run(mmod_a_f_3f_3f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_4f_4f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_4f_4f_infix_test12.name("mmod_a_f_4f_4f_infix_test12");
  last_test = "mmod_a_f_4f_4f_infix_test12";
  {  // f_4f_4f_infix_test12
    ShAttrib<4, SH_CONST, float> a(float(2), float(-2), float(0.5), float(-0.5));
    ShAttrib<4, SH_CONST, float> b(float(2), float(-2), float(0.5), float(-0.5));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0.0), float(-0.0));

    try {
      if (test.run(mmod_a_f_4f_4f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_i_2i_2f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, int> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, int> out;
    out = a %= b;
  } SH_END;

  mmod_a_i_2i_2f_infix_test13.name("mmod_a_i_2i_2f_infix_test13");
  last_test = "mmod_a_i_2i_2f_infix_test13";
  {  // i_2i_2f_infix_test13
    ShAttrib<2, SH_CONST, int> a(int(64), int(-64));
    ShAttrib<2, SH_CONST, float> b(float(64), float(-64));
    ShAttrib<2, SH_CONST, int> expected(int(0), int(0));

    try {
      if (test.run(mmod_a_i_2i_2f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_3f_f_infix_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_3f_f_infix_test14.name("mmod_a_f_3f_f_infix_test14");
  last_test = "mmod_a_f_3f_f_infix_test14";
  {  // f_3f_f_infix_test14
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(5.0), float(2.4));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.4));

    try {
      if (test.run(mmod_a_f_3f_f_infix_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmod_a_f_3f_f_infix_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a %= b;
  } SH_END;

  mmod_a_f_3f_f_infix_test15.name("mmod_a_f_3f_f_infix_test15");
  last_test = "mmod_a_f_3f_f_infix_test15";
  {  // f_3f_f_infix_test15
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(5.0), float(2.4));
    ShAttrib<1, SH_CONST, float> b(float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(-0.1));

    try {
      if (test.run(mmod_a_f_3f_f_infix_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // i_2i_2f_infix_test0
    last_test = "i_2i_2f_infix_test0";
    ShAttrib<2, SH_CONST, int> a(int(3), int(3));
    ShAttrib<2, SH_CONST, float> b(float(4), float(2));
    ShAttrib<2, SH_CONST, int> expected(int(3), int(1));

    ShAttrib<2, SH_TEMP, int> out;
    out = a % b;

    try {
      if (test.check("i_2i_2f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test1
    last_test = "i_3i_3i_infix_test1";
    ShAttrib<3, SH_CONST, int> a(int(-3), int(-3), int(-3));
    ShAttrib<3, SH_CONST, int> b(int(4), int(3), int(2));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a % b;

    try {
      if (test.check("i_3i_3i_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test2
    last_test = "i_3i_3i_infix_test2";
    ShAttrib<3, SH_CONST, int> a(int(3), int(3), int(3));
    ShAttrib<3, SH_CONST, int> b(int(-4), int(-3), int(-2));
    ShAttrib<3, SH_CONST, int> expected(int(-1), int(0), int(-1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a % b;

    try {
      if (test.check("i_3i_3i_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_2i_2f_infix_test3
    last_test = "i_2i_2f_infix_test3";
    ShAttrib<2, SH_CONST, int> a(int(-3), int(-3));
    ShAttrib<2, SH_CONST, float> b(float(-4), float(-2));
    ShAttrib<2, SH_CONST, int> expected(int(-3), int(-1));

    ShAttrib<2, SH_TEMP, int> out;
    out = a % b;

    try {
      if (test.check("i_2i_2f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_infix_test4
    last_test = "f_2f_2f_infix_test4";
    ShAttrib<2, SH_CONST, float> a(float(3.0), float(3.0));
    ShAttrib<2, SH_CONST, float> b(float(4.0), float(2.0));
    ShAttrib<2, SH_CONST, float> expected(float(3.0), float(1.0));

    ShAttrib<2, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_2f_2f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShAttrib<3, SH_CONST, float> a(float(-3.0), float(-3.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(-0.0), float(1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test6
    last_test = "f_3f_3f_infix_test6";
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(3.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(0.0), float(-1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_3f_3f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_infix_test7
    last_test = "f_2f_2f_infix_test7";
    ShAttrib<2, SH_CONST, float> a(float(-3.0), float(-3.0));
    ShAttrib<2, SH_CONST, float> b(float(-4.0), float(-2.0));
    ShAttrib<2, SH_CONST, float> expected(float(-3.0), float(-1.0));

    ShAttrib<2, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_2f_2f_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test8
    last_test = "f_3f_3f_infix_test8";
    ShAttrib<3, SH_CONST, float> a(float(3.1), float(3.5), float(3.9));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(3.1), float(0.5), float(1.9));

    ShAttrib<3, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_3f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test9
    last_test = "f_3f_3f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.9), float(2.5), float(0.1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_3f_3f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test10
    last_test = "f_3f_3f_infix_test10";
    ShAttrib<3, SH_CONST, float> a(float(3.1), float(3.5), float(3.9));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.9), float(-2.5), float(-0.1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_3f_3f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test11
    last_test = "f_3f_3f_infix_test11";
    ShAttrib<3, SH_CONST, float> a(float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-3.1), float(-0.5), float(-1.9));

    ShAttrib<3, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_3f_3f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test12
    last_test = "f_4f_4f_infix_test12";
    ShAttrib<4, SH_CONST, float> a(float(2), float(-2), float(0.5), float(-0.5));
    ShAttrib<4, SH_CONST, float> b(float(2), float(-2), float(0.5), float(-0.5));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0.0), float(-0.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_4f_4f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_2i_2f_infix_test13
    last_test = "i_2i_2f_infix_test13";
    ShAttrib<2, SH_CONST, int> a(int(64), int(-64));
    ShAttrib<2, SH_CONST, float> b(float(64), float(-64));
    ShAttrib<2, SH_CONST, int> expected(int(0), int(0));

    ShAttrib<2, SH_TEMP, int> out;
    out = a % b;

    try {
      if (test.check("i_2i_2f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test14
    last_test = "f_3f_f_infix_test14";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(5.0), float(2.4));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.4));

    ShAttrib<3, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_3f_f_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test15
    last_test = "f_3f_f_infix_test15";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(5.0), float(2.4));
    ShAttrib<1, SH_CONST, float> b(float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(-0.1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_3f_f_infix_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test16
    last_test = "f_f_3f_infix_test16";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(5.0), float(2.4));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(3.0), float(0.6));

    ShAttrib<3, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_f_3f_infix_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test17
    last_test = "f_f_3f_infix_test17";
    ShAttrib<1, SH_CONST, float> a(float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(5.0), float(2.4));
    ShAttrib<3, SH_CONST, float> expected(float(-0.0), float(2.0), float(1.8));

    ShAttrib<3, SH_TEMP, float> out;
    out = a % b;

    try {
      if (test.check("f_f_3f_infix_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_2i_2f_infix_test0
    last_test = "i_2i_2f_infix_test0";
    ShAttrib<2, SH_CONST, int> a(int(3), int(3));
    ShAttrib<2, SH_CONST, float> b(float(4), float(2));
    ShAttrib<2, SH_CONST, int> expected(int(3), int(1));

    ShAttrib<2, SH_TEMP, int> out;
    out = a %= b;

    try {
      if (test.check("i_2i_2f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test1
    last_test = "i_3i_3i_infix_test1";
    ShAttrib<3, SH_CONST, int> a(int(-3), int(-3), int(-3));
    ShAttrib<3, SH_CONST, int> b(int(4), int(3), int(2));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a %= b;

    try {
      if (test.check("i_3i_3i_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test2
    last_test = "i_3i_3i_infix_test2";
    ShAttrib<3, SH_CONST, int> a(int(3), int(3), int(3));
    ShAttrib<3, SH_CONST, int> b(int(-4), int(-3), int(-2));
    ShAttrib<3, SH_CONST, int> expected(int(-1), int(0), int(-1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a %= b;

    try {
      if (test.check("i_3i_3i_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_2i_2f_infix_test3
    last_test = "i_2i_2f_infix_test3";
    ShAttrib<2, SH_CONST, int> a(int(-3), int(-3));
    ShAttrib<2, SH_CONST, float> b(float(-4), float(-2));
    ShAttrib<2, SH_CONST, int> expected(int(-3), int(-1));

    ShAttrib<2, SH_TEMP, int> out;
    out = a %= b;

    try {
      if (test.check("i_2i_2f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_infix_test4
    last_test = "f_2f_2f_infix_test4";
    ShAttrib<2, SH_CONST, float> a(float(3.0), float(3.0));
    ShAttrib<2, SH_CONST, float> b(float(4.0), float(2.0));
    ShAttrib<2, SH_CONST, float> expected(float(3.0), float(1.0));

    ShAttrib<2, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_2f_2f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShAttrib<3, SH_CONST, float> a(float(-3.0), float(-3.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(-0.0), float(1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test6
    last_test = "f_3f_3f_infix_test6";
    ShAttrib<3, SH_CONST, float> a(float(3.0), float(3.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(0.0), float(-1.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_3f_3f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_infix_test7
    last_test = "f_2f_2f_infix_test7";
    ShAttrib<2, SH_CONST, float> a(float(-3.0), float(-3.0));
    ShAttrib<2, SH_CONST, float> b(float(-4.0), float(-2.0));
    ShAttrib<2, SH_CONST, float> expected(float(-3.0), float(-1.0));

    ShAttrib<2, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_2f_2f_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test8
    last_test = "f_3f_3f_infix_test8";
    ShAttrib<3, SH_CONST, float> a(float(3.1), float(3.5), float(3.9));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(3.1), float(0.5), float(1.9));

    ShAttrib<3, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_3f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test9
    last_test = "f_3f_3f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<3, SH_CONST, float> b(float(4.0), float(3.0), float(2.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.9), float(2.5), float(0.1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_3f_3f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test10
    last_test = "f_3f_3f_infix_test10";
    ShAttrib<3, SH_CONST, float> a(float(3.1), float(3.5), float(3.9));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-0.9), float(-2.5), float(-0.1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_3f_3f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test11
    last_test = "f_3f_3f_infix_test11";
    ShAttrib<3, SH_CONST, float> a(float(-3.1), float(-3.5), float(-3.9));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-3.0), float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(-3.1), float(-0.5), float(-1.9));

    ShAttrib<3, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_3f_3f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test12
    last_test = "f_4f_4f_infix_test12";
    ShAttrib<4, SH_CONST, float> a(float(2), float(-2), float(0.5), float(-0.5));
    ShAttrib<4, SH_CONST, float> b(float(2), float(-2), float(0.5), float(-0.5));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(0.0), float(-0.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_4f_4f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_2i_2f_infix_test13
    last_test = "i_2i_2f_infix_test13";
    ShAttrib<2, SH_CONST, int> a(int(64), int(-64));
    ShAttrib<2, SH_CONST, float> b(float(64), float(-64));
    ShAttrib<2, SH_CONST, int> expected(int(0), int(0));

    ShAttrib<2, SH_TEMP, int> out;
    out = a %= b;

    try {
      if (test.check("i_2i_2f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test14
    last_test = "f_3f_f_infix_test14";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(5.0), float(2.4));
    ShAttrib<1, SH_CONST, float> b(float(0.5));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.4));

    ShAttrib<3, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_3f_f_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test15
    last_test = "f_3f_f_infix_test15";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(5.0), float(2.4));
    ShAttrib<1, SH_CONST, float> b(float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(-0.1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a %= b;

    try {
      if (test.check("f_3f_f_infix_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

