#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram mul_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a * b;
  } SH_END;

  mul_a_f_3f_3f_infix_test0.name("mul_a_f_3f_3f_infix_test0");
  last_test = "mul_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(4.0), float(10.0));

    try {
      if (test.run(mul_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_f_3f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a * b;
  } SH_END;

  mul_a_f_3f_1f_infix_test1.name("mul_a_f_3f_1f_infix_test1");
  last_test = "mul_a_f_3f_1f_infix_test1";
  {  // f_3f_1f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<3, SH_CONST, float> expected(float(7.0), float(14.0), float(21.0));

    try {
      if (test.run(mul_a_f_3f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_f_1f_1f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a * b;
  } SH_END;

  mul_a_f_1f_1f_infix_test2.name("mul_a_f_1f_1f_infix_test2");
  last_test = "mul_a_f_1f_1f_infix_test2";
  {  // f_1f_1f_infix_test2
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> expected(float(7.0));

    try {
      if (test.run(mul_a_f_1f_1f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a * b;
  } SH_END;

  mul_a_f_3f_3f_infix_test3.name("mul_a_f_3f_3f_infix_test3");
  last_test = "mul_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-16.0), float(-25.0), float(-36.0));

    try {
      if (test.run(mul_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_i_3i_3i_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a * b;
  } SH_END;

  mul_a_i_3i_3i_infix_test4.name("mul_a_i_3i_3i_infix_test4");
  last_test = "mul_a_i_3i_3i_infix_test4";
  {  // i_3i_3i_infix_test4
    ShAttrib<3, SH_CONST, int> a(int(0.0), int(1.0), int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(3.0), int(4.0), int(5.0));
    ShAttrib<3, SH_CONST, int> expected(int(0.0), int(4.0), int(10.0));

    try {
      if (test.run(mul_a_i_3i_3i_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_i_3i_1i_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a * b;
  } SH_END;

  mul_a_i_3i_1i_infix_test5.name("mul_a_i_3i_1i_infix_test5");
  last_test = "mul_a_i_3i_1i_infix_test5";
  {  // i_3i_1i_infix_test5
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<1, SH_CONST, int> b(int(7.0));
    ShAttrib<3, SH_CONST, int> expected(int(7.0), int(14.0), int(21.0));

    try {
      if (test.run(mul_a_i_3i_1i_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_i_1i_1i_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a * b;
  } SH_END;

  mul_a_i_1i_1i_infix_test6.name("mul_a_i_1i_1i_infix_test6");
  last_test = "mul_a_i_1i_1i_infix_test6";
  {  // i_1i_1i_infix_test6
    ShAttrib<1, SH_CONST, int> a(int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(7.0));
    ShAttrib<1, SH_CONST, int> expected(int(7.0));

    try {
      if (test.run(mul_a_i_1i_1i_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_i_3i_3i_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a * b;
  } SH_END;

  mul_a_i_3i_3i_infix_test7.name("mul_a_i_3i_3i_infix_test7");
  last_test = "mul_a_i_3i_3i_infix_test7";
  {  // i_3i_3i_infix_test7
    ShAttrib<3, SH_CONST, int> a(int(4.0), int(5.0), int(6.0));
    ShAttrib<3, SH_CONST, int> b(int(-4.0), int(-5.0), int(-6.0));
    ShAttrib<3, SH_CONST, int> expected(int(-16.0), int(-25.0), int(-36.0));

    try {
      if (test.run(mul_a_i_3i_3i_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_f_1f_3f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a * b;
  } SH_END;

  mul_a_f_1f_3f_infix_test8.name("mul_a_f_1f_3f_infix_test8");
  last_test = "mul_a_f_1f_3f_infix_test8";
  {  // f_1f_3f_infix_test8
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(3.0), float(4.0), float(5.0));

    try {
      if (test.run(mul_a_f_1f_3f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_f_f_3f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a * b;
  } SH_END;

  mul_a_f_f_3f_infix_test9.name("mul_a_f_f_3f_infix_test9");
  last_test = "mul_a_f_f_3f_infix_test9";
  {  // f_f_3f_infix_test9
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<3, SH_CONST, float> b(float(10.0), float(56.0), float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(5.0), float(28.0), float(-0.25));

    try {
      if (test.run(mul_a_f_f_3f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_f_f_3f_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a * b;
  } SH_END;

  mul_a_f_f_3f_infix_test10.name("mul_a_f_f_3f_infix_test10");
  last_test = "mul_a_f_f_3f_infix_test10";
  {  // f_f_3f_infix_test10
    ShAttrib<1, SH_CONST, float> a(float(2.3));
    ShAttrib<3, SH_CONST, float> b(float(10.0), float(56.0), float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(23.0), float(128.8), float(-1.15));

    try {
      if (test.run(mul_a_f_f_3f_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_f_f_3f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a * b;
  } SH_END;

  mul_a_f_f_3f_infix_test11.name("mul_a_f_f_3f_infix_test11");
  last_test = "mul_a_f_f_3f_infix_test11";
  {  // f_f_3f_infix_test11
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(10.0), float(56.0), float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(-0.0));

    try {
      if (test.run(mul_a_f_f_3f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_f_3f_f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a * b;
  } SH_END;

  mul_a_f_3f_f_infix_test12.name("mul_a_f_3f_f_infix_test12");
  last_test = "mul_a_f_3f_f_infix_test12";
  {  // f_3f_f_infix_test12
    ShAttrib<3, SH_CONST, float> a(float(10.0), float(56.0), float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(-0.1));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-5.6), float(0.05));

    try {
      if (test.run(mul_a_f_3f_f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mul_a_f_3f_f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a * b;
  } SH_END;

  mul_a_f_3f_f_infix_test13.name("mul_a_f_3f_f_infix_test13");
  last_test = "mul_a_f_3f_f_infix_test13";
  {  // f_3f_f_infix_test13
    ShAttrib<3, SH_CONST, float> a(float(10.0), float(56.0), float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(-1.4));
    ShAttrib<3, SH_CONST, float> expected(float(-14.0), float(-78.4), float(0.7));

    try {
      if (test.run(mul_a_f_3f_f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmul_a_f_3f_3f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a *= b;
  } SH_END;

  mmul_a_f_3f_3f_infix_test0.name("mmul_a_f_3f_3f_infix_test0");
  last_test = "mmul_a_f_3f_3f_infix_test0";
  {  // f_3f_3f_infix_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(4.0), float(10.0));

    try {
      if (test.run(mmul_a_f_3f_3f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmul_a_f_3f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a *= b;
  } SH_END;

  mmul_a_f_3f_1f_infix_test1.name("mmul_a_f_3f_1f_infix_test1");
  last_test = "mmul_a_f_3f_1f_infix_test1";
  {  // f_3f_1f_infix_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<3, SH_CONST, float> expected(float(7.0), float(14.0), float(21.0));

    try {
      if (test.run(mmul_a_f_3f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmul_a_f_1f_1f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a *= b;
  } SH_END;

  mmul_a_f_1f_1f_infix_test2.name("mmul_a_f_1f_1f_infix_test2");
  last_test = "mmul_a_f_1f_1f_infix_test2";
  {  // f_1f_1f_infix_test2
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> expected(float(7.0));

    try {
      if (test.run(mmul_a_f_1f_1f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmul_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a *= b;
  } SH_END;

  mmul_a_f_3f_3f_infix_test3.name("mmul_a_f_3f_3f_infix_test3");
  last_test = "mmul_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-16.0), float(-25.0), float(-36.0));

    try {
      if (test.run(mmul_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmul_a_i_3i_3i_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a *= b;
  } SH_END;

  mmul_a_i_3i_3i_infix_test4.name("mmul_a_i_3i_3i_infix_test4");
  last_test = "mmul_a_i_3i_3i_infix_test4";
  {  // i_3i_3i_infix_test4
    ShAttrib<3, SH_CONST, int> a(int(0.0), int(1.0), int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(3.0), int(4.0), int(5.0));
    ShAttrib<3, SH_CONST, int> expected(int(0.0), int(4.0), int(10.0));

    try {
      if (test.run(mmul_a_i_3i_3i_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmul_a_i_3i_1i_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a *= b;
  } SH_END;

  mmul_a_i_3i_1i_infix_test5.name("mmul_a_i_3i_1i_infix_test5");
  last_test = "mmul_a_i_3i_1i_infix_test5";
  {  // i_3i_1i_infix_test5
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<1, SH_CONST, int> b(int(7.0));
    ShAttrib<3, SH_CONST, int> expected(int(7.0), int(14.0), int(21.0));

    try {
      if (test.run(mmul_a_i_3i_1i_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmul_a_i_1i_1i_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a *= b;
  } SH_END;

  mmul_a_i_1i_1i_infix_test6.name("mmul_a_i_1i_1i_infix_test6");
  last_test = "mmul_a_i_1i_1i_infix_test6";
  {  // i_1i_1i_infix_test6
    ShAttrib<1, SH_CONST, int> a(int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(7.0));
    ShAttrib<1, SH_CONST, int> expected(int(7.0));

    try {
      if (test.run(mmul_a_i_1i_1i_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmul_a_i_3i_3i_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a *= b;
  } SH_END;

  mmul_a_i_3i_3i_infix_test7.name("mmul_a_i_3i_3i_infix_test7");
  last_test = "mmul_a_i_3i_3i_infix_test7";
  {  // i_3i_3i_infix_test7
    ShAttrib<3, SH_CONST, int> a(int(4.0), int(5.0), int(6.0));
    ShAttrib<3, SH_CONST, int> b(int(-4.0), int(-5.0), int(-6.0));
    ShAttrib<3, SH_CONST, int> expected(int(-16.0), int(-25.0), int(-36.0));

    try {
      if (test.run(mmul_a_i_3i_3i_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmul_a_f_3f_f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a *= b;
  } SH_END;

  mmul_a_f_3f_f_infix_test8.name("mmul_a_f_3f_f_infix_test8");
  last_test = "mmul_a_f_3f_f_infix_test8";
  {  // f_3f_f_infix_test8
    ShAttrib<3, SH_CONST, float> a(float(10.0), float(56.0), float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(-0.1));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-5.6), float(0.05));

    try {
      if (test.run(mmul_a_f_3f_f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram mmul_a_f_3f_f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a *= b;
  } SH_END;

  mmul_a_f_3f_f_infix_test9.name("mmul_a_f_3f_f_infix_test9");
  last_test = "mmul_a_f_3f_f_infix_test9";
  {  // f_3f_f_infix_test9
    ShAttrib<3, SH_CONST, float> a(float(10.0), float(56.0), float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(-1.4));
    ShAttrib<3, SH_CONST, float> expected(float(-14.0), float(-78.4), float(0.7));

    try {
      if (test.run(mmul_a_f_3f_f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(4.0), float(10.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_1f_infix_test1
    last_test = "f_3f_1f_infix_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<3, SH_CONST, float> expected(float(7.0), float(14.0), float(21.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test2
    last_test = "f_1f_1f_infix_test2";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> expected(float(7.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_1f_1f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-16.0), float(-25.0), float(-36.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test4
    last_test = "i_3i_3i_infix_test4";
    ShAttrib<3, SH_CONST, int> a(int(0.0), int(1.0), int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(3.0), int(4.0), int(5.0));
    ShAttrib<3, SH_CONST, int> expected(int(0.0), int(4.0), int(10.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a * b;

    try {
      if (test.check("i_3i_3i_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_1i_infix_test5
    last_test = "i_3i_1i_infix_test5";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<1, SH_CONST, int> b(int(7.0));
    ShAttrib<3, SH_CONST, int> expected(int(7.0), int(14.0), int(21.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a * b;

    try {
      if (test.check("i_3i_1i_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1i_1i_infix_test6
    last_test = "i_1i_1i_infix_test6";
    ShAttrib<1, SH_CONST, int> a(int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(7.0));
    ShAttrib<1, SH_CONST, int> expected(int(7.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a * b;

    try {
      if (test.check("i_1i_1i_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test7
    last_test = "i_3i_3i_infix_test7";
    ShAttrib<3, SH_CONST, int> a(int(4.0), int(5.0), int(6.0));
    ShAttrib<3, SH_CONST, int> b(int(-4.0), int(-5.0), int(-6.0));
    ShAttrib<3, SH_CONST, int> expected(int(-16.0), int(-25.0), int(-36.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a * b;

    try {
      if (test.check("i_3i_3i_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_3f_infix_test8
    last_test = "f_1f_3f_infix_test8";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(3.0), float(4.0), float(5.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_1f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test9
    last_test = "f_f_3f_infix_test9";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<3, SH_CONST, float> b(float(10.0), float(56.0), float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(5.0), float(28.0), float(-0.25));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_f_3f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test10
    last_test = "f_f_3f_infix_test10";
    ShAttrib<1, SH_CONST, float> a(float(2.3));
    ShAttrib<3, SH_CONST, float> b(float(10.0), float(56.0), float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(23.0), float(128.8), float(-1.15));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_f_3f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test11
    last_test = "f_f_3f_infix_test11";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(10.0), float(56.0), float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(-0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_f_3f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test12
    last_test = "f_3f_f_infix_test12";
    ShAttrib<3, SH_CONST, float> a(float(10.0), float(56.0), float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(-0.1));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-5.6), float(0.05));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test13
    last_test = "f_3f_f_infix_test13";
    ShAttrib<3, SH_CONST, float> a(float(10.0), float(56.0), float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(-1.4));
    ShAttrib<3, SH_CONST, float> expected(float(-14.0), float(-78.4), float(0.7));

    ShAttrib<3, SH_TEMP, float> out;
    out = a * b;

    try {
      if (test.check("f_3f_f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test0
    last_test = "f_3f_3f_infix_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(1.0), float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(3.0), float(4.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(4.0), float(10.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_3f_3f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_1f_infix_test1
    last_test = "f_3f_1f_infix_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<3, SH_CONST, float> expected(float(7.0), float(14.0), float(21.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_3f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test2
    last_test = "f_1f_1f_infix_test2";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(7.0));
    ShAttrib<1, SH_CONST, float> expected(float(7.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_1f_1f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(4.0), float(5.0), float(6.0));
    ShAttrib<3, SH_CONST, float> b(float(-4.0), float(-5.0), float(-6.0));
    ShAttrib<3, SH_CONST, float> expected(float(-16.0), float(-25.0), float(-36.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test4
    last_test = "i_3i_3i_infix_test4";
    ShAttrib<3, SH_CONST, int> a(int(0.0), int(1.0), int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(3.0), int(4.0), int(5.0));
    ShAttrib<3, SH_CONST, int> expected(int(0.0), int(4.0), int(10.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a *= b;

    try {
      if (test.check("i_3i_3i_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_1i_infix_test5
    last_test = "i_3i_1i_infix_test5";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<1, SH_CONST, int> b(int(7.0));
    ShAttrib<3, SH_CONST, int> expected(int(7.0), int(14.0), int(21.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a *= b;

    try {
      if (test.check("i_3i_1i_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1i_1i_infix_test6
    last_test = "i_1i_1i_infix_test6";
    ShAttrib<1, SH_CONST, int> a(int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(7.0));
    ShAttrib<1, SH_CONST, int> expected(int(7.0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a *= b;

    try {
      if (test.check("i_1i_1i_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test7
    last_test = "i_3i_3i_infix_test7";
    ShAttrib<3, SH_CONST, int> a(int(4.0), int(5.0), int(6.0));
    ShAttrib<3, SH_CONST, int> b(int(-4.0), int(-5.0), int(-6.0));
    ShAttrib<3, SH_CONST, int> expected(int(-16.0), int(-25.0), int(-36.0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a *= b;

    try {
      if (test.check("i_3i_3i_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test8
    last_test = "f_3f_f_infix_test8";
    ShAttrib<3, SH_CONST, float> a(float(10.0), float(56.0), float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(-0.1));
    ShAttrib<3, SH_CONST, float> expected(float(-1.0), float(-5.6), float(0.05));

    ShAttrib<3, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_3f_f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test9
    last_test = "f_3f_f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(10.0), float(56.0), float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(-1.4));
    ShAttrib<3, SH_CONST, float> expected(float(-14.0), float(-78.4), float(0.7));

    ShAttrib<3, SH_TEMP, float> out;
    out = a *= b;

    try {
      if (test.check("f_3f_f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

