#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram poly_a_f_1f_1f_callpoly_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_1f_1f_callpoly_test0.name("poly_a_f_1f_1f_callpoly_test0");
  last_test = "poly_a_f_1f_1f_callpoly_test0";
  {  // f_1f_1f_callpoly_test0
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(poly_a_f_1f_1f_callpoly_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_2f_2f_callpoly_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_2f_2f_callpoly_test1.name("poly_a_f_2f_2f_callpoly_test1");
  last_test = "poly_a_f_2f_2f_callpoly_test1";
  {  // f_2f_2f_callpoly_test1
    ShAttrib<2, SH_CONST, float> a(float(0.0), float(0.0));
    ShAttrib<2, SH_CONST, float> b(float(0), float(0));
    ShAttrib<2, SH_CONST, float> expected(float(0.0), float(0.0));

    try {
      if (test.run(poly_a_f_2f_2f_callpoly_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_3f_3f_callpoly_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_3f_3f_callpoly_test2.name("poly_a_f_3f_3f_callpoly_test2");
  last_test = "poly_a_f_3f_3f_callpoly_test2";
  {  // f_3f_3f_callpoly_test2
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(poly_a_f_3f_3f_callpoly_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_4f_4f_callpoly_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_4f_4f_callpoly_test3.name("poly_a_f_4f_4f_callpoly_test3");
  last_test = "poly_a_f_4f_4f_callpoly_test3";
  {  // f_4f_4f_callpoly_test3
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(poly_a_f_4f_4f_callpoly_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_1f_1f_callpoly_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_1f_1f_callpoly_test4.name("poly_a_f_1f_1f_callpoly_test4");
  last_test = "poly_a_f_1f_1f_callpoly_test4";
  {  // f_1f_1f_callpoly_test4
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(poly_a_f_1f_1f_callpoly_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_2f_2f_callpoly_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_2f_2f_callpoly_test5.name("poly_a_f_2f_2f_callpoly_test5");
  last_test = "poly_a_f_2f_2f_callpoly_test5";
  {  // f_2f_2f_callpoly_test5
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<2, SH_CONST, float> b(float(0), float(0));
    ShAttrib<2, SH_CONST, float> expected(float(0.0), float(0.0));

    try {
      if (test.run(poly_a_f_2f_2f_callpoly_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_3f_3f_callpoly_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_3f_3f_callpoly_test6.name("poly_a_f_3f_3f_callpoly_test6");
  last_test = "poly_a_f_3f_3f_callpoly_test6";
  {  // f_3f_3f_callpoly_test6
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(poly_a_f_3f_3f_callpoly_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_4f_4f_callpoly_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_4f_4f_callpoly_test7.name("poly_a_f_4f_4f_callpoly_test7");
  last_test = "poly_a_f_4f_4f_callpoly_test7";
  {  // f_4f_4f_callpoly_test7
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(poly_a_f_4f_4f_callpoly_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_1f_1f_callpoly_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_1f_1f_callpoly_test8.name("poly_a_f_1f_1f_callpoly_test8");
  last_test = "poly_a_f_1f_1f_callpoly_test8";
  {  // f_1f_1f_callpoly_test8
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(poly_a_f_1f_1f_callpoly_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_2f_1f_callpoly_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_2f_1f_callpoly_test9.name("poly_a_f_2f_1f_callpoly_test9");
  last_test = "poly_a_f_2f_1f_callpoly_test9";
  {  // f_2f_1f_callpoly_test9
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(2));
    ShAttrib<2, SH_CONST, float> expected(float(2.0), float(2.0));

    try {
      if (test.run(poly_a_f_2f_1f_callpoly_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_3f_4f_callpoly_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_3f_4f_callpoly_test10.name("poly_a_f_3f_4f_callpoly_test10");
  last_test = "poly_a_f_3f_4f_callpoly_test10";
  {  // f_3f_4f_callpoly_test10
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(3), float(0), float(0), float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(2.5), float(-1.0), float(-10.5));

    try {
      if (test.run(poly_a_f_3f_4f_callpoly_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_4f_3f_callpoly_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_4f_3f_callpoly_test11.name("poly_a_f_4f_3f_callpoly_test11");
  last_test = "poly_a_f_4f_3f_callpoly_test11";
  {  // f_4f_3f_callpoly_test11
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(-10), float(1));
    ShAttrib<4, SH_CONST, float> expected(float(-5.0), float(-12.0), float(-17.0), float(-20.0));

    try {
      if (test.run(poly_a_f_4f_3f_callpoly_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_1f_4f_callpoly_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_1f_4f_callpoly_test12.name("poly_a_f_1f_4f_callpoly_test12");
  last_test = "poly_a_f_1f_4f_callpoly_test12";
  {  // f_1f_4f_callpoly_test12
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(1), float(4), float(5), float(35.2));
    ShAttrib<1, SH_CONST, float> expected(float(45.2));

    try {
      if (test.run(poly_a_f_1f_4f_callpoly_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_2f_1f_callpoly_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_2f_1f_callpoly_test13.name("poly_a_f_2f_1f_callpoly_test13");
  last_test = "poly_a_f_2f_1f_callpoly_test13";
  {  // f_2f_1f_callpoly_test13
    ShAttrib<2, SH_CONST, float> a(float(-10.0), float(0.2));
    ShAttrib<1, SH_CONST, float> b(float(0.3));
    ShAttrib<2, SH_CONST, float> expected(float(0.3), float(0.3));

    try {
      if (test.run(poly_a_f_2f_1f_callpoly_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_4f_3f_callpoly_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_4f_3f_callpoly_test14.name("poly_a_f_4f_3f_callpoly_test14");
  last_test = "poly_a_f_4f_3f_callpoly_test14";
  {  // f_4f_3f_callpoly_test14
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(-0.2), float(13.0), float(42));
    ShAttrib<3, SH_CONST, float> b(float(1), float(-1), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0.5), float(1.2), float(-12.0), float(-41));

    try {
      if (test.run(poly_a_f_4f_3f_callpoly_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_1f_2f_callpoly_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_1f_2f_callpoly_test15.name("poly_a_f_1f_2f_callpoly_test15");
  last_test = "poly_a_f_1f_2f_callpoly_test15";
  {  // f_1f_2f_callpoly_test15
    ShAttrib<1, SH_CONST, float> a(float(1));
    ShAttrib<2, SH_CONST, float> b(float(-1), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(-1));

    try {
      if (test.run(poly_a_f_1f_2f_callpoly_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_1f_2f_callpoly_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_1f_2f_callpoly_test16.name("poly_a_f_1f_2f_callpoly_test16");
  last_test = "poly_a_f_1f_2f_callpoly_test16";
  {  // f_1f_2f_callpoly_test16
    ShAttrib<1, SH_CONST, float> a(float(0.4));
    ShAttrib<2, SH_CONST, float> b(float(-1), float(4));
    ShAttrib<1, SH_CONST, float> expected(float(0.6));

    try {
      if (test.run(poly_a_f_1f_2f_callpoly_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_2f_4f_callpoly_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_2f_4f_callpoly_test17.name("poly_a_f_2f_4f_callpoly_test17");
  last_test = "poly_a_f_2f_4f_callpoly_test17";
  {  // f_2f_4f_callpoly_test17
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(-0.2));
    ShAttrib<4, SH_CONST, float> b(float(1), float(4), float(5), float(35.2));
    ShAttrib<2, SH_CONST, float> expected(float(45.2), float(0.1184));

    try {
      if (test.run(poly_a_f_2f_4f_callpoly_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_2f_1f_callpoly_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_2f_1f_callpoly_test18.name("poly_a_f_2f_1f_callpoly_test18");
  last_test = "poly_a_f_2f_1f_callpoly_test18";
  {  // f_2f_1f_callpoly_test18
    ShAttrib<2, SH_CONST, float> a(float(-10.0), float(0.2));
    ShAttrib<1, SH_CONST, float> b(float(0.3));
    ShAttrib<2, SH_CONST, float> expected(float(0.3), float(0.3));

    try {
      if (test.run(poly_a_f_2f_1f_callpoly_test18, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_2f_2f_callpoly_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_2f_2f_callpoly_test19.name("poly_a_f_2f_2f_callpoly_test19");
  last_test = "poly_a_f_2f_2f_callpoly_test19";
  {  // f_2f_2f_callpoly_test19
    ShAttrib<2, SH_CONST, float> a(float(-10.0), float(0.2));
    ShAttrib<2, SH_CONST, float> b(float(0.3), float(20));
    ShAttrib<2, SH_CONST, float> expected(float(-199.7), float(4.3));

    try {
      if (test.run(poly_a_f_2f_2f_callpoly_test19, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_4f_2f_callpoly_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_4f_2f_callpoly_test20.name("poly_a_f_4f_2f_callpoly_test20");
  last_test = "poly_a_f_4f_2f_callpoly_test20";
  {  // f_4f_2f_callpoly_test20
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(-0.2), float(13.0), float(42));
    ShAttrib<2, SH_CONST, float> b(float(1), float(-1));
    ShAttrib<4, SH_CONST, float> expected(float(0.5), float(1.2), float(-12.0), float(-41));

    try {
      if (test.run(poly_a_f_4f_2f_callpoly_test20, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_4f_2f_callpoly_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_4f_2f_callpoly_test21.name("poly_a_f_4f_2f_callpoly_test21");
  last_test = "poly_a_f_4f_2f_callpoly_test21";
  {  // f_4f_2f_callpoly_test21
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<2, SH_CONST, float> b(float(4), float(-10));
    ShAttrib<4, SH_CONST, float> expected(float(-6.0), float(-16.0), float(-26.0), float(-36.0));

    try {
      if (test.run(poly_a_f_4f_2f_callpoly_test21, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_3f_2f_callpoly_test22 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_3f_2f_callpoly_test22.name("poly_a_f_3f_2f_callpoly_test22");
  last_test = "poly_a_f_3f_2f_callpoly_test22";
  {  // f_3f_2f_callpoly_test22
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<2, SH_CONST, float> b(float(4), float(-10));
    ShAttrib<3, SH_CONST, float> expected(float(-6.0), float(-16.0), float(-26.0));

    try {
      if (test.run(poly_a_f_3f_2f_callpoly_test22, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram poly_a_f_2f_2f_callpoly_test23 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<2, SH_INPUT, float> a;
    ShAttrib<2, SH_INPUT, float> b;
    ShAttrib<2, SH_OUTPUT, float> out;
    out = poly(a, b);
  } SH_END;

  poly_a_f_2f_2f_callpoly_test23.name("poly_a_f_2f_2f_callpoly_test23");
  last_test = "poly_a_f_2f_2f_callpoly_test23";
  {  // f_2f_2f_callpoly_test23
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<2, SH_CONST, float> b(float(4), float(-10));
    ShAttrib<2, SH_CONST, float> expected(float(-6.0), float(-16.0));

    try {
      if (test.run(poly_a_f_2f_2f_callpoly_test23, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_1f_1f_callpoly_test0
    last_test = "f_1f_1f_callpoly_test0";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_1f_1f_callpoly_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_callpoly_test1
    last_test = "f_2f_2f_callpoly_test1";
    ShAttrib<2, SH_CONST, float> a(float(0.0), float(0.0));
    ShAttrib<2, SH_CONST, float> b(float(0), float(0));
    ShAttrib<2, SH_CONST, float> expected(float(0.0), float(0.0));

    ShAttrib<2, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_2f_2f_callpoly_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_callpoly_test2
    last_test = "f_3f_3f_callpoly_test2";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_3f_3f_callpoly_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callpoly_test3
    last_test = "f_4f_4f_callpoly_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0), float(0.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_4f_4f_callpoly_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_callpoly_test4
    last_test = "f_1f_1f_callpoly_test4";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_1f_1f_callpoly_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_callpoly_test5
    last_test = "f_2f_2f_callpoly_test5";
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<2, SH_CONST, float> b(float(0), float(0));
    ShAttrib<2, SH_CONST, float> expected(float(0.0), float(0.0));

    ShAttrib<2, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_2f_2f_callpoly_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_callpoly_test6
    last_test = "f_3f_3f_callpoly_test6";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_3f_3f_callpoly_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callpoly_test7
    last_test = "f_4f_4f_callpoly_test7";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0), float(0.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_4f_4f_callpoly_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_callpoly_test8
    last_test = "f_1f_1f_callpoly_test8";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_1f_1f_callpoly_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_1f_callpoly_test9
    last_test = "f_2f_1f_callpoly_test9";
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<1, SH_CONST, float> b(float(2));
    ShAttrib<2, SH_CONST, float> expected(float(2.0), float(2.0));

    ShAttrib<2, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_2f_1f_callpoly_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_4f_callpoly_test10
    last_test = "f_3f_4f_callpoly_test10";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(3), float(0), float(0), float(-0.5));
    ShAttrib<3, SH_CONST, float> expected(float(2.5), float(-1.0), float(-10.5));

    ShAttrib<3, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_3f_4f_callpoly_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_3f_callpoly_test11
    last_test = "f_4f_3f_callpoly_test11";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(-10), float(1));
    ShAttrib<4, SH_CONST, float> expected(float(-5.0), float(-12.0), float(-17.0), float(-20.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_4f_3f_callpoly_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_4f_callpoly_test12
    last_test = "f_1f_4f_callpoly_test12";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(1), float(4), float(5), float(35.2));
    ShAttrib<1, SH_CONST, float> expected(float(45.2));

    ShAttrib<1, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_1f_4f_callpoly_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_1f_callpoly_test13
    last_test = "f_2f_1f_callpoly_test13";
    ShAttrib<2, SH_CONST, float> a(float(-10.0), float(0.2));
    ShAttrib<1, SH_CONST, float> b(float(0.3));
    ShAttrib<2, SH_CONST, float> expected(float(0.3), float(0.3));

    ShAttrib<2, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_2f_1f_callpoly_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_3f_callpoly_test14
    last_test = "f_4f_3f_callpoly_test14";
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(-0.2), float(13.0), float(42));
    ShAttrib<3, SH_CONST, float> b(float(1), float(-1), float(0));
    ShAttrib<4, SH_CONST, float> expected(float(0.5), float(1.2), float(-12.0), float(-41));

    ShAttrib<4, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_4f_3f_callpoly_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_2f_callpoly_test15
    last_test = "f_1f_2f_callpoly_test15";
    ShAttrib<1, SH_CONST, float> a(float(1));
    ShAttrib<2, SH_CONST, float> b(float(-1), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(-1));

    ShAttrib<1, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_1f_2f_callpoly_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_2f_callpoly_test16
    last_test = "f_1f_2f_callpoly_test16";
    ShAttrib<1, SH_CONST, float> a(float(0.4));
    ShAttrib<2, SH_CONST, float> b(float(-1), float(4));
    ShAttrib<1, SH_CONST, float> expected(float(0.6));

    ShAttrib<1, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_1f_2f_callpoly_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_4f_callpoly_test17
    last_test = "f_2f_4f_callpoly_test17";
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(-0.2));
    ShAttrib<4, SH_CONST, float> b(float(1), float(4), float(5), float(35.2));
    ShAttrib<2, SH_CONST, float> expected(float(45.2), float(0.1184));

    ShAttrib<2, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_2f_4f_callpoly_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_1f_callpoly_test18
    last_test = "f_2f_1f_callpoly_test18";
    ShAttrib<2, SH_CONST, float> a(float(-10.0), float(0.2));
    ShAttrib<1, SH_CONST, float> b(float(0.3));
    ShAttrib<2, SH_CONST, float> expected(float(0.3), float(0.3));

    ShAttrib<2, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_2f_1f_callpoly_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_callpoly_test19
    last_test = "f_2f_2f_callpoly_test19";
    ShAttrib<2, SH_CONST, float> a(float(-10.0), float(0.2));
    ShAttrib<2, SH_CONST, float> b(float(0.3), float(20));
    ShAttrib<2, SH_CONST, float> expected(float(-199.7), float(4.3));

    ShAttrib<2, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_2f_2f_callpoly_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_2f_callpoly_test20
    last_test = "f_4f_2f_callpoly_test20";
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(-0.2), float(13.0), float(42));
    ShAttrib<2, SH_CONST, float> b(float(1), float(-1));
    ShAttrib<4, SH_CONST, float> expected(float(0.5), float(1.2), float(-12.0), float(-41));

    ShAttrib<4, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_4f_2f_callpoly_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_2f_callpoly_test21
    last_test = "f_4f_2f_callpoly_test21";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(2.0), float(3.0), float(4.0));
    ShAttrib<2, SH_CONST, float> b(float(4), float(-10));
    ShAttrib<4, SH_CONST, float> expected(float(-6.0), float(-16.0), float(-26.0), float(-36.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_4f_2f_callpoly_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_2f_callpoly_test22
    last_test = "f_3f_2f_callpoly_test22";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<2, SH_CONST, float> b(float(4), float(-10));
    ShAttrib<3, SH_CONST, float> expected(float(-6.0), float(-16.0), float(-26.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_3f_2f_callpoly_test22", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_2f_2f_callpoly_test23
    last_test = "f_2f_2f_callpoly_test23";
    ShAttrib<2, SH_CONST, float> a(float(1.0), float(2.0));
    ShAttrib<2, SH_CONST, float> b(float(4), float(-10));
    ShAttrib<2, SH_CONST, float> expected(float(-6.0), float(-16.0));

    ShAttrib<2, SH_TEMP, float> out;
    out = poly(a, b);

    try {
      if (test.check("f_2f_2f_callpoly_test23", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

