#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram pow_a_f_3f_3f_callpow_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_3f_3f_callpow_test0.name("pow_a_f_3f_3f_callpow_test0");
  last_test = "pow_a_f_3f_3f_callpow_test0";
  {  // f_3f_3f_callpow_test0
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(pow_a_f_3f_3f_callpow_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_4f_callpow_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_4f_callpow_test1.name("pow_a_f_4f_4f_callpow_test1");
  last_test = "pow_a_f_4f_4f_callpow_test1";
  {  // f_4f_4f_callpow_test1
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(pow_a_f_4f_4f_callpow_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_4f_callpow_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_4f_callpow_test2.name("pow_a_f_4f_4f_callpow_test2");
  last_test = "pow_a_f_4f_4f_callpow_test2";
  {  // f_4f_4f_callpow_test2
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    try {
      if (test.run(pow_a_f_4f_4f_callpow_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_4f_callpow_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_4f_callpow_test3.name("pow_a_f_4f_4f_callpow_test3");
  last_test = "pow_a_f_4f_4f_callpow_test3";
  {  // f_4f_4f_callpow_test3
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.0), float(-1.0), float(-2.0), float(-5.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    try {
      if (test.run(pow_a_f_4f_4f_callpow_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_4f_callpow_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_4f_callpow_test4.name("pow_a_f_4f_4f_callpow_test4");
  last_test = "pow_a_f_4f_4f_callpow_test4";
  {  // f_4f_4f_callpow_test4
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    try {
      if (test.run(pow_a_f_4f_4f_callpow_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_4f_callpow_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_4f_callpow_test5.name("pow_a_f_4f_4f_callpow_test5");
  last_test = "pow_a_f_4f_4f_callpow_test5";
  {  // f_4f_4f_callpow_test5
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.2), float(-0.5), float(-0.9), float(-1.5));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    try {
      if (test.run(pow_a_f_4f_4f_callpow_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_4f_callpow_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_4f_callpow_test6.name("pow_a_f_4f_4f_callpow_test6");
  last_test = "pow_a_f_4f_4f_callpow_test6";
  {  // f_4f_4f_callpow_test6
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(3.0), float(4.0), float(243.0));

    try {
      if (test.run(pow_a_f_4f_4f_callpow_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_4f_callpow_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_4f_callpow_test7.name("pow_a_f_4f_4f_callpow_test7");
  last_test = "pow_a_f_4f_4f_callpow_test7";
  {  // f_4f_4f_callpow_test7
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.1), float(0.5), float(0.9), float(2.3));
    ShAttrib<4, SH_CONST, float> expected(float(1.07177346254), float(1.73205080757), float(1.86606598307), float(12.5135025328));

    try {
      if (test.run(pow_a_f_4f_4f_callpow_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_4f_callpow_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_4f_callpow_test8.name("pow_a_f_4f_4f_callpow_test8");
  last_test = "pow_a_f_4f_4f_callpow_test8";
  {  // f_4f_4f_callpow_test8
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.0), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(0.333333333333), float(0.25), float(0.0123456790123));

    try {
      if (test.run(pow_a_f_4f_4f_callpow_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_f_4f_callpow_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_f_4f_callpow_test9.name("pow_a_f_f_4f_callpow_test9");
  last_test = "pow_a_f_f_4f_callpow_test9";
  {  // f_f_4f_callpow_test9
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0), float(0.0));

    try {
      if (test.run(pow_a_f_f_4f_callpow_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_f_4f_callpow_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_f_4f_callpow_test10.name("pow_a_f_f_4f_callpow_test10");
  last_test = "pow_a_f_f_4f_callpow_test10";
  {  // f_f_4f_callpow_test10
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(2.0), float(4.0), float(32.0));

    try {
      if (test.run(pow_a_f_f_4f_callpow_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_f_4f_callpow_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_f_4f_callpow_test11.name("pow_a_f_f_4f_callpow_test11");
  last_test = "pow_a_f_f_4f_callpow_test11";
  {  // f_f_4f_callpow_test11
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.1), float(0.5), float(0.9), float(2.3));
    ShAttrib<4, SH_CONST, float> expected(float(1.11612317403), float(1.73205080757), float(2.68787537952), float(12.5135025328));

    try {
      if (test.run(pow_a_f_f_4f_callpow_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_f_4f_callpow_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_f_4f_callpow_test12.name("pow_a_f_f_4f_callpow_test12");
  last_test = "pow_a_f_f_4f_callpow_test12";
  {  // f_f_4f_callpow_test12
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.0), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    try {
      if (test.run(pow_a_f_f_4f_callpow_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_f_callpow_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_f_callpow_test13.name("pow_a_f_4f_f_callpow_test13");
  last_test = "pow_a_f_4f_f_callpow_test13";
  {  // f_4f_f_callpow_test13
    ShAttrib<4, SH_CONST, float> a(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    try {
      if (test.run(pow_a_f_4f_f_callpow_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_f_callpow_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_f_callpow_test14.name("pow_a_f_4f_f_callpow_test14");
  last_test = "pow_a_f_4f_f_callpow_test14";
  {  // f_4f_f_callpow_test14
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(1.0), float(4.0), float(25.0));

    try {
      if (test.run(pow_a_f_4f_f_callpow_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram pow_a_f_4f_f_callpow_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = pow(a, b);
  } SH_END;

  pow_a_f_4f_f_callpow_test15.name("pow_a_f_4f_f_callpow_test15");
  last_test = "pow_a_f_4f_f_callpow_test15";
  {  // f_4f_f_callpow_test15
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.5), float(0.9), float(2.3));
    ShAttrib<1, SH_CONST, float> b(float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.001), float(0.125), float(0.729), float(12.167));

    try {
      if (test.run(pow_a_f_4f_f_callpow_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_3f_callpow_test0
    last_test = "f_3f_3f_callpow_test0";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(1.0), float(2.0), float(5.0));
    ShAttrib<3, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_3f_3f_callpow_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callpow_test1
    last_test = "f_4f_4f_callpow_test1";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0), float(0.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_4f_callpow_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callpow_test2
    last_test = "f_4f_4f_callpow_test2";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_4f_callpow_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callpow_test3
    last_test = "f_4f_4f_callpow_test3";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.0), float(-1.0), float(-2.0), float(-5.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_4f_callpow_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callpow_test4
    last_test = "f_4f_4f_callpow_test4";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_4f_callpow_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callpow_test5
    last_test = "f_4f_4f_callpow_test5";
    ShAttrib<4, SH_CONST, float> a(float(1.0), float(1.0), float(1.0), float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.2), float(-0.5), float(-0.9), float(-1.5));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_4f_callpow_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callpow_test6
    last_test = "f_4f_4f_callpow_test6";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(3.0), float(4.0), float(243.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_4f_callpow_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callpow_test7
    last_test = "f_4f_4f_callpow_test7";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.1), float(0.5), float(0.9), float(2.3));
    ShAttrib<4, SH_CONST, float> expected(float(1.07177346254), float(1.73205080757), float(1.86606598307), float(12.5135025328));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_4f_callpow_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_callpow_test8
    last_test = "f_4f_4f_callpow_test8";
    ShAttrib<4, SH_CONST, float> a(float(2.0), float(3.0), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.0), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(0.333333333333), float(0.25), float(0.0123456790123));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_4f_callpow_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_4f_callpow_test9
    last_test = "f_f_4f_callpow_test9";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(0.0), float(0.0), float(0.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_f_4f_callpow_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_4f_callpow_test10
    last_test = "f_f_4f_callpow_test10";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(2.0), float(4.0), float(32.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_f_4f_callpow_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_4f_callpow_test11
    last_test = "f_f_4f_callpow_test11";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<4, SH_CONST, float> b(float(0.1), float(0.5), float(0.9), float(2.3));
    ShAttrib<4, SH_CONST, float> expected(float(1.11612317403), float(1.73205080757), float(2.68787537952), float(12.5135025328));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_f_4f_callpow_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_4f_callpow_test12
    last_test = "f_f_4f_callpow_test12";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<4, SH_CONST, float> b(float(-0.0), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_f_4f_callpow_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_f_callpow_test13
    last_test = "f_4f_f_callpow_test13";
    ShAttrib<4, SH_CONST, float> a(float(0.2), float(0.5), float(0.9), float(1.5));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.0), float(1.0), float(1.0), float(1.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_f_callpow_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_f_callpow_test14
    last_test = "f_4f_f_callpow_test14";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(2.0), float(5.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.0), float(1.0), float(4.0), float(25.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_f_callpow_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_f_callpow_test15
    last_test = "f_4f_f_callpow_test15";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.5), float(0.9), float(2.3));
    ShAttrib<1, SH_CONST, float> b(float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.001), float(0.125), float(0.729), float(12.167));

    ShAttrib<4, SH_TEMP, float> out;
    out = pow(a, b);

    try {
      if (test.check("f_4f_f_callpow_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

