#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram rcp_a_f_4f_callrcp_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rcp(a);
  } SH_END;

  rcp_a_f_4f_callrcp_test0.name("rcp_a_f_4f_callrcp_test0");
  last_test = "rcp_a_f_4f_callrcp_test0";
  {  // f_4f_callrcp_test0
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(1.0), float(2.0), float(4.0));
    ShAttrib<4, SH_CONST, float> expected(float(2.0), float(1.0), float(0.5), float(0.25));

    try {
      if (test.run(rcp_a_f_4f_callrcp_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rcp_a_f_4f_callrcp_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rcp(a);
  } SH_END;

  rcp_a_f_4f_callrcp_test1.name("rcp_a_f_4f_callrcp_test1");
  last_test = "rcp_a_f_4f_callrcp_test1";
  {  // f_4f_callrcp_test1
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(10.0), float(4.0), float(3.33333333333), float(2.0));

    try {
      if (test.run(rcp_a_f_4f_callrcp_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rcp_a_f_4f_callrcp_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rcp(a);
  } SH_END;

  rcp_a_f_4f_callrcp_test2.name("rcp_a_f_4f_callrcp_test2");
  last_test = "rcp_a_f_4f_callrcp_test2";
  {  // f_4f_callrcp_test2
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.434782608696), float(0.263157894737), float(0.5), float(0.333333333333));

    try {
      if (test.run(rcp_a_f_4f_callrcp_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rcp_a_f_4f_callrcp_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rcp(a);
  } SH_END;

  rcp_a_f_4f_callrcp_test3.name("rcp_a_f_4f_callrcp_test3");
  last_test = "rcp_a_f_4f_callrcp_test3";
  {  // f_4f_callrcp_test3
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(1.0), float(2.9), float(500.0));
    ShAttrib<4, SH_CONST, float> expected(float(2.0), float(1.0), float(0.344827586207), float(0.002));

    try {
      if (test.run(rcp_a_f_4f_callrcp_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rcp_a_f_4f_callrcp_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rcp(a);
  } SH_END;

  rcp_a_f_4f_callrcp_test4.name("rcp_a_f_4f_callrcp_test4");
  last_test = "rcp_a_f_4f_callrcp_test4";
  {  // f_4f_callrcp_test4
    ShAttrib<4, SH_CONST, float> a(float(-0.5), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-2.0), float(-1.0), float(-0.5), float(-0.25));

    try {
      if (test.run(rcp_a_f_4f_callrcp_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rcp_a_f_4f_callrcp_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rcp(a);
  } SH_END;

  rcp_a_f_4f_callrcp_test5.name("rcp_a_f_4f_callrcp_test5");
  last_test = "rcp_a_f_4f_callrcp_test5";
  {  // f_4f_callrcp_test5
    ShAttrib<4, SH_CONST, float> a(float(-0.1), float(-0.25), float(-0.3), float(-0.5));
    ShAttrib<4, SH_CONST, float> expected(float(-10.0), float(-4.0), float(-3.33333333333), float(-2.0));

    try {
      if (test.run(rcp_a_f_4f_callrcp_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rcp_a_f_4f_callrcp_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rcp(a);
  } SH_END;

  rcp_a_f_4f_callrcp_test6.name("rcp_a_f_4f_callrcp_test6");
  last_test = "rcp_a_f_4f_callrcp_test6";
  {  // f_4f_callrcp_test6
    ShAttrib<4, SH_CONST, float> a(float(-2.3), float(-3.8), float(-2.0), float(-3.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.434782608696), float(-0.263157894737), float(-0.5), float(-0.333333333333));

    try {
      if (test.run(rcp_a_f_4f_callrcp_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rcp_a_f_4f_callrcp_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rcp(a);
  } SH_END;

  rcp_a_f_4f_callrcp_test7.name("rcp_a_f_4f_callrcp_test7");
  last_test = "rcp_a_f_4f_callrcp_test7";
  {  // f_4f_callrcp_test7
    ShAttrib<4, SH_CONST, float> a(float(-0.5), float(-1.0), float(-2.9), float(-500.0));
    ShAttrib<4, SH_CONST, float> expected(float(-2.0), float(-1.0), float(-0.344827586207), float(-0.002));

    try {
      if (test.run(rcp_a_f_4f_callrcp_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_callrcp_test0
    last_test = "f_4f_callrcp_test0";
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(1.0), float(2.0), float(4.0));
    ShAttrib<4, SH_CONST, float> expected(float(2.0), float(1.0), float(0.5), float(0.25));

    ShAttrib<4, SH_TEMP, float> out;
    out = rcp(a);

    try {
      if (test.check("f_4f_callrcp_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callrcp_test1
    last_test = "f_4f_callrcp_test1";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(10.0), float(4.0), float(3.33333333333), float(2.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = rcp(a);

    try {
      if (test.check("f_4f_callrcp_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callrcp_test2
    last_test = "f_4f_callrcp_test2";
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.434782608696), float(0.263157894737), float(0.5), float(0.333333333333));

    ShAttrib<4, SH_TEMP, float> out;
    out = rcp(a);

    try {
      if (test.check("f_4f_callrcp_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callrcp_test3
    last_test = "f_4f_callrcp_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(1.0), float(2.9), float(500.0));
    ShAttrib<4, SH_CONST, float> expected(float(2.0), float(1.0), float(0.344827586207), float(0.002));

    ShAttrib<4, SH_TEMP, float> out;
    out = rcp(a);

    try {
      if (test.check("f_4f_callrcp_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callrcp_test4
    last_test = "f_4f_callrcp_test4";
    ShAttrib<4, SH_CONST, float> a(float(-0.5), float(-1.0), float(-2.0), float(-4.0));
    ShAttrib<4, SH_CONST, float> expected(float(-2.0), float(-1.0), float(-0.5), float(-0.25));

    ShAttrib<4, SH_TEMP, float> out;
    out = rcp(a);

    try {
      if (test.check("f_4f_callrcp_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callrcp_test5
    last_test = "f_4f_callrcp_test5";
    ShAttrib<4, SH_CONST, float> a(float(-0.1), float(-0.25), float(-0.3), float(-0.5));
    ShAttrib<4, SH_CONST, float> expected(float(-10.0), float(-4.0), float(-3.33333333333), float(-2.0));

    ShAttrib<4, SH_TEMP, float> out;
    out = rcp(a);

    try {
      if (test.check("f_4f_callrcp_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callrcp_test6
    last_test = "f_4f_callrcp_test6";
    ShAttrib<4, SH_CONST, float> a(float(-2.3), float(-3.8), float(-2.0), float(-3.0));
    ShAttrib<4, SH_CONST, float> expected(float(-0.434782608696), float(-0.263157894737), float(-0.5), float(-0.333333333333));

    ShAttrib<4, SH_TEMP, float> out;
    out = rcp(a);

    try {
      if (test.check("f_4f_callrcp_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callrcp_test7
    last_test = "f_4f_callrcp_test7";
    ShAttrib<4, SH_CONST, float> a(float(-0.5), float(-1.0), float(-2.9), float(-500.0));
    ShAttrib<4, SH_CONST, float> expected(float(-2.0), float(-1.0), float(-0.344827586207), float(-0.002));

    ShAttrib<4, SH_TEMP, float> out;
    out = rcp(a);

    try {
      if (test.check("f_4f_callrcp_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

