#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram sign_a_f_4f_callsign_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sign(a);
  } SH_END;

  sign_a_f_4f_callsign_test0.name("sign_a_f_4f_callsign_test0");
  last_test = "sign_a_f_4f_callsign_test0";
  {  // f_4f_callsign_test0
    ShAttrib<4, SH_CONST, float> a(float(-8.0), float(-8.9), float(-8.5), float(-8.1));
    ShAttrib<4, SH_CONST, float> expected(float(-1), float(-1), float(-1), float(-1));

    try {
      if (test.run(sign_a_f_4f_callsign_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sign_a_f_4f_callsign_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sign(a);
  } SH_END;

  sign_a_f_4f_callsign_test1.name("sign_a_f_4f_callsign_test1");
  last_test = "sign_a_f_4f_callsign_test1";
  {  // f_4f_callsign_test1
    ShAttrib<4, SH_CONST, float> a(float(-0.0), float(-0.5), float(0.0), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(-1), float(0), float(1));

    try {
      if (test.run(sign_a_f_4f_callsign_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sign_a_f_4f_callsign_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sign(a);
  } SH_END;

  sign_a_f_4f_callsign_test2.name("sign_a_f_4f_callsign_test2");
  last_test = "sign_a_f_4f_callsign_test2";
  {  // f_4f_callsign_test2
    ShAttrib<4, SH_CONST, float> a(float(8.0), float(8.9), float(8.5), float(8.1));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(1), float(1));

    try {
      if (test.run(sign_a_f_4f_callsign_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_4f_callsign_test0
    last_test = "f_4f_callsign_test0";
    ShAttrib<4, SH_CONST, float> a(float(-8.0), float(-8.9), float(-8.5), float(-8.1));
    ShAttrib<4, SH_CONST, float> expected(float(-1), float(-1), float(-1), float(-1));

    ShAttrib<4, SH_TEMP, float> out;
    out = sign(a);

    try {
      if (test.check("f_4f_callsign_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsign_test1
    last_test = "f_4f_callsign_test1";
    ShAttrib<4, SH_CONST, float> a(float(-0.0), float(-0.5), float(0.0), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(-1), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = sign(a);

    try {
      if (test.check("f_4f_callsign_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsign_test2
    last_test = "f_4f_callsign_test2";
    ShAttrib<4, SH_CONST, float> a(float(8.0), float(8.9), float(8.5), float(8.1));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(1), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = sign(a);

    try {
      if (test.check("f_4f_callsign_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

