#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram sqrt_a_f_1f_callsqrt_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = sqrt(a);
  } SH_END;

  sqrt_a_f_1f_callsqrt_test0.name("sqrt_a_f_1f_callsqrt_test0");
  last_test = "sqrt_a_f_1f_callsqrt_test0";
  {  // f_1f_callsqrt_test0
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(sqrt_a_f_1f_callsqrt_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sqrt_a_f_3f_callsqrt_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = sqrt(a);
  } SH_END;

  sqrt_a_f_3f_callsqrt_test1.name("sqrt_a_f_3f_callsqrt_test1");
  last_test = "sqrt_a_f_3f_callsqrt_test1";
  {  // f_3f_callsqrt_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(4.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(1.41421356237), float(2.0));

    try {
      if (test.run(sqrt_a_f_3f_callsqrt_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sqrt_a_f_4f_callsqrt_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sqrt(a);
  } SH_END;

  sqrt_a_f_4f_callsqrt_test2.name("sqrt_a_f_4f_callsqrt_test2");
  last_test = "sqrt_a_f_4f_callsqrt_test2";
  {  // f_4f_callsqrt_test2
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(0.316227766017), float(0.5), float(0.547722557505), float(0.707106781187));

    try {
      if (test.run(sqrt_a_f_4f_callsqrt_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sqrt_a_f_4f_callsqrt_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sqrt(a);
  } SH_END;

  sqrt_a_f_4f_callsqrt_test3.name("sqrt_a_f_4f_callsqrt_test3");
  last_test = "sqrt_a_f_4f_callsqrt_test3";
  {  // f_4f_callsqrt_test3
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.51657508881), float(1.94935886896), float(1.41421356237), float(1.73205080757));

    try {
      if (test.run(sqrt_a_f_4f_callsqrt_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram sqrt_a_f_4f_callsqrt_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = sqrt(a);
  } SH_END;

  sqrt_a_f_4f_callsqrt_test4.name("sqrt_a_f_4f_callsqrt_test4");
  last_test = "sqrt_a_f_4f_callsqrt_test4";
  {  // f_4f_callsqrt_test4
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(1.0), float(2.9), float(50.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.707106781187), float(1.0), float(1.70293863659), float(7.07106781187));

    try {
      if (test.run(sqrt_a_f_4f_callsqrt_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rsqrt_a_f_3f_callrsqrt_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = rsqrt(a);
  } SH_END;

  rsqrt_a_f_3f_callrsqrt_test0.name("rsqrt_a_f_3f_callrsqrt_test0");
  last_test = "rsqrt_a_f_3f_callrsqrt_test0";
  {  // f_3f_callrsqrt_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(4.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(0.707106781187), float(0.5));

    try {
      if (test.run(rsqrt_a_f_3f_callrsqrt_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rsqrt_a_f_4f_callrsqrt_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rsqrt(a);
  } SH_END;

  rsqrt_a_f_4f_callrsqrt_test1.name("rsqrt_a_f_4f_callrsqrt_test1");
  last_test = "rsqrt_a_f_4f_callrsqrt_test1";
  {  // f_4f_callrsqrt_test1
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(3.16227766017), float(2.0), float(1.82574185835), float(1.41421356237));

    try {
      if (test.run(rsqrt_a_f_4f_callrsqrt_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rsqrt_a_f_4f_callrsqrt_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rsqrt(a);
  } SH_END;

  rsqrt_a_f_4f_callrsqrt_test2.name("rsqrt_a_f_4f_callrsqrt_test2");
  last_test = "rsqrt_a_f_4f_callrsqrt_test2";
  {  // f_4f_callrsqrt_test2
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.659380473396), float(0.512989176043), float(0.707106781187), float(0.57735026919));

    try {
      if (test.run(rsqrt_a_f_4f_callrsqrt_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram rsqrt_a_f_4f_callrsqrt_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = rsqrt(a);
  } SH_END;

  rsqrt_a_f_4f_callrsqrt_test3.name("rsqrt_a_f_4f_callrsqrt_test3");
  last_test = "rsqrt_a_f_4f_callrsqrt_test3";
  {  // f_4f_callrsqrt_test3
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(1.0), float(2.9), float(50.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.41421356237), float(1.0), float(0.587220219515), float(0.141421356237));

    try {
      if (test.run(rsqrt_a_f_4f_callrsqrt_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_1f_callsqrt_test0
    last_test = "f_1f_callsqrt_test0";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = sqrt(a);

    try {
      if (test.check("f_1f_callsqrt_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callsqrt_test1
    last_test = "f_3f_callsqrt_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(4.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(1.41421356237), float(2.0));

    ShAttrib<3, SH_TEMP, float> out;
    out = sqrt(a);

    try {
      if (test.check("f_3f_callsqrt_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsqrt_test2
    last_test = "f_4f_callsqrt_test2";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(0.316227766017), float(0.5), float(0.547722557505), float(0.707106781187));

    ShAttrib<4, SH_TEMP, float> out;
    out = sqrt(a);

    try {
      if (test.check("f_4f_callsqrt_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsqrt_test3
    last_test = "f_4f_callsqrt_test3";
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.51657508881), float(1.94935886896), float(1.41421356237), float(1.73205080757));

    ShAttrib<4, SH_TEMP, float> out;
    out = sqrt(a);

    try {
      if (test.check("f_4f_callsqrt_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callsqrt_test4
    last_test = "f_4f_callsqrt_test4";
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(1.0), float(2.9), float(50.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.707106781187), float(1.0), float(1.70293863659), float(7.07106781187));

    ShAttrib<4, SH_TEMP, float> out;
    out = sqrt(a);

    try {
      if (test.check("f_4f_callsqrt_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_callrsqrt_test0
    last_test = "f_3f_callrsqrt_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(4.0));
    ShAttrib<3, SH_CONST, float> expected(float(1.0), float(0.707106781187), float(0.5));

    ShAttrib<3, SH_TEMP, float> out;
    out = rsqrt(a);

    try {
      if (test.check("f_3f_callrsqrt_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callrsqrt_test1
    last_test = "f_4f_callrsqrt_test1";
    ShAttrib<4, SH_CONST, float> a(float(0.1), float(0.25), float(0.3), float(0.5));
    ShAttrib<4, SH_CONST, float> expected(float(3.16227766017), float(2.0), float(1.82574185835), float(1.41421356237));

    ShAttrib<4, SH_TEMP, float> out;
    out = rsqrt(a);

    try {
      if (test.check("f_4f_callrsqrt_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callrsqrt_test2
    last_test = "f_4f_callrsqrt_test2";
    ShAttrib<4, SH_CONST, float> a(float(2.3), float(3.8), float(2.0), float(3.0));
    ShAttrib<4, SH_CONST, float> expected(float(0.659380473396), float(0.512989176043), float(0.707106781187), float(0.57735026919));

    ShAttrib<4, SH_TEMP, float> out;
    out = rsqrt(a);

    try {
      if (test.check("f_4f_callrsqrt_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_callrsqrt_test3
    last_test = "f_4f_callrsqrt_test3";
    ShAttrib<4, SH_CONST, float> a(float(0.5), float(1.0), float(2.9), float(50.0));
    ShAttrib<4, SH_CONST, float> expected(float(1.41421356237), float(1.0), float(0.587220219515), float(0.141421356237));

    ShAttrib<4, SH_TEMP, float> out;
    out = rsqrt(a);

    try {
      if (test.check("f_4f_callrsqrt_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

