#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram lt_a_f_1f_1f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_1f_1f_infix_test0.name("lt_a_f_1f_1f_infix_test0");
  last_test = "lt_a_f_1f_1f_infix_test0";
  {  // f_1f_1f_infix_test0
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(lt_a_f_1f_1f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_f_1f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_1f_1f_infix_test1.name("lt_a_f_1f_1f_infix_test1");
  last_test = "lt_a_f_1f_1f_infix_test1";
  {  // f_1f_1f_infix_test1
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(lt_a_f_1f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_f_1f_1f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_1f_1f_infix_test2.name("lt_a_f_1f_1f_infix_test2");
  last_test = "lt_a_f_1f_1f_infix_test2";
  {  // f_1f_1f_infix_test2
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(lt_a_f_1f_1f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_3f_3f_infix_test3.name("lt_a_f_3f_3f_infix_test3");
  last_test = "lt_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(0));

    try {
      if (test.run(lt_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_f_3f_3f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_3f_3f_infix_test4.name("lt_a_f_3f_3f_infix_test4");
  last_test = "lt_a_f_3f_3f_infix_test4";
  {  // f_3f_3f_infix_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    try {
      if (test.run(lt_a_f_3f_3f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_f_3f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_3f_3f_infix_test5.name("lt_a_f_3f_3f_infix_test5");
  last_test = "lt_a_f_3f_3f_infix_test5";
  {  // f_3f_3f_infix_test5
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    try {
      if (test.run(lt_a_f_3f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_f_4f_4f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_4f_4f_infix_test6.name("lt_a_f_4f_4f_infix_test6");
  last_test = "lt_a_f_4f_4f_infix_test6";
  {  // f_4f_4f_infix_test6
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(1), float(0));

    try {
      if (test.run(lt_a_f_4f_4f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_f_f_3f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_f_3f_infix_test7.name("lt_a_f_f_3f_infix_test7");
  last_test = "lt_a_f_f_3f_infix_test7";
  {  // f_f_3f_infix_test7
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(1));

    try {
      if (test.run(lt_a_f_f_3f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_f_f_3f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_f_3f_infix_test8.name("lt_a_f_f_3f_infix_test8");
  last_test = "lt_a_f_f_3f_infix_test8";
  {  // f_f_3f_infix_test8
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    try {
      if (test.run(lt_a_f_f_3f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_f_3f_f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_3f_f_infix_test9.name("lt_a_f_3f_f_infix_test9");
  last_test = "lt_a_f_3f_f_infix_test9";
  {  // f_3f_f_infix_test9
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    try {
      if (test.run(lt_a_f_3f_f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_f_3f_f_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a < b;
  } SH_END;

  lt_a_f_3f_f_infix_test10.name("lt_a_f_3f_f_infix_test10");
  last_test = "lt_a_f_3f_f_infix_test10";
  {  // f_3f_f_infix_test10
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(0));

    try {
      if (test.run(lt_a_f_3f_f_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_1f_1f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_1f_1f_infix_test11.name("lt_a_i_1f_1f_infix_test11");
  last_test = "lt_a_i_1f_1f_infix_test11";
  {  // i_1f_1f_infix_test11
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    try {
      if (test.run(lt_a_i_1f_1f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_1f_1f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_1f_1f_infix_test12.name("lt_a_i_1f_1f_infix_test12");
  last_test = "lt_a_i_1f_1f_infix_test12";
  {  // i_1f_1f_infix_test12
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(lt_a_i_1f_1f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_1f_1f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_1f_1f_infix_test13.name("lt_a_i_1f_1f_infix_test13");
  last_test = "lt_a_i_1f_1f_infix_test13";
  {  // i_1f_1f_infix_test13
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(lt_a_i_1f_1f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_3i_3i_infix_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_3i_3i_infix_test14.name("lt_a_i_3i_3i_infix_test14");
  last_test = "lt_a_i_3i_3i_infix_test14";
  {  // i_3i_3i_infix_test14
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(0));

    try {
      if (test.run(lt_a_i_3i_3i_infix_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_3i_3i_infix_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_3i_3i_infix_test15.name("lt_a_i_3i_3i_infix_test15");
  last_test = "lt_a_i_3i_3i_infix_test15";
  {  // i_3i_3i_infix_test15
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    try {
      if (test.run(lt_a_i_3i_3i_infix_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_3i_3i_infix_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_3i_3i_infix_test16.name("lt_a_i_3i_3i_infix_test16");
  last_test = "lt_a_i_3i_3i_infix_test16";
  {  // i_3i_3i_infix_test16
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    try {
      if (test.run(lt_a_i_3i_3i_infix_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_4i_4i_infix_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_4i_4i_infix_test17.name("lt_a_i_4i_4i_infix_test17");
  last_test = "lt_a_i_4i_4i_infix_test17";
  {  // i_4i_4i_infix_test17
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(0), int(1), int(0));

    try {
      if (test.run(lt_a_i_4i_4i_infix_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_i_3i_infix_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_i_3i_infix_test18.name("lt_a_i_i_3i_infix_test18");
  last_test = "lt_a_i_i_3i_infix_test18";
  {  // i_i_3i_infix_test18
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(1));

    try {
      if (test.run(lt_a_i_i_3i_infix_test18, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_i_3i_infix_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_i_3i_infix_test19.name("lt_a_i_i_3i_infix_test19");
  last_test = "lt_a_i_i_3i_infix_test19";
  {  // i_i_3i_infix_test19
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    try {
      if (test.run(lt_a_i_i_3i_infix_test19, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_3i_i_infix_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_3i_i_infix_test20.name("lt_a_i_3i_i_infix_test20");
  last_test = "lt_a_i_3i_i_infix_test20";
  {  // i_3i_i_infix_test20
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    try {
      if (test.run(lt_a_i_3i_i_infix_test20, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram lt_a_i_3i_i_infix_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a < b;
  } SH_END;

  lt_a_i_3i_i_infix_test21.name("lt_a_i_3i_i_infix_test21");
  last_test = "lt_a_i_3i_i_infix_test21";
  {  // i_3i_i_infix_test21
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(0));

    try {
      if (test.run(lt_a_i_3i_i_infix_test21, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_1f_1f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_1f_1f_infix_test0.name("le_a_f_1f_1f_infix_test0");
  last_test = "le_a_f_1f_1f_infix_test0";
  {  // f_1f_1f_infix_test0
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(le_a_f_1f_1f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_1f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_1f_1f_infix_test1.name("le_a_f_1f_1f_infix_test1");
  last_test = "le_a_f_1f_1f_infix_test1";
  {  // f_1f_1f_infix_test1
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(le_a_f_1f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_1f_1f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_1f_1f_infix_test2.name("le_a_f_1f_1f_infix_test2");
  last_test = "le_a_f_1f_1f_infix_test2";
  {  // f_1f_1f_infix_test2
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(le_a_f_1f_1f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_3f_3f_infix_test3.name("le_a_f_3f_3f_infix_test3");
  last_test = "le_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    try {
      if (test.run(le_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_3f_3f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_3f_3f_infix_test4.name("le_a_f_3f_3f_infix_test4");
  last_test = "le_a_f_3f_3f_infix_test4";
  {  // f_3f_3f_infix_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(1));

    try {
      if (test.run(le_a_f_3f_3f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_3f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_3f_3f_infix_test5.name("le_a_f_3f_3f_infix_test5");
  last_test = "le_a_f_3f_3f_infix_test5";
  {  // f_3f_3f_infix_test5
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    try {
      if (test.run(le_a_f_3f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_4f_4f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_4f_4f_infix_test6.name("le_a_f_4f_4f_infix_test6");
  last_test = "le_a_f_4f_4f_infix_test6";
  {  // f_4f_4f_infix_test6
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0), float(1), float(0));

    try {
      if (test.run(le_a_f_4f_4f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_f_3f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_f_3f_infix_test7.name("le_a_f_f_3f_infix_test7");
  last_test = "le_a_f_f_3f_infix_test7";
  {  // f_f_3f_infix_test7
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(1));

    try {
      if (test.run(le_a_f_f_3f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_f_3f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_f_3f_infix_test8.name("le_a_f_f_3f_infix_test8");
  last_test = "le_a_f_f_3f_infix_test8";
  {  // f_f_3f_infix_test8
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    try {
      if (test.run(le_a_f_f_3f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_3f_f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_3f_f_infix_test9.name("le_a_f_3f_f_infix_test9");
  last_test = "le_a_f_3f_f_infix_test9";
  {  // f_3f_f_infix_test9
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    try {
      if (test.run(le_a_f_3f_f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_f_3f_f_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a <= b;
  } SH_END;

  le_a_f_3f_f_infix_test10.name("le_a_f_3f_f_infix_test10");
  last_test = "le_a_f_3f_f_infix_test10";
  {  // f_3f_f_infix_test10
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(0));

    try {
      if (test.run(le_a_f_3f_f_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_1f_1f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_1f_1f_infix_test11.name("le_a_i_1f_1f_infix_test11");
  last_test = "le_a_i_1f_1f_infix_test11";
  {  // i_1f_1f_infix_test11
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    try {
      if (test.run(le_a_i_1f_1f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_1f_1f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_1f_1f_infix_test12.name("le_a_i_1f_1f_infix_test12");
  last_test = "le_a_i_1f_1f_infix_test12";
  {  // i_1f_1f_infix_test12
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    try {
      if (test.run(le_a_i_1f_1f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_1f_1f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_1f_1f_infix_test13.name("le_a_i_1f_1f_infix_test13");
  last_test = "le_a_i_1f_1f_infix_test13";
  {  // i_1f_1f_infix_test13
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(le_a_i_1f_1f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_3i_3i_infix_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_3i_3i_infix_test14.name("le_a_i_3i_3i_infix_test14");
  last_test = "le_a_i_3i_3i_infix_test14";
  {  // i_3i_3i_infix_test14
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    try {
      if (test.run(le_a_i_3i_3i_infix_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_3i_3i_infix_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_3i_3i_infix_test15.name("le_a_i_3i_3i_infix_test15");
  last_test = "le_a_i_3i_3i_infix_test15";
  {  // i_3i_3i_infix_test15
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(1));

    try {
      if (test.run(le_a_i_3i_3i_infix_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_3i_3i_infix_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_3i_3i_infix_test16.name("le_a_i_3i_3i_infix_test16");
  last_test = "le_a_i_3i_3i_infix_test16";
  {  // i_3i_3i_infix_test16
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    try {
      if (test.run(le_a_i_3i_3i_infix_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_4i_4i_infix_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_4i_4i_infix_test17.name("le_a_i_4i_4i_infix_test17");
  last_test = "le_a_i_4i_4i_infix_test17";
  {  // i_4i_4i_infix_test17
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(1), int(0), int(1), int(0));

    try {
      if (test.run(le_a_i_4i_4i_infix_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_i_3i_infix_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_i_3i_infix_test18.name("le_a_i_i_3i_infix_test18");
  last_test = "le_a_i_i_3i_infix_test18";
  {  // i_i_3i_infix_test18
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(1));

    try {
      if (test.run(le_a_i_i_3i_infix_test18, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_i_3i_infix_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_i_3i_infix_test19.name("le_a_i_i_3i_infix_test19");
  last_test = "le_a_i_i_3i_infix_test19";
  {  // i_i_3i_infix_test19
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    try {
      if (test.run(le_a_i_i_3i_infix_test19, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_3i_i_infix_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_3i_i_infix_test20.name("le_a_i_3i_i_infix_test20");
  last_test = "le_a_i_3i_i_infix_test20";
  {  // i_3i_i_infix_test20
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    try {
      if (test.run(le_a_i_3i_i_infix_test20, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram le_a_i_3i_i_infix_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a <= b;
  } SH_END;

  le_a_i_3i_i_infix_test21.name("le_a_i_3i_i_infix_test21");
  last_test = "le_a_i_3i_i_infix_test21";
  {  // i_3i_i_infix_test21
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(0));

    try {
      if (test.run(le_a_i_3i_i_infix_test21, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_1f_1f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_1f_1f_infix_test0.name("gt_a_f_1f_1f_infix_test0");
  last_test = "gt_a_f_1f_1f_infix_test0";
  {  // f_1f_1f_infix_test0
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(gt_a_f_1f_1f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_1f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_1f_1f_infix_test1.name("gt_a_f_1f_1f_infix_test1");
  last_test = "gt_a_f_1f_1f_infix_test1";
  {  // f_1f_1f_infix_test1
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(gt_a_f_1f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_1f_1f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_1f_1f_infix_test2.name("gt_a_f_1f_1f_infix_test2");
  last_test = "gt_a_f_1f_1f_infix_test2";
  {  // f_1f_1f_infix_test2
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(gt_a_f_1f_1f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_3f_3f_infix_test3.name("gt_a_f_3f_3f_infix_test3");
  last_test = "gt_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    try {
      if (test.run(gt_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_3f_3f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_3f_3f_infix_test4.name("gt_a_f_3f_3f_infix_test4");
  last_test = "gt_a_f_3f_3f_infix_test4";
  {  // f_3f_3f_infix_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(0));

    try {
      if (test.run(gt_a_f_3f_3f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_3f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_3f_3f_infix_test5.name("gt_a_f_3f_3f_infix_test5");
  last_test = "gt_a_f_3f_3f_infix_test5";
  {  // f_3f_3f_infix_test5
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    try {
      if (test.run(gt_a_f_3f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_4f_4f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_4f_4f_infix_test6.name("gt_a_f_4f_4f_infix_test6");
  last_test = "gt_a_f_4f_4f_infix_test6";
  {  // f_4f_4f_infix_test6
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(1), float(0), float(1));

    try {
      if (test.run(gt_a_f_4f_4f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_f_3f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_f_3f_infix_test7.name("gt_a_f_f_3f_infix_test7");
  last_test = "gt_a_f_f_3f_infix_test7";
  {  // f_f_3f_infix_test7
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(0));

    try {
      if (test.run(gt_a_f_f_3f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_f_3f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_f_3f_infix_test8.name("gt_a_f_f_3f_infix_test8");
  last_test = "gt_a_f_f_3f_infix_test8";
  {  // f_f_3f_infix_test8
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    try {
      if (test.run(gt_a_f_f_3f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_3f_f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_3f_f_infix_test9.name("gt_a_f_3f_f_infix_test9");
  last_test = "gt_a_f_3f_f_infix_test9";
  {  // f_3f_f_infix_test9
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    try {
      if (test.run(gt_a_f_3f_f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_f_3f_f_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a > b;
  } SH_END;

  gt_a_f_3f_f_infix_test10.name("gt_a_f_3f_f_infix_test10");
  last_test = "gt_a_f_3f_f_infix_test10";
  {  // f_3f_f_infix_test10
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(1));

    try {
      if (test.run(gt_a_f_3f_f_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_1f_1f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_1f_1f_infix_test11.name("gt_a_i_1f_1f_infix_test11");
  last_test = "gt_a_i_1f_1f_infix_test11";
  {  // i_1f_1f_infix_test11
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(gt_a_i_1f_1f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_1f_1f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_1f_1f_infix_test12.name("gt_a_i_1f_1f_infix_test12");
  last_test = "gt_a_i_1f_1f_infix_test12";
  {  // i_1f_1f_infix_test12
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(gt_a_i_1f_1f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_1f_1f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_1f_1f_infix_test13.name("gt_a_i_1f_1f_infix_test13");
  last_test = "gt_a_i_1f_1f_infix_test13";
  {  // i_1f_1f_infix_test13
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    try {
      if (test.run(gt_a_i_1f_1f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_3i_3i_infix_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_3i_3i_infix_test14.name("gt_a_i_3i_3i_infix_test14");
  last_test = "gt_a_i_3i_3i_infix_test14";
  {  // i_3i_3i_infix_test14
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    try {
      if (test.run(gt_a_i_3i_3i_infix_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_3i_3i_infix_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_3i_3i_infix_test15.name("gt_a_i_3i_3i_infix_test15");
  last_test = "gt_a_i_3i_3i_infix_test15";
  {  // i_3i_3i_infix_test15
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(0));

    try {
      if (test.run(gt_a_i_3i_3i_infix_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_3i_3i_infix_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_3i_3i_infix_test16.name("gt_a_i_3i_3i_infix_test16");
  last_test = "gt_a_i_3i_3i_infix_test16";
  {  // i_3i_3i_infix_test16
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    try {
      if (test.run(gt_a_i_3i_3i_infix_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_4i_4i_infix_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_4i_4i_infix_test17.name("gt_a_i_4i_4i_infix_test17");
  last_test = "gt_a_i_4i_4i_infix_test17";
  {  // i_4i_4i_infix_test17
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(1), int(0), int(1));

    try {
      if (test.run(gt_a_i_4i_4i_infix_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_i_3i_infix_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_i_3i_infix_test18.name("gt_a_i_i_3i_infix_test18");
  last_test = "gt_a_i_i_3i_infix_test18";
  {  // i_i_3i_infix_test18
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(0));

    try {
      if (test.run(gt_a_i_i_3i_infix_test18, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_i_3i_infix_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_i_3i_infix_test19.name("gt_a_i_i_3i_infix_test19");
  last_test = "gt_a_i_i_3i_infix_test19";
  {  // i_i_3i_infix_test19
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(gt_a_i_i_3i_infix_test19, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_3i_i_infix_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_3i_i_infix_test20.name("gt_a_i_3i_i_infix_test20");
  last_test = "gt_a_i_3i_i_infix_test20";
  {  // i_3i_i_infix_test20
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(gt_a_i_3i_i_infix_test20, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram gt_a_i_3i_i_infix_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a > b;
  } SH_END;

  gt_a_i_3i_i_infix_test21.name("gt_a_i_3i_i_infix_test21");
  last_test = "gt_a_i_3i_i_infix_test21";
  {  // i_3i_i_infix_test21
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(1));

    try {
      if (test.run(gt_a_i_3i_i_infix_test21, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_1f_1f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_1f_1f_infix_test0.name("ge_a_f_1f_1f_infix_test0");
  last_test = "ge_a_f_1f_1f_infix_test0";
  {  // f_1f_1f_infix_test0
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(ge_a_f_1f_1f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_1f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_1f_1f_infix_test1.name("ge_a_f_1f_1f_infix_test1");
  last_test = "ge_a_f_1f_1f_infix_test1";
  {  // f_1f_1f_infix_test1
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(ge_a_f_1f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_1f_1f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_1f_1f_infix_test2.name("ge_a_f_1f_1f_infix_test2");
  last_test = "ge_a_f_1f_1f_infix_test2";
  {  // f_1f_1f_infix_test2
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(ge_a_f_1f_1f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_3f_3f_infix_test3.name("ge_a_f_3f_3f_infix_test3");
  last_test = "ge_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(1));

    try {
      if (test.run(ge_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_3f_3f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_3f_3f_infix_test4.name("ge_a_f_3f_3f_infix_test4");
  last_test = "ge_a_f_3f_3f_infix_test4";
  {  // f_3f_3f_infix_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    try {
      if (test.run(ge_a_f_3f_3f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_3f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_3f_3f_infix_test5.name("ge_a_f_3f_3f_infix_test5");
  last_test = "ge_a_f_3f_3f_infix_test5";
  {  // f_3f_3f_infix_test5
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    try {
      if (test.run(ge_a_f_3f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_4f_4f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_4f_4f_infix_test6.name("ge_a_f_4f_4f_infix_test6");
  last_test = "ge_a_f_4f_4f_infix_test6";
  {  // f_4f_4f_infix_test6
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(0), float(1));

    try {
      if (test.run(ge_a_f_4f_4f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_f_3f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_f_3f_infix_test7.name("ge_a_f_f_3f_infix_test7");
  last_test = "ge_a_f_f_3f_infix_test7";
  {  // f_f_3f_infix_test7
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(0));

    try {
      if (test.run(ge_a_f_f_3f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_f_3f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_f_3f_infix_test8.name("ge_a_f_f_3f_infix_test8");
  last_test = "ge_a_f_f_3f_infix_test8";
  {  // f_f_3f_infix_test8
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    try {
      if (test.run(ge_a_f_f_3f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_3f_f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_3f_f_infix_test9.name("ge_a_f_3f_f_infix_test9");
  last_test = "ge_a_f_3f_f_infix_test9";
  {  // f_3f_f_infix_test9
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    try {
      if (test.run(ge_a_f_3f_f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_f_3f_f_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a >= b;
  } SH_END;

  ge_a_f_3f_f_infix_test10.name("ge_a_f_3f_f_infix_test10");
  last_test = "ge_a_f_3f_f_infix_test10";
  {  // f_3f_f_infix_test10
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(1));

    try {
      if (test.run(ge_a_f_3f_f_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_1f_1f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_1f_1f_infix_test11.name("ge_a_i_1f_1f_infix_test11");
  last_test = "ge_a_i_1f_1f_infix_test11";
  {  // i_1f_1f_infix_test11
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(ge_a_i_1f_1f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_1f_1f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_1f_1f_infix_test12.name("ge_a_i_1f_1f_infix_test12");
  last_test = "ge_a_i_1f_1f_infix_test12";
  {  // i_1f_1f_infix_test12
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    try {
      if (test.run(ge_a_i_1f_1f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_1f_1f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_1f_1f_infix_test13.name("ge_a_i_1f_1f_infix_test13");
  last_test = "ge_a_i_1f_1f_infix_test13";
  {  // i_1f_1f_infix_test13
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    try {
      if (test.run(ge_a_i_1f_1f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_3i_3i_infix_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_3i_3i_infix_test14.name("ge_a_i_3i_3i_infix_test14");
  last_test = "ge_a_i_3i_3i_infix_test14";
  {  // i_3i_3i_infix_test14
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(1));

    try {
      if (test.run(ge_a_i_3i_3i_infix_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_3i_3i_infix_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_3i_3i_infix_test15.name("ge_a_i_3i_3i_infix_test15");
  last_test = "ge_a_i_3i_3i_infix_test15";
  {  // i_3i_3i_infix_test15
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    try {
      if (test.run(ge_a_i_3i_3i_infix_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_3i_3i_infix_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_3i_3i_infix_test16.name("ge_a_i_3i_3i_infix_test16");
  last_test = "ge_a_i_3i_3i_infix_test16";
  {  // i_3i_3i_infix_test16
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    try {
      if (test.run(ge_a_i_3i_3i_infix_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_4i_4i_infix_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_4i_4i_infix_test17.name("ge_a_i_4i_4i_infix_test17");
  last_test = "ge_a_i_4i_4i_infix_test17";
  {  // i_4i_4i_infix_test17
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(1), int(1), int(0), int(1));

    try {
      if (test.run(ge_a_i_4i_4i_infix_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_i_3i_infix_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_i_3i_infix_test18.name("ge_a_i_i_3i_infix_test18");
  last_test = "ge_a_i_i_3i_infix_test18";
  {  // i_i_3i_infix_test18
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(0));

    try {
      if (test.run(ge_a_i_i_3i_infix_test18, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_i_3i_infix_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_i_3i_infix_test19.name("ge_a_i_i_3i_infix_test19");
  last_test = "ge_a_i_i_3i_infix_test19";
  {  // i_i_3i_infix_test19
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(ge_a_i_i_3i_infix_test19, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_3i_i_infix_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_3i_i_infix_test20.name("ge_a_i_3i_i_infix_test20");
  last_test = "ge_a_i_3i_i_infix_test20";
  {  // i_3i_i_infix_test20
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(ge_a_i_3i_i_infix_test20, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ge_a_i_3i_i_infix_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a >= b;
  } SH_END;

  ge_a_i_3i_i_infix_test21.name("ge_a_i_3i_i_infix_test21");
  last_test = "ge_a_i_3i_i_infix_test21";
  {  // i_3i_i_infix_test21
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(1));

    try {
      if (test.run(ge_a_i_3i_i_infix_test21, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_1f_1f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_1f_1f_infix_test0.name("eq_a_f_1f_1f_infix_test0");
  last_test = "eq_a_f_1f_1f_infix_test0";
  {  // f_1f_1f_infix_test0
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(eq_a_f_1f_1f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_1f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_1f_1f_infix_test1.name("eq_a_f_1f_1f_infix_test1");
  last_test = "eq_a_f_1f_1f_infix_test1";
  {  // f_1f_1f_infix_test1
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(eq_a_f_1f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_1f_1f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_1f_1f_infix_test2.name("eq_a_f_1f_1f_infix_test2");
  last_test = "eq_a_f_1f_1f_infix_test2";
  {  // f_1f_1f_infix_test2
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(eq_a_f_1f_1f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_3f_3f_infix_test3.name("eq_a_f_3f_3f_infix_test3");
  last_test = "eq_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(1));

    try {
      if (test.run(eq_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_3f_3f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_3f_3f_infix_test4.name("eq_a_f_3f_3f_infix_test4");
  last_test = "eq_a_f_3f_3f_infix_test4";
  {  // f_3f_3f_infix_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(1));

    try {
      if (test.run(eq_a_f_3f_3f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_3f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_3f_3f_infix_test5.name("eq_a_f_3f_3f_infix_test5");
  last_test = "eq_a_f_3f_3f_infix_test5";
  {  // f_3f_3f_infix_test5
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    try {
      if (test.run(eq_a_f_3f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_4f_4f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_4f_4f_infix_test6.name("eq_a_f_4f_4f_infix_test6");
  last_test = "eq_a_f_4f_4f_infix_test6";
  {  // f_4f_4f_infix_test6
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0), float(0), float(0));

    try {
      if (test.run(eq_a_f_4f_4f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_f_3f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_f_3f_infix_test7.name("eq_a_f_f_3f_infix_test7");
  last_test = "eq_a_f_f_3f_infix_test7";
  {  // f_f_3f_infix_test7
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    try {
      if (test.run(eq_a_f_f_3f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_f_3f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_f_3f_infix_test8.name("eq_a_f_f_3f_infix_test8");
  last_test = "eq_a_f_f_3f_infix_test8";
  {  // f_f_3f_infix_test8
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    try {
      if (test.run(eq_a_f_f_3f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_3f_f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_3f_f_infix_test9.name("eq_a_f_3f_f_infix_test9");
  last_test = "eq_a_f_3f_f_infix_test9";
  {  // f_3f_f_infix_test9
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    try {
      if (test.run(eq_a_f_3f_f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_f_3f_f_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a == b;
  } SH_END;

  eq_a_f_3f_f_infix_test10.name("eq_a_f_3f_f_infix_test10");
  last_test = "eq_a_f_3f_f_infix_test10";
  {  // f_3f_f_infix_test10
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    try {
      if (test.run(eq_a_f_3f_f_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_1f_1f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_1f_1f_infix_test11.name("eq_a_i_1f_1f_infix_test11");
  last_test = "eq_a_i_1f_1f_infix_test11";
  {  // i_1f_1f_infix_test11
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(eq_a_i_1f_1f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_1f_1f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_1f_1f_infix_test12.name("eq_a_i_1f_1f_infix_test12");
  last_test = "eq_a_i_1f_1f_infix_test12";
  {  // i_1f_1f_infix_test12
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    try {
      if (test.run(eq_a_i_1f_1f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_1f_1f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_1f_1f_infix_test13.name("eq_a_i_1f_1f_infix_test13");
  last_test = "eq_a_i_1f_1f_infix_test13";
  {  // i_1f_1f_infix_test13
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(eq_a_i_1f_1f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_3i_3i_infix_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_3i_3i_infix_test14.name("eq_a_i_3i_3i_infix_test14");
  last_test = "eq_a_i_3i_3i_infix_test14";
  {  // i_3i_3i_infix_test14
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(1));

    try {
      if (test.run(eq_a_i_3i_3i_infix_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_3i_3i_infix_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_3i_3i_infix_test15.name("eq_a_i_3i_3i_infix_test15");
  last_test = "eq_a_i_3i_3i_infix_test15";
  {  // i_3i_3i_infix_test15
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(1));

    try {
      if (test.run(eq_a_i_3i_3i_infix_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_3i_3i_infix_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_3i_3i_infix_test16.name("eq_a_i_3i_3i_infix_test16");
  last_test = "eq_a_i_3i_3i_infix_test16";
  {  // i_3i_3i_infix_test16
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    try {
      if (test.run(eq_a_i_3i_3i_infix_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_4i_4i_infix_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_4i_4i_infix_test17.name("eq_a_i_4i_4i_infix_test17");
  last_test = "eq_a_i_4i_4i_infix_test17";
  {  // i_4i_4i_infix_test17
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(1), int(0), int(0), int(0));

    try {
      if (test.run(eq_a_i_4i_4i_infix_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_i_3i_infix_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_i_3i_infix_test18.name("eq_a_i_i_3i_infix_test18");
  last_test = "eq_a_i_i_3i_infix_test18";
  {  // i_i_3i_infix_test18
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    try {
      if (test.run(eq_a_i_i_3i_infix_test18, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_i_3i_infix_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_i_3i_infix_test19.name("eq_a_i_i_3i_infix_test19");
  last_test = "eq_a_i_i_3i_infix_test19";
  {  // i_i_3i_infix_test19
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    try {
      if (test.run(eq_a_i_i_3i_infix_test19, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_3i_i_infix_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_3i_i_infix_test20.name("eq_a_i_3i_i_infix_test20");
  last_test = "eq_a_i_3i_i_infix_test20";
  {  // i_3i_i_infix_test20
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    try {
      if (test.run(eq_a_i_3i_i_infix_test20, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram eq_a_i_3i_i_infix_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a == b;
  } SH_END;

  eq_a_i_3i_i_infix_test21.name("eq_a_i_3i_i_infix_test21");
  last_test = "eq_a_i_3i_i_infix_test21";
  {  // i_3i_i_infix_test21
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    try {
      if (test.run(eq_a_i_3i_i_infix_test21, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_1f_1f_infix_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_1f_1f_infix_test0.name("ne_a_f_1f_1f_infix_test0");
  last_test = "ne_a_f_1f_1f_infix_test0";
  {  // f_1f_1f_infix_test0
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(ne_a_f_1f_1f_infix_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_1f_1f_infix_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_1f_1f_infix_test1.name("ne_a_f_1f_1f_infix_test1");
  last_test = "ne_a_f_1f_1f_infix_test1";
  {  // f_1f_1f_infix_test1
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    try {
      if (test.run(ne_a_f_1f_1f_infix_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_1f_1f_infix_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_1f_1f_infix_test2.name("ne_a_f_1f_1f_infix_test2");
  last_test = "ne_a_f_1f_1f_infix_test2";
  {  // f_1f_1f_infix_test2
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    try {
      if (test.run(ne_a_f_1f_1f_infix_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_3f_3f_infix_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_3f_3f_infix_test3.name("ne_a_f_3f_3f_infix_test3");
  last_test = "ne_a_f_3f_3f_infix_test3";
  {  // f_3f_3f_infix_test3
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(0));

    try {
      if (test.run(ne_a_f_3f_3f_infix_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_3f_3f_infix_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_3f_3f_infix_test4.name("ne_a_f_3f_3f_infix_test4");
  last_test = "ne_a_f_3f_3f_infix_test4";
  {  // f_3f_3f_infix_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(0));

    try {
      if (test.run(ne_a_f_3f_3f_infix_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_3f_3f_infix_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_3f_3f_infix_test5.name("ne_a_f_3f_3f_infix_test5");
  last_test = "ne_a_f_3f_3f_infix_test5";
  {  // f_3f_3f_infix_test5
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    try {
      if (test.run(ne_a_f_3f_3f_infix_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_4f_4f_infix_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<4, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_4f_4f_infix_test6.name("ne_a_f_4f_4f_infix_test6");
  last_test = "ne_a_f_4f_4f_infix_test6";
  {  // f_4f_4f_infix_test6
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(1), float(1), float(1));

    try {
      if (test.run(ne_a_f_4f_4f_infix_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_f_3f_infix_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_f_3f_infix_test7.name("ne_a_f_f_3f_infix_test7");
  last_test = "ne_a_f_f_3f_infix_test7";
  {  // f_f_3f_infix_test7
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    try {
      if (test.run(ne_a_f_f_3f_infix_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_f_3f_infix_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_f_3f_infix_test8.name("ne_a_f_f_3f_infix_test8");
  last_test = "ne_a_f_f_3f_infix_test8";
  {  // f_f_3f_infix_test8
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    try {
      if (test.run(ne_a_f_f_3f_infix_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_3f_f_infix_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_3f_f_infix_test9.name("ne_a_f_3f_f_infix_test9");
  last_test = "ne_a_f_3f_f_infix_test9";
  {  // f_3f_f_infix_test9
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    try {
      if (test.run(ne_a_f_3f_f_infix_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_f_3f_f_infix_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<3, SH_OUTPUT, float> out;
    out = a != b;
  } SH_END;

  ne_a_f_3f_f_infix_test10.name("ne_a_f_3f_f_infix_test10");
  last_test = "ne_a_f_3f_f_infix_test10";
  {  // f_3f_f_infix_test10
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    try {
      if (test.run(ne_a_f_3f_f_infix_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_1f_1f_infix_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_1f_1f_infix_test11.name("ne_a_i_1f_1f_infix_test11");
  last_test = "ne_a_i_1f_1f_infix_test11";
  {  // i_1f_1f_infix_test11
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    try {
      if (test.run(ne_a_i_1f_1f_infix_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_1f_1f_infix_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_1f_1f_infix_test12.name("ne_a_i_1f_1f_infix_test12");
  last_test = "ne_a_i_1f_1f_infix_test12";
  {  // i_1f_1f_infix_test12
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    try {
      if (test.run(ne_a_i_1f_1f_infix_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_1f_1f_infix_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_1f_1f_infix_test13.name("ne_a_i_1f_1f_infix_test13");
  last_test = "ne_a_i_1f_1f_infix_test13";
  {  // i_1f_1f_infix_test13
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    try {
      if (test.run(ne_a_i_1f_1f_infix_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_3i_3i_infix_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_3i_3i_infix_test14.name("ne_a_i_3i_3i_infix_test14");
  last_test = "ne_a_i_3i_3i_infix_test14";
  {  // i_3i_3i_infix_test14
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(0));

    try {
      if (test.run(ne_a_i_3i_3i_infix_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_3i_3i_infix_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_3i_3i_infix_test15.name("ne_a_i_3i_3i_infix_test15");
  last_test = "ne_a_i_3i_3i_infix_test15";
  {  // i_3i_3i_infix_test15
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(0));

    try {
      if (test.run(ne_a_i_3i_3i_infix_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_3i_3i_infix_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_3i_3i_infix_test16.name("ne_a_i_3i_3i_infix_test16");
  last_test = "ne_a_i_3i_3i_infix_test16";
  {  // i_3i_3i_infix_test16
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(ne_a_i_3i_3i_infix_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_4i_4i_infix_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, int> a;
    ShAttrib<4, SH_INPUT, int> b;
    ShAttrib<4, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_4i_4i_infix_test17.name("ne_a_i_4i_4i_infix_test17");
  last_test = "ne_a_i_4i_4i_infix_test17";
  {  // i_4i_4i_infix_test17
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(1), int(1), int(1));

    try {
      if (test.run(ne_a_i_4i_4i_infix_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_i_3i_infix_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_i_3i_infix_test18.name("ne_a_i_i_3i_infix_test18");
  last_test = "ne_a_i_i_3i_infix_test18";
  {  // i_i_3i_infix_test18
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    try {
      if (test.run(ne_a_i_i_3i_infix_test18, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_i_3i_infix_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, int> a;
    ShAttrib<3, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_i_3i_infix_test19.name("ne_a_i_i_3i_infix_test19");
  last_test = "ne_a_i_i_3i_infix_test19";
  {  // i_i_3i_infix_test19
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(ne_a_i_i_3i_infix_test19, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_3i_i_infix_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_3i_i_infix_test20.name("ne_a_i_3i_i_infix_test20");
  last_test = "ne_a_i_3i_i_infix_test20";
  {  // i_3i_i_infix_test20
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    try {
      if (test.run(ne_a_i_3i_i_infix_test20, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram ne_a_i_3i_i_infix_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, int> a;
    ShAttrib<1, SH_INPUT, int> b;
    ShAttrib<3, SH_OUTPUT, int> out;
    out = a != b;
  } SH_END;

  ne_a_i_3i_i_infix_test21.name("ne_a_i_3i_i_infix_test21");
  last_test = "ne_a_i_3i_i_infix_test21";
  {  // i_3i_i_infix_test21
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    try {
      if (test.run(ne_a_i_3i_i_infix_test21, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_1f_1f_infix_test0
    last_test = "f_1f_1f_infix_test0";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_1f_1f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test1
    last_test = "f_1f_1f_infix_test1";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_1f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test2
    last_test = "f_1f_1f_infix_test2";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_1f_1f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test4
    last_test = "f_3f_3f_infix_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_3f_3f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test6
    last_test = "f_4f_4f_infix_test6";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(0), float(1), float(0));

    ShAttrib<4, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_4f_4f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test7
    last_test = "f_f_3f_infix_test7";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_f_3f_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test8
    last_test = "f_f_3f_infix_test8";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test9
    last_test = "f_3f_f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_3f_f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test10
    last_test = "f_3f_f_infix_test10";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a < b;

    try {
      if (test.check("f_3f_f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test11
    last_test = "i_1f_1f_infix_test11";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    ShAttrib<1, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_1f_1f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test12
    last_test = "i_1f_1f_infix_test12";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_1f_1f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test13
    last_test = "i_1f_1f_infix_test13";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_1f_1f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test14
    last_test = "i_3i_3i_infix_test14";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_3i_3i_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test15
    last_test = "i_3i_3i_infix_test15";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_3i_3i_infix_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test16
    last_test = "i_3i_3i_infix_test16";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_3i_3i_infix_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_infix_test17
    last_test = "i_4i_4i_infix_test17";
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(0), int(1), int(0));

    ShAttrib<4, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_4i_4i_infix_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test18
    last_test = "i_i_3i_infix_test18";
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_i_3i_infix_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test19
    last_test = "i_i_3i_infix_test19";
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_i_3i_infix_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test20
    last_test = "i_3i_i_infix_test20";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_3i_i_infix_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test21
    last_test = "i_3i_i_infix_test21";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a < b;

    try {
      if (test.check("i_3i_i_infix_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test0
    last_test = "f_1f_1f_infix_test0";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_1f_1f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test1
    last_test = "f_1f_1f_infix_test1";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_1f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test2
    last_test = "f_1f_1f_infix_test2";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_1f_1f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test4
    last_test = "f_3f_3f_infix_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_3f_3f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test6
    last_test = "f_4f_4f_infix_test6";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0), float(1), float(0));

    ShAttrib<4, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_4f_4f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test7
    last_test = "f_f_3f_infix_test7";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_f_3f_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test8
    last_test = "f_f_3f_infix_test8";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test9
    last_test = "f_3f_f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_3f_f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test10
    last_test = "f_3f_f_infix_test10";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a <= b;

    try {
      if (test.check("f_3f_f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test11
    last_test = "i_1f_1f_infix_test11";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    ShAttrib<1, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_1f_1f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test12
    last_test = "i_1f_1f_infix_test12";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    ShAttrib<1, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_1f_1f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test13
    last_test = "i_1f_1f_infix_test13";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_1f_1f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test14
    last_test = "i_3i_3i_infix_test14";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_3i_3i_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test15
    last_test = "i_3i_3i_infix_test15";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_3i_3i_infix_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test16
    last_test = "i_3i_3i_infix_test16";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_3i_3i_infix_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_infix_test17
    last_test = "i_4i_4i_infix_test17";
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(1), int(0), int(1), int(0));

    ShAttrib<4, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_4i_4i_infix_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test18
    last_test = "i_i_3i_infix_test18";
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_i_3i_infix_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test19
    last_test = "i_i_3i_infix_test19";
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_i_3i_infix_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test20
    last_test = "i_3i_i_infix_test20";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_3i_i_infix_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test21
    last_test = "i_3i_i_infix_test21";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a <= b;

    try {
      if (test.check("i_3i_i_infix_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test0
    last_test = "f_1f_1f_infix_test0";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_1f_1f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test1
    last_test = "f_1f_1f_infix_test1";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_1f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test2
    last_test = "f_1f_1f_infix_test2";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_1f_1f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test4
    last_test = "f_3f_3f_infix_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_3f_3f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test6
    last_test = "f_4f_4f_infix_test6";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(1), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_4f_4f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test7
    last_test = "f_f_3f_infix_test7";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_f_3f_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test8
    last_test = "f_f_3f_infix_test8";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test9
    last_test = "f_3f_f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_3f_f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test10
    last_test = "f_3f_f_infix_test10";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a > b;

    try {
      if (test.check("f_3f_f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test11
    last_test = "i_1f_1f_infix_test11";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_1f_1f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test12
    last_test = "i_1f_1f_infix_test12";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_1f_1f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test13
    last_test = "i_1f_1f_infix_test13";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    ShAttrib<1, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_1f_1f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test14
    last_test = "i_3i_3i_infix_test14";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_3i_3i_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test15
    last_test = "i_3i_3i_infix_test15";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_3i_3i_infix_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test16
    last_test = "i_3i_3i_infix_test16";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_3i_3i_infix_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_infix_test17
    last_test = "i_4i_4i_infix_test17";
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(1), int(0), int(1));

    ShAttrib<4, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_4i_4i_infix_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test18
    last_test = "i_i_3i_infix_test18";
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_i_3i_infix_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test19
    last_test = "i_i_3i_infix_test19";
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_i_3i_infix_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test20
    last_test = "i_3i_i_infix_test20";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_3i_i_infix_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test21
    last_test = "i_3i_i_infix_test21";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a > b;

    try {
      if (test.check("i_3i_i_infix_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test0
    last_test = "f_1f_1f_infix_test0";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_1f_1f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test1
    last_test = "f_1f_1f_infix_test1";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_1f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test2
    last_test = "f_1f_1f_infix_test2";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_1f_1f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test4
    last_test = "f_3f_3f_infix_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_3f_3f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test6
    last_test = "f_4f_4f_infix_test6";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(1), float(0), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_4f_4f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test7
    last_test = "f_f_3f_infix_test7";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_f_3f_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test8
    last_test = "f_f_3f_infix_test8";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test9
    last_test = "f_3f_f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_3f_f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test10
    last_test = "f_3f_f_infix_test10";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a >= b;

    try {
      if (test.check("f_3f_f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test11
    last_test = "i_1f_1f_infix_test11";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_1f_1f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test12
    last_test = "i_1f_1f_infix_test12";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    ShAttrib<1, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_1f_1f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test13
    last_test = "i_1f_1f_infix_test13";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    ShAttrib<1, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_1f_1f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test14
    last_test = "i_3i_3i_infix_test14";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_3i_3i_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test15
    last_test = "i_3i_3i_infix_test15";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_3i_3i_infix_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test16
    last_test = "i_3i_3i_infix_test16";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_3i_3i_infix_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_infix_test17
    last_test = "i_4i_4i_infix_test17";
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(1), int(1), int(0), int(1));

    ShAttrib<4, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_4i_4i_infix_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test18
    last_test = "i_i_3i_infix_test18";
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_i_3i_infix_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test19
    last_test = "i_i_3i_infix_test19";
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_i_3i_infix_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test20
    last_test = "i_3i_i_infix_test20";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_3i_i_infix_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test21
    last_test = "i_3i_i_infix_test21";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a >= b;

    try {
      if (test.check("i_3i_i_infix_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test0
    last_test = "f_1f_1f_infix_test0";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_1f_1f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test1
    last_test = "f_1f_1f_infix_test1";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_1f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test2
    last_test = "f_1f_1f_infix_test2";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_1f_1f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test4
    last_test = "f_3f_3f_infix_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_3f_3f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test6
    last_test = "f_4f_4f_infix_test6";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(1), float(0), float(0), float(0));

    ShAttrib<4, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_4f_4f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test7
    last_test = "f_f_3f_infix_test7";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_f_3f_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test8
    last_test = "f_f_3f_infix_test8";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test9
    last_test = "f_3f_f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(0), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_3f_f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test10
    last_test = "f_3f_f_infix_test10";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(0), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a == b;

    try {
      if (test.check("f_3f_f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test11
    last_test = "i_1f_1f_infix_test11";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_1f_1f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test12
    last_test = "i_1f_1f_infix_test12";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    ShAttrib<1, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_1f_1f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test13
    last_test = "i_1f_1f_infix_test13";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_1f_1f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test14
    last_test = "i_3i_3i_infix_test14";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_3i_3i_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test15
    last_test = "i_3i_3i_infix_test15";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_3i_3i_infix_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test16
    last_test = "i_3i_3i_infix_test16";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_3i_3i_infix_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_infix_test17
    last_test = "i_4i_4i_infix_test17";
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(1), int(0), int(0), int(0));

    ShAttrib<4, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_4i_4i_infix_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test18
    last_test = "i_i_3i_infix_test18";
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_i_3i_infix_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test19
    last_test = "i_i_3i_infix_test19";
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_i_3i_infix_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test20
    last_test = "i_3i_i_infix_test20";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(0), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_3i_i_infix_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test21
    last_test = "i_3i_i_infix_test21";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(0), int(1), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a == b;

    try {
      if (test.check("i_3i_i_infix_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test0
    last_test = "f_1f_1f_infix_test0";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_1f_1f_infix_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test1
    last_test = "f_1f_1f_infix_test1";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0));

    ShAttrib<1, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_1f_1f_infix_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_infix_test2
    last_test = "f_1f_1f_infix_test2";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1));

    ShAttrib<1, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_1f_1f_infix_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test3
    last_test = "f_3f_3f_infix_test3";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(2.0), float(1.0), float(3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_3f_3f_infix_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test4
    last_test = "f_3f_3f_infix_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(-1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(0));

    ShAttrib<3, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_3f_3f_infix_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_infix_test5
    last_test = "f_3f_3f_infix_test5";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(-2.0), float(1.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_3f_3f_infix_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_infix_test6
    last_test = "f_4f_4f_infix_test6";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(1.0), float(-0.5), float(0.1));
    ShAttrib<4, SH_CONST, float> b(float(0.0), float(0.0), float(1.0), float(-1.0));
    ShAttrib<4, SH_CONST, float> expected(float(0), float(1), float(1), float(1));

    ShAttrib<4, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_4f_4f_infix_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test7
    last_test = "f_f_3f_infix_test7";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_f_3f_infix_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_f_3f_infix_test8
    last_test = "f_f_3f_infix_test8";
    ShAttrib<1, SH_CONST, float> a(float(2.0));
    ShAttrib<3, SH_CONST, float> b(float(-1.0), float(0.0), float(1.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_f_3f_infix_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test9
    last_test = "f_3f_f_infix_test9";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(-2.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(1), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_3f_f_infix_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_f_infix_test10
    last_test = "f_3f_f_infix_test10";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(0.0), float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(0.0));
    ShAttrib<3, SH_CONST, float> expected(float(1), float(0), float(1));

    ShAttrib<3, SH_TEMP, float> out;
    out = a != b;

    try {
      if (test.check("f_3f_f_infix_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test11
    last_test = "i_1f_1f_infix_test11";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    ShAttrib<1, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_1f_1f_infix_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test12
    last_test = "i_1f_1f_infix_test12";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(0));

    ShAttrib<1, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_1f_1f_infix_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_1f_1f_infix_test13
    last_test = "i_1f_1f_infix_test13";
    ShAttrib<1, SH_CONST, float> a(float(3.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, int> expected(int(1));

    ShAttrib<1, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_1f_1f_infix_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test14
    last_test = "i_3i_3i_infix_test14";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(2.0), int(1.0), int(3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_3i_3i_infix_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test15
    last_test = "i_3i_3i_infix_test15";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(-2.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(-1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(0));

    ShAttrib<3, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_3i_3i_infix_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_3i_infix_test16
    last_test = "i_3i_3i_infix_test16";
    ShAttrib<3, SH_CONST, int> a(int(1.0), int(-2.0), int(3.0));
    ShAttrib<3, SH_CONST, int> b(int(-2.0), int(1.0), int(-3.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_3i_3i_infix_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_4i_4i_infix_test17
    last_test = "i_4i_4i_infix_test17";
    ShAttrib<4, SH_CONST, int> a(int(0.0), int(1.0), int(-0.5), int(0.1));
    ShAttrib<4, SH_CONST, int> b(int(0.0), int(0.0), int(1.0), int(-1.0));
    ShAttrib<4, SH_CONST, int> expected(int(0), int(1), int(1), int(1));

    ShAttrib<4, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_4i_4i_infix_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test18
    last_test = "i_i_3i_infix_test18";
    ShAttrib<1, SH_CONST, int> a(int(0.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_i_3i_infix_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_i_3i_infix_test19
    last_test = "i_i_3i_infix_test19";
    ShAttrib<1, SH_CONST, int> a(int(2.0));
    ShAttrib<3, SH_CONST, int> b(int(-1.0), int(0.0), int(1.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_i_3i_infix_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test20
    last_test = "i_3i_i_infix_test20";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(-2.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(1), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_3i_i_infix_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // i_3i_i_infix_test21
    last_test = "i_3i_i_infix_test21";
    ShAttrib<3, SH_CONST, int> a(int(-1.0), int(0.0), int(1.0));
    ShAttrib<1, SH_CONST, int> b(int(0.0));
    ShAttrib<3, SH_CONST, int> expected(int(1), int(0), int(1));

    ShAttrib<3, SH_TEMP, int> out;
    out = a != b;

    try {
      if (test.check("i_3i_i_infix_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

