#include "test.hpp"

int main(int argc, char** argv) {
  using namespace SH;

  char* last_test = "none";

  Test test(argc, argv);

  int errors = 0, total_tests = 0;
  ShProgram length_a_f_3f_calllength_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test0.name("length_a_f_3f_calllength_test0");
  last_test = "length_a_f_3f_calllength_test0";
  {  // f_3f_calllength_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    try {
      if (test.run(length_a_f_3f_calllength_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test1.name("length_a_f_3f_calllength_test1");
  last_test = "length_a_f_3f_calllength_test1";
  {  // f_3f_calllength_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    try {
      if (test.run(length_a_f_3f_calllength_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test2.name("length_a_f_3f_calllength_test2");
  last_test = "length_a_f_3f_calllength_test2";
  {  // f_3f_calllength_test2
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    try {
      if (test.run(length_a_f_3f_calllength_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test3.name("length_a_f_3f_calllength_test3");
  last_test = "length_a_f_3f_calllength_test3";
  {  // f_3f_calllength_test3
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    try {
      if (test.run(length_a_f_3f_calllength_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test4.name("length_a_f_3f_calllength_test4");
  last_test = "length_a_f_3f_calllength_test4";
  {  // f_3f_calllength_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    try {
      if (test.run(length_a_f_3f_calllength_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test5.name("length_a_f_3f_calllength_test5");
  last_test = "length_a_f_3f_calllength_test5";
  {  // f_3f_calllength_test5
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    try {
      if (test.run(length_a_f_3f_calllength_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test6.name("length_a_f_3f_calllength_test6");
  last_test = "length_a_f_3f_calllength_test6";
  {  // f_3f_calllength_test6
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    try {
      if (test.run(length_a_f_3f_calllength_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test7.name("length_a_f_3f_calllength_test7");
  last_test = "length_a_f_3f_calllength_test7";
  {  // f_3f_calllength_test7
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    try {
      if (test.run(length_a_f_3f_calllength_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test8.name("length_a_f_3f_calllength_test8");
  last_test = "length_a_f_3f_calllength_test8";
  {  // f_3f_calllength_test8
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    try {
      if (test.run(length_a_f_3f_calllength_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test9.name("length_a_f_3f_calllength_test9");
  last_test = "length_a_f_3f_calllength_test9";
  {  // f_3f_calllength_test9
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    try {
      if (test.run(length_a_f_3f_calllength_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test10.name("length_a_f_3f_calllength_test10");
  last_test = "length_a_f_3f_calllength_test10";
  {  // f_3f_calllength_test10
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    try {
      if (test.run(length_a_f_3f_calllength_test10, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test11.name("length_a_f_3f_calllength_test11");
  last_test = "length_a_f_3f_calllength_test11";
  {  // f_3f_calllength_test11
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    try {
      if (test.run(length_a_f_3f_calllength_test11, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_1f_calllength_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_1f_calllength_test12.name("length_a_f_1f_calllength_test12");
  last_test = "length_a_f_1f_calllength_test12";
  {  // f_1f_calllength_test12
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_a_f_1f_calllength_test12, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_3f_calllength_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_3f_calllength_test13.name("length_a_f_3f_calllength_test13");
  last_test = "length_a_f_3f_calllength_test13";
  {  // f_3f_calllength_test13
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_a_f_3f_calllength_test13, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_4f_calllength_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_4f_calllength_test14.name("length_a_f_4f_calllength_test14");
  last_test = "length_a_f_4f_calllength_test14";
  {  // f_4f_calllength_test14
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_a_f_4f_calllength_test14, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_4f_calllength_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_4f_calllength_test15.name("length_a_f_4f_calllength_test15");
  last_test = "length_a_f_4f_calllength_test15";
  {  // f_4f_calllength_test15
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_a_f_4f_calllength_test15, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_1f_calllength_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_1f_calllength_test16.name("length_a_f_1f_calllength_test16");
  last_test = "length_a_f_1f_calllength_test16";
  {  // f_1f_calllength_test16
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(length_a_f_1f_calllength_test16, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_1f_calllength_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_1f_calllength_test17.name("length_a_f_1f_calllength_test17");
  last_test = "length_a_f_1f_calllength_test17";
  {  // f_1f_calllength_test17
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(length_a_f_1f_calllength_test17, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_1f_calllength_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_1f_calllength_test18.name("length_a_f_1f_calllength_test18");
  last_test = "length_a_f_1f_calllength_test18";
  {  // f_1f_calllength_test18
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    try {
      if (test.run(length_a_f_1f_calllength_test18, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_1f_calllength_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_1f_calllength_test19.name("length_a_f_1f_calllength_test19");
  last_test = "length_a_f_1f_calllength_test19";
  {  // f_1f_calllength_test19
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    try {
      if (test.run(length_a_f_1f_calllength_test19, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_1f_calllength_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_1f_calllength_test20.name("length_a_f_1f_calllength_test20");
  last_test = "length_a_f_1f_calllength_test20";
  {  // f_1f_calllength_test20
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    try {
      if (test.run(length_a_f_1f_calllength_test20, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_a_f_1f_calllength_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length(a);
  } SH_END;

  length_a_f_1f_calllength_test21.name("length_a_f_1f_calllength_test21");
  last_test = "length_a_f_1f_calllength_test21";
  {  // f_1f_calllength_test21
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    try {
      if (test.run(length_a_f_1f_calllength_test21, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test0.name("length_1_a_f_3f_calllength1_test0");
  last_test = "length_1_a_f_3f_calllength1_test0";
  {  // f_3f_calllength1_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test1.name("length_1_a_f_3f_calllength1_test1");
  last_test = "length_1_a_f_3f_calllength1_test1";
  {  // f_3f_calllength1_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test2.name("length_1_a_f_3f_calllength1_test2");
  last_test = "length_1_a_f_3f_calllength1_test2";
  {  // f_3f_calllength1_test2
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test3.name("length_1_a_f_3f_calllength1_test3");
  last_test = "length_1_a_f_3f_calllength1_test3";
  {  // f_3f_calllength1_test3
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test4.name("length_1_a_f_3f_calllength1_test4");
  last_test = "length_1_a_f_3f_calllength1_test4";
  {  // f_3f_calllength1_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test5.name("length_1_a_f_3f_calllength1_test5");
  last_test = "length_1_a_f_3f_calllength1_test5";
  {  // f_3f_calllength1_test5
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test6.name("length_1_a_f_3f_calllength1_test6");
  last_test = "length_1_a_f_3f_calllength1_test6";
  {  // f_3f_calllength1_test6
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test7.name("length_1_a_f_3f_calllength1_test7");
  last_test = "length_1_a_f_3f_calllength1_test7";
  {  // f_3f_calllength1_test7
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test8.name("length_1_a_f_3f_calllength1_test8");
  last_test = "length_1_a_f_3f_calllength1_test8";
  {  // f_3f_calllength1_test8
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test9.name("length_1_a_f_3f_calllength1_test9");
  last_test = "length_1_a_f_3f_calllength1_test9";
  {  // f_3f_calllength1_test9
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test10.name("length_1_a_f_3f_calllength1_test10");
  last_test = "length_1_a_f_3f_calllength1_test10";
  {  // f_3f_calllength1_test10
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test10, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test11.name("length_1_a_f_3f_calllength1_test11");
  last_test = "length_1_a_f_3f_calllength1_test11";
  {  // f_3f_calllength1_test11
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test11, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_1f_calllength1_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_1f_calllength1_test12.name("length_1_a_f_1f_calllength1_test12");
  last_test = "length_1_a_f_1f_calllength1_test12";
  {  // f_1f_calllength1_test12
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_1_a_f_1f_calllength1_test12, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_3f_calllength1_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_3f_calllength1_test13.name("length_1_a_f_3f_calllength1_test13");
  last_test = "length_1_a_f_3f_calllength1_test13";
  {  // f_3f_calllength1_test13
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_1_a_f_3f_calllength1_test13, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_4f_calllength1_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_4f_calllength1_test14.name("length_1_a_f_4f_calllength1_test14");
  last_test = "length_1_a_f_4f_calllength1_test14";
  {  // f_4f_calllength1_test14
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_1_a_f_4f_calllength1_test14, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_4f_calllength1_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_4f_calllength1_test15.name("length_1_a_f_4f_calllength1_test15");
  last_test = "length_1_a_f_4f_calllength1_test15";
  {  // f_4f_calllength1_test15
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_1_a_f_4f_calllength1_test15, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_1f_calllength1_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_1f_calllength1_test16.name("length_1_a_f_1f_calllength1_test16");
  last_test = "length_1_a_f_1f_calllength1_test16";
  {  // f_1f_calllength1_test16
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(length_1_a_f_1f_calllength1_test16, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_1f_calllength1_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_1f_calllength1_test17.name("length_1_a_f_1f_calllength1_test17");
  last_test = "length_1_a_f_1f_calllength1_test17";
  {  // f_1f_calllength1_test17
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(length_1_a_f_1f_calllength1_test17, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_1f_calllength1_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_1f_calllength1_test18.name("length_1_a_f_1f_calllength1_test18");
  last_test = "length_1_a_f_1f_calllength1_test18";
  {  // f_1f_calllength1_test18
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    try {
      if (test.run(length_1_a_f_1f_calllength1_test18, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_1f_calllength1_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_1f_calllength1_test19.name("length_1_a_f_1f_calllength1_test19");
  last_test = "length_1_a_f_1f_calllength1_test19";
  {  // f_1f_calllength1_test19
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    try {
      if (test.run(length_1_a_f_1f_calllength1_test19, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_1f_calllength1_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_1f_calllength1_test20.name("length_1_a_f_1f_calllength1_test20");
  last_test = "length_1_a_f_1f_calllength1_test20";
  {  // f_1f_calllength1_test20
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    try {
      if (test.run(length_1_a_f_1f_calllength1_test20, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_1_a_f_1f_calllength1_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_1(a);
  } SH_END;

  length_1_a_f_1f_calllength1_test21.name("length_1_a_f_1f_calllength1_test21");
  last_test = "length_1_a_f_1f_calllength1_test21";
  {  // f_1f_calllength1_test21
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    try {
      if (test.run(length_1_a_f_1f_calllength1_test21, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test0.name("length_inf_a_f_3f_calllengthinf_test0");
  last_test = "length_inf_a_f_3f_calllengthinf_test0";
  {  // f_3f_calllengthinf_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test0, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test1.name("length_inf_a_f_3f_calllengthinf_test1");
  last_test = "length_inf_a_f_3f_calllengthinf_test1";
  {  // f_3f_calllengthinf_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test1, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test2.name("length_inf_a_f_3f_calllengthinf_test2");
  last_test = "length_inf_a_f_3f_calllengthinf_test2";
  {  // f_3f_calllengthinf_test2
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test2, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test3.name("length_inf_a_f_3f_calllengthinf_test3");
  last_test = "length_inf_a_f_3f_calllengthinf_test3";
  {  // f_3f_calllengthinf_test3
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test3, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test4.name("length_inf_a_f_3f_calllengthinf_test4");
  last_test = "length_inf_a_f_3f_calllengthinf_test4";
  {  // f_3f_calllengthinf_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test4, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test5.name("length_inf_a_f_3f_calllengthinf_test5");
  last_test = "length_inf_a_f_3f_calllengthinf_test5";
  {  // f_3f_calllengthinf_test5
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test5, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test6.name("length_inf_a_f_3f_calllengthinf_test6");
  last_test = "length_inf_a_f_3f_calllengthinf_test6";
  {  // f_3f_calllengthinf_test6
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test6, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test7.name("length_inf_a_f_3f_calllengthinf_test7");
  last_test = "length_inf_a_f_3f_calllengthinf_test7";
  {  // f_3f_calllengthinf_test7
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test7, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test8.name("length_inf_a_f_3f_calllengthinf_test8");
  last_test = "length_inf_a_f_3f_calllengthinf_test8";
  {  // f_3f_calllengthinf_test8
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test8, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test9.name("length_inf_a_f_3f_calllengthinf_test9");
  last_test = "length_inf_a_f_3f_calllengthinf_test9";
  {  // f_3f_calllengthinf_test9
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test9, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test10.name("length_inf_a_f_3f_calllengthinf_test10");
  last_test = "length_inf_a_f_3f_calllengthinf_test10";
  {  // f_3f_calllengthinf_test10
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test10, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test11.name("length_inf_a_f_3f_calllengthinf_test11");
  last_test = "length_inf_a_f_3f_calllengthinf_test11";
  {  // f_3f_calllengthinf_test11
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test11, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_1f_calllengthinf_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_1f_calllengthinf_test12.name("length_inf_a_f_1f_calllengthinf_test12");
  last_test = "length_inf_a_f_1f_calllengthinf_test12";
  {  // f_1f_calllengthinf_test12
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_inf_a_f_1f_calllengthinf_test12, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_3f_calllengthinf_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_3f_calllengthinf_test13.name("length_inf_a_f_3f_calllengthinf_test13");
  last_test = "length_inf_a_f_3f_calllengthinf_test13";
  {  // f_3f_calllengthinf_test13
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_inf_a_f_3f_calllengthinf_test13, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_4f_calllengthinf_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_4f_calllengthinf_test14.name("length_inf_a_f_4f_calllengthinf_test14");
  last_test = "length_inf_a_f_4f_calllengthinf_test14";
  {  // f_4f_calllengthinf_test14
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_inf_a_f_4f_calllengthinf_test14, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_4f_calllengthinf_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_4f_calllengthinf_test15.name("length_inf_a_f_4f_calllengthinf_test15");
  last_test = "length_inf_a_f_4f_calllengthinf_test15";
  {  // f_4f_calllengthinf_test15
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(length_inf_a_f_4f_calllengthinf_test15, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_1f_calllengthinf_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_1f_calllengthinf_test16.name("length_inf_a_f_1f_calllengthinf_test16");
  last_test = "length_inf_a_f_1f_calllengthinf_test16";
  {  // f_1f_calllengthinf_test16
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(length_inf_a_f_1f_calllengthinf_test16, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_1f_calllengthinf_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_1f_calllengthinf_test17.name("length_inf_a_f_1f_calllengthinf_test17");
  last_test = "length_inf_a_f_1f_calllengthinf_test17";
  {  // f_1f_calllengthinf_test17
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    try {
      if (test.run(length_inf_a_f_1f_calllengthinf_test17, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_1f_calllengthinf_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_1f_calllengthinf_test18.name("length_inf_a_f_1f_calllengthinf_test18");
  last_test = "length_inf_a_f_1f_calllengthinf_test18";
  {  // f_1f_calllengthinf_test18
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    try {
      if (test.run(length_inf_a_f_1f_calllengthinf_test18, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_1f_calllengthinf_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_1f_calllengthinf_test19.name("length_inf_a_f_1f_calllengthinf_test19");
  last_test = "length_inf_a_f_1f_calllengthinf_test19";
  {  // f_1f_calllengthinf_test19
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    try {
      if (test.run(length_inf_a_f_1f_calllengthinf_test19, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_1f_calllengthinf_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_1f_calllengthinf_test20.name("length_inf_a_f_1f_calllengthinf_test20");
  last_test = "length_inf_a_f_1f_calllengthinf_test20";
  {  // f_1f_calllengthinf_test20
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    try {
      if (test.run(length_inf_a_f_1f_calllengthinf_test20, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram length_inf_a_f_1f_calllengthinf_test21 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = length_inf(a);
  } SH_END;

  length_inf_a_f_1f_calllengthinf_test21.name("length_inf_a_f_1f_calllengthinf_test21");
  last_test = "length_inf_a_f_1f_calllengthinf_test21";
  {  // f_1f_calllengthinf_test21
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    try {
      if (test.run(length_inf_a_f_1f_calllengthinf_test21, a, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test0.name("distance_a_f_3f_3f_calldistance_test0");
  last_test = "distance_a_f_3f_3f_calldistance_test0";
  {  // f_3f_3f_calldistance_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(5.19615242271));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test1.name("distance_a_f_3f_3f_calldistance_test1");
  last_test = "distance_a_f_3f_3f_calldistance_test1";
  {  // f_3f_3f_calldistance_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(10.7238052948));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test2.name("distance_a_f_3f_3f_calldistance_test2");
  last_test = "distance_a_f_3f_3f_calldistance_test2";
  {  // f_3f_3f_calldistance_test2
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(11.7898261226));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test3.name("distance_a_f_3f_3f_calldistance_test3");
  last_test = "distance_a_f_3f_3f_calldistance_test3";
  {  // f_3f_3f_calldistance_test3
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(-5), float(-6));
    ShAttrib<1, SH_CONST, float> expected(float(5.19615242271));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test4.name("distance_a_f_3f_3f_calldistance_test4");
  last_test = "distance_a_f_3f_3f_calldistance_test4";
  {  // f_3f_3f_calldistance_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(9.11043357914));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test5.name("distance_a_f_3f_3f_calldistance_test5");
  last_test = "distance_a_f_3f_3f_calldistance_test5";
  {  // f_3f_3f_calldistance_test5
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(6.5574385243));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test6.name("distance_a_f_3f_3f_calldistance_test6");
  last_test = "distance_a_f_3f_3f_calldistance_test6";
  {  // f_3f_3f_calldistance_test6
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(94.3924158023));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test7.name("distance_a_f_3f_3f_calldistance_test7");
  last_test = "distance_a_f_3f_3f_calldistance_test7";
  {  // f_3f_3f_calldistance_test7
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(98.5129548892));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test8.name("distance_a_f_3f_3f_calldistance_test8");
  last_test = "distance_a_f_3f_3f_calldistance_test8";
  {  // f_3f_3f_calldistance_test8
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(94.3924158023));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test9.name("distance_a_f_3f_3f_calldistance_test9");
  last_test = "distance_a_f_3f_3f_calldistance_test9";
  {  // f_3f_3f_calldistance_test9
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(98.5129548892));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test10.name("distance_a_f_3f_3f_calldistance_test10");
  last_test = "distance_a_f_3f_3f_calldistance_test10";
  {  // f_3f_3f_calldistance_test10
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(98.5133609263));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test11.name("distance_a_f_3f_3f_calldistance_test11");
  last_test = "distance_a_f_3f_3f_calldistance_test11";
  {  // f_3f_3f_calldistance_test11
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(100.370126437));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_1f_1f_calldistance_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_1f_1f_calldistance_test12.name("distance_a_f_1f_1f_calldistance_test12");
  last_test = "distance_a_f_1f_1f_calldistance_test12";
  {  // f_1f_1f_calldistance_test12
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_a_f_1f_1f_calldistance_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_3f_3f_calldistance_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_3f_3f_calldistance_test13.name("distance_a_f_3f_3f_calldistance_test13");
  last_test = "distance_a_f_3f_3f_calldistance_test13";
  {  // f_3f_3f_calldistance_test13
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_a_f_3f_3f_calldistance_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_4f_4f_calldistance_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_4f_4f_calldistance_test14.name("distance_a_f_4f_4f_calldistance_test14");
  last_test = "distance_a_f_4f_4f_calldistance_test14";
  {  // f_4f_4f_calldistance_test14
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_a_f_4f_4f_calldistance_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_1f_1f_calldistance_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_1f_1f_calldistance_test15.name("distance_a_f_1f_1f_calldistance_test15");
  last_test = "distance_a_f_1f_1f_calldistance_test15";
  {  // f_1f_1f_calldistance_test15
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_a_f_1f_1f_calldistance_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_1f_1f_calldistance_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_1f_1f_calldistance_test16.name("distance_a_f_1f_1f_calldistance_test16");
  last_test = "distance_a_f_1f_1f_calldistance_test16";
  {  // f_1f_1f_calldistance_test16
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(2.0));

    try {
      if (test.run(distance_a_f_1f_1f_calldistance_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_1f_1f_calldistance_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_1f_1f_calldistance_test17.name("distance_a_f_1f_1f_calldistance_test17");
  last_test = "distance_a_f_1f_1f_calldistance_test17";
  {  // f_1f_1f_calldistance_test17
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(98.0));

    try {
      if (test.run(distance_a_f_1f_1f_calldistance_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_1f_1f_calldistance_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_1f_1f_calldistance_test18.name("distance_a_f_1f_1f_calldistance_test18");
  last_test = "distance_a_f_1f_1f_calldistance_test18";
  {  // f_1f_1f_calldistance_test18
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.4));
    ShAttrib<1, SH_CONST, float> expected(float(102.4));

    try {
      if (test.run(distance_a_f_1f_1f_calldistance_test18, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_1f_1f_calldistance_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_1f_1f_calldistance_test19.name("distance_a_f_1f_1f_calldistance_test19");
  last_test = "distance_a_f_1f_1f_calldistance_test19";
  {  // f_1f_1f_calldistance_test19
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.1));
    ShAttrib<1, SH_CONST, float> expected(float(0.4));

    try {
      if (test.run(distance_a_f_1f_1f_calldistance_test19, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_a_f_1f_1f_calldistance_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance(a, b);
  } SH_END;

  distance_a_f_1f_1f_calldistance_test20.name("distance_a_f_1f_1f_calldistance_test20");
  last_test = "distance_a_f_1f_1f_calldistance_test20";
  {  // f_1f_1f_calldistance_test20
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.7333));
    ShAttrib<1, SH_CONST, float> expected(float(1.2333));

    try {
      if (test.run(distance_a_f_1f_1f_calldistance_test20, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test0.name("distance_1_a_f_3f_3f_calldistance1_test0");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test0";
  {  // f_3f_3f_calldistance1_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(9.0));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test1.name("distance_1_a_f_3f_3f_calldistance1_test1");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test1";
  {  // f_3f_3f_calldistance1_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(17.0));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test2.name("distance_1_a_f_3f_3f_calldistance1_test2");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test2";
  {  // f_3f_3f_calldistance1_test2
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(19.0));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test3.name("distance_1_a_f_3f_3f_calldistance1_test3");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test3";
  {  // f_3f_3f_calldistance1_test3
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(-5), float(-6));
    ShAttrib<1, SH_CONST, float> expected(float(9.0));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test4.name("distance_1_a_f_3f_3f_calldistance1_test4");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test4";
  {  // f_3f_3f_calldistance1_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(15.0));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test5.name("distance_1_a_f_3f_3f_calldistance1_test5");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test5";
  {  // f_3f_3f_calldistance1_test5
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(11.0));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test6.name("distance_1_a_f_3f_3f_calldistance1_test6");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test6";
  {  // f_3f_3f_calldistance1_test6
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(123.881));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test7.name("distance_1_a_f_3f_3f_calldistance1_test7");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test7";
  {  // f_3f_3f_calldistance1_test7
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(124.941));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test8.name("distance_1_a_f_3f_3f_calldistance1_test8");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test8";
  {  // f_3f_3f_calldistance1_test8
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(123.881));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test9.name("distance_1_a_f_3f_3f_calldistance1_test9");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test9";
  {  // f_3f_3f_calldistance1_test9
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(124.941));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test10.name("distance_1_a_f_3f_3f_calldistance1_test10");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test10";
  {  // f_3f_3f_calldistance1_test10
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(125.141));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test11.name("distance_1_a_f_3f_3f_calldistance1_test11");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test11";
  {  // f_3f_3f_calldistance1_test11
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(130.341));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_1f_1f_calldistance1_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_1f_1f_calldistance1_test12.name("distance_1_a_f_1f_1f_calldistance1_test12");
  last_test = "distance_1_a_f_1f_1f_calldistance1_test12";
  {  // f_1f_1f_calldistance1_test12
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_1_a_f_1f_1f_calldistance1_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_3f_3f_calldistance1_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_3f_3f_calldistance1_test13.name("distance_1_a_f_3f_3f_calldistance1_test13");
  last_test = "distance_1_a_f_3f_3f_calldistance1_test13";
  {  // f_3f_3f_calldistance1_test13
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_1_a_f_3f_3f_calldistance1_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_4f_4f_calldistance1_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_4f_4f_calldistance1_test14.name("distance_1_a_f_4f_4f_calldistance1_test14");
  last_test = "distance_1_a_f_4f_4f_calldistance1_test14";
  {  // f_4f_4f_calldistance1_test14
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_1_a_f_4f_4f_calldistance1_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_1f_1f_calldistance1_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_1f_1f_calldistance1_test15.name("distance_1_a_f_1f_1f_calldistance1_test15");
  last_test = "distance_1_a_f_1f_1f_calldistance1_test15";
  {  // f_1f_1f_calldistance1_test15
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_1_a_f_1f_1f_calldistance1_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_1f_1f_calldistance1_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_1f_1f_calldistance1_test16.name("distance_1_a_f_1f_1f_calldistance1_test16");
  last_test = "distance_1_a_f_1f_1f_calldistance1_test16";
  {  // f_1f_1f_calldistance1_test16
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(2.0));

    try {
      if (test.run(distance_1_a_f_1f_1f_calldistance1_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_1f_1f_calldistance1_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_1f_1f_calldistance1_test17.name("distance_1_a_f_1f_1f_calldistance1_test17");
  last_test = "distance_1_a_f_1f_1f_calldistance1_test17";
  {  // f_1f_1f_calldistance1_test17
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(98.0));

    try {
      if (test.run(distance_1_a_f_1f_1f_calldistance1_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_1f_1f_calldistance1_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_1f_1f_calldistance1_test18.name("distance_1_a_f_1f_1f_calldistance1_test18");
  last_test = "distance_1_a_f_1f_1f_calldistance1_test18";
  {  // f_1f_1f_calldistance1_test18
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.4));
    ShAttrib<1, SH_CONST, float> expected(float(102.4));

    try {
      if (test.run(distance_1_a_f_1f_1f_calldistance1_test18, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_1f_1f_calldistance1_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_1f_1f_calldistance1_test19.name("distance_1_a_f_1f_1f_calldistance1_test19");
  last_test = "distance_1_a_f_1f_1f_calldistance1_test19";
  {  // f_1f_1f_calldistance1_test19
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.1));
    ShAttrib<1, SH_CONST, float> expected(float(0.4));

    try {
      if (test.run(distance_1_a_f_1f_1f_calldistance1_test19, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_1_a_f_1f_1f_calldistance1_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_1(a, b);
  } SH_END;

  distance_1_a_f_1f_1f_calldistance1_test20.name("distance_1_a_f_1f_1f_calldistance1_test20");
  last_test = "distance_1_a_f_1f_1f_calldistance1_test20";
  {  // f_1f_1f_calldistance1_test20
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.7333));
    ShAttrib<1, SH_CONST, float> expected(float(1.2333));

    try {
      if (test.run(distance_1_a_f_1f_1f_calldistance1_test20, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test0 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test0.name("distance_inf_a_f_3f_3f_calldistanceinf_test0");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test0";
  {  // f_3f_3f_calldistanceinf_test0
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test0, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test1 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test1.name("distance_inf_a_f_3f_3f_calldistanceinf_test1");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test1";
  {  // f_3f_3f_calldistanceinf_test1
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(9.0));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test1, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test2 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test2.name("distance_inf_a_f_3f_3f_calldistanceinf_test2");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test2";
  {  // f_3f_3f_calldistanceinf_test2
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(9.0));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test2, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test3 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test3.name("distance_inf_a_f_3f_3f_calldistanceinf_test3");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test3";
  {  // f_3f_3f_calldistanceinf_test3
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(-5), float(-6));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test3, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test4 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test4.name("distance_inf_a_f_3f_3f_calldistanceinf_test4");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test4";
  {  // f_3f_3f_calldistanceinf_test4
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(7.0));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test4, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test5 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test5.name("distance_inf_a_f_3f_3f_calldistanceinf_test5");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test5";
  {  // f_3f_3f_calldistanceinf_test5
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(5.0));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test5, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test6 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test6.name("distance_inf_a_f_3f_3f_calldistanceinf_test6");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test6";
  {  // f_3f_3f_calldistanceinf_test6
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(86.881));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test6, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test7 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test7.name("distance_inf_a_f_3f_3f_calldistanceinf_test7");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test7";
  {  // f_3f_3f_calldistanceinf_test7
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(93.341));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test7, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test8 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test8.name("distance_inf_a_f_3f_3f_calldistanceinf_test8");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test8";
  {  // f_3f_3f_calldistanceinf_test8
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(86.881));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test8, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test9 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test9.name("distance_inf_a_f_3f_3f_calldistanceinf_test9");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test9";
  {  // f_3f_3f_calldistanceinf_test9
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(93.341));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test9, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test10 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test10.name("distance_inf_a_f_3f_3f_calldistanceinf_test10");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test10";
  {  // f_3f_3f_calldistanceinf_test10
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(93.341));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test10, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test11 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test11.name("distance_inf_a_f_3f_3f_calldistanceinf_test11");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test11";
  {  // f_3f_3f_calldistanceinf_test11
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(93.341));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test11, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_1f_1f_calldistanceinf_test12 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_1f_1f_calldistanceinf_test12.name("distance_inf_a_f_1f_1f_calldistanceinf_test12");
  last_test = "distance_inf_a_f_1f_1f_calldistanceinf_test12";
  {  // f_1f_1f_calldistanceinf_test12
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_inf_a_f_1f_1f_calldistanceinf_test12, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_3f_3f_calldistanceinf_test13 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<3, SH_INPUT, float> a;
    ShAttrib<3, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_3f_3f_calldistanceinf_test13.name("distance_inf_a_f_3f_3f_calldistanceinf_test13");
  last_test = "distance_inf_a_f_3f_3f_calldistanceinf_test13";
  {  // f_3f_3f_calldistanceinf_test13
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_inf_a_f_3f_3f_calldistanceinf_test13, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_4f_4f_calldistanceinf_test14 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<4, SH_INPUT, float> a;
    ShAttrib<4, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_4f_4f_calldistanceinf_test14.name("distance_inf_a_f_4f_4f_calldistanceinf_test14");
  last_test = "distance_inf_a_f_4f_4f_calldistanceinf_test14";
  {  // f_4f_4f_calldistanceinf_test14
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_inf_a_f_4f_4f_calldistanceinf_test14, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_1f_1f_calldistanceinf_test15 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_1f_1f_calldistanceinf_test15.name("distance_inf_a_f_1f_1f_calldistanceinf_test15");
  last_test = "distance_inf_a_f_1f_1f_calldistanceinf_test15";
  {  // f_1f_1f_calldistanceinf_test15
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    try {
      if (test.run(distance_inf_a_f_1f_1f_calldistanceinf_test15, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_1f_1f_calldistanceinf_test16 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_1f_1f_calldistanceinf_test16.name("distance_inf_a_f_1f_1f_calldistanceinf_test16");
  last_test = "distance_inf_a_f_1f_1f_calldistanceinf_test16";
  {  // f_1f_1f_calldistanceinf_test16
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(2.0));

    try {
      if (test.run(distance_inf_a_f_1f_1f_calldistanceinf_test16, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_1f_1f_calldistanceinf_test17 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_1f_1f_calldistanceinf_test17.name("distance_inf_a_f_1f_1f_calldistanceinf_test17");
  last_test = "distance_inf_a_f_1f_1f_calldistanceinf_test17";
  {  // f_1f_1f_calldistanceinf_test17
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(98.0));

    try {
      if (test.run(distance_inf_a_f_1f_1f_calldistanceinf_test17, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_1f_1f_calldistanceinf_test18 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_1f_1f_calldistanceinf_test18.name("distance_inf_a_f_1f_1f_calldistanceinf_test18");
  last_test = "distance_inf_a_f_1f_1f_calldistanceinf_test18";
  {  // f_1f_1f_calldistanceinf_test18
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.4));
    ShAttrib<1, SH_CONST, float> expected(float(102.4));

    try {
      if (test.run(distance_inf_a_f_1f_1f_calldistanceinf_test18, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_1f_1f_calldistanceinf_test19 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_1f_1f_calldistanceinf_test19.name("distance_inf_a_f_1f_1f_calldistanceinf_test19");
  last_test = "distance_inf_a_f_1f_1f_calldistanceinf_test19";
  {  // f_1f_1f_calldistanceinf_test19
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.1));
    ShAttrib<1, SH_CONST, float> expected(float(0.4));

    try {
      if (test.run(distance_inf_a_f_1f_1f_calldistanceinf_test19, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  ShProgram distance_inf_a_f_1f_1f_calldistanceinf_test20 = SH_BEGIN_PROGRAM("stream") {
    ShAttrib<1, SH_INPUT, float> a;
    ShAttrib<1, SH_INPUT, float> b;
    ShAttrib<1, SH_OUTPUT, float> out;
    out = distance_inf(a, b);
  } SH_END;

  distance_inf_a_f_1f_1f_calldistanceinf_test20.name("distance_inf_a_f_1f_1f_calldistanceinf_test20");
  last_test = "distance_inf_a_f_1f_1f_calldistanceinf_test20";
  {  // f_1f_1f_calldistanceinf_test20
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.7333));
    ShAttrib<1, SH_CONST, float> expected(float(1.2333));

    try {
      if (test.run(distance_inf_a_f_1f_1f_calldistanceinf_test20, a, b, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }
    total_tests++;
  }

  {  // f_3f_calllength_test0
    last_test = "f_3f_calllength_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test1
    last_test = "f_3f_calllength_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test2
    last_test = "f_3f_calllength_test2";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test3
    last_test = "f_3f_calllength_test3";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test4
    last_test = "f_3f_calllength_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test5
    last_test = "f_3f_calllength_test5";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.74165738677));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test6
    last_test = "f_3f_calllength_test6";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test7
    last_test = "f_3f_calllength_test7";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test8
    last_test = "f_3f_calllength_test8";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test9
    last_test = "f_3f_calllength_test9";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test10
    last_test = "f_3f_calllength_test10";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test11
    last_test = "f_3f_calllength_test11";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(4.21460555687));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength_test12
    last_test = "f_1f_calllength_test12";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_1f_calllength_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength_test13
    last_test = "f_3f_calllength_test13";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_3f_calllength_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllength_test14
    last_test = "f_4f_calllength_test14";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_4f_calllength_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllength_test15
    last_test = "f_4f_calllength_test15";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_4f_calllength_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength_test16
    last_test = "f_1f_calllength_test16";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_1f_calllength_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength_test17
    last_test = "f_1f_calllength_test17";
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_1f_calllength_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength_test18
    last_test = "f_1f_calllength_test18";
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_1f_calllength_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength_test19
    last_test = "f_1f_calllength_test19";
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_1f_calllength_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength_test20
    last_test = "f_1f_calllength_test20";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_1f_calllength_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength_test21
    last_test = "f_1f_calllength_test21";
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = length(a);

    try {
      if (test.check("f_1f_calllength_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test0
    last_test = "f_3f_calllength1_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test1
    last_test = "f_3f_calllength1_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test2
    last_test = "f_3f_calllength1_test2";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test3
    last_test = "f_3f_calllength1_test3";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test4
    last_test = "f_3f_calllength1_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test5
    last_test = "f_3f_calllength1_test5";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(6.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test6
    last_test = "f_3f_calllength1_test6";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test7
    last_test = "f_3f_calllength1_test7";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test8
    last_test = "f_3f_calllength1_test8";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test9
    last_test = "f_3f_calllength1_test9";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test10
    last_test = "f_3f_calllength1_test10";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test11
    last_test = "f_3f_calllength1_test11";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(6.13));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength1_test12
    last_test = "f_1f_calllength1_test12";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_1f_calllength1_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllength1_test13
    last_test = "f_3f_calllength1_test13";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_3f_calllength1_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllength1_test14
    last_test = "f_4f_calllength1_test14";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_4f_calllength1_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllength1_test15
    last_test = "f_4f_calllength1_test15";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_4f_calllength1_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength1_test16
    last_test = "f_1f_calllength1_test16";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_1f_calllength1_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength1_test17
    last_test = "f_1f_calllength1_test17";
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_1f_calllength1_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength1_test18
    last_test = "f_1f_calllength1_test18";
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_1f_calllength1_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength1_test19
    last_test = "f_1f_calllength1_test19";
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_1f_calllength1_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength1_test20
    last_test = "f_1f_calllength1_test20";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_1f_calllength1_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllength1_test21
    last_test = "f_1f_calllength1_test21";
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_1(a);

    try {
      if (test.check("f_1f_calllength1_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test0
    last_test = "f_3f_calllengthinf_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test1
    last_test = "f_3f_calllengthinf_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test2
    last_test = "f_3f_calllengthinf_test2";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test3
    last_test = "f_3f_calllengthinf_test3";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test4
    last_test = "f_3f_calllengthinf_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test5
    last_test = "f_3f_calllengthinf_test5";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test6
    last_test = "f_3f_calllengthinf_test6";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test7
    last_test = "f_3f_calllengthinf_test7";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test8
    last_test = "f_3f_calllengthinf_test8";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test9
    last_test = "f_3f_calllengthinf_test9";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test10
    last_test = "f_3f_calllengthinf_test10";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test11
    last_test = "f_3f_calllengthinf_test11";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<1, SH_CONST, float> expected(float(3.23));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllengthinf_test12
    last_test = "f_1f_calllengthinf_test12";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_1f_calllengthinf_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_calllengthinf_test13
    last_test = "f_3f_calllengthinf_test13";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_3f_calllengthinf_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllengthinf_test14
    last_test = "f_4f_calllengthinf_test14";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_4f_calllengthinf_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_calllengthinf_test15
    last_test = "f_4f_calllengthinf_test15";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_4f_calllengthinf_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllengthinf_test16
    last_test = "f_1f_calllengthinf_test16";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_1f_calllengthinf_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllengthinf_test17
    last_test = "f_1f_calllengthinf_test17";
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> expected(float(1.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_1f_calllengthinf_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllengthinf_test18
    last_test = "f_1f_calllengthinf_test18";
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_1f_calllengthinf_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllengthinf_test19
    last_test = "f_1f_calllengthinf_test19";
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> expected(float(100.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_1f_calllengthinf_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllengthinf_test20
    last_test = "f_1f_calllengthinf_test20";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_1f_calllengthinf_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_calllengthinf_test21
    last_test = "f_1f_calllengthinf_test21";
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> expected(float(0.5));

    ShAttrib<1, SH_TEMP, float> out;
    out = length_inf(a);

    try {
      if (test.check("f_1f_calllengthinf_test21", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test0
    last_test = "f_3f_3f_calldistance_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(5.19615242271));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test1
    last_test = "f_3f_3f_calldistance_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(10.7238052948));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test2
    last_test = "f_3f_3f_calldistance_test2";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(11.7898261226));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test3
    last_test = "f_3f_3f_calldistance_test3";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(-5), float(-6));
    ShAttrib<1, SH_CONST, float> expected(float(5.19615242271));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test4
    last_test = "f_3f_3f_calldistance_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(9.11043357914));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test5
    last_test = "f_3f_3f_calldistance_test5";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(6.5574385243));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test6
    last_test = "f_3f_3f_calldistance_test6";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(94.3924158023));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test7
    last_test = "f_3f_3f_calldistance_test7";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(98.5129548892));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test8
    last_test = "f_3f_3f_calldistance_test8";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(94.3924158023));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test9
    last_test = "f_3f_3f_calldistance_test9";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(98.5129548892));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test10
    last_test = "f_3f_3f_calldistance_test10";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(98.5133609263));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test11
    last_test = "f_3f_3f_calldistance_test11";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(100.370126437));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance_test12
    last_test = "f_1f_1f_calldistance_test12";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_1f_1f_calldistance_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance_test13
    last_test = "f_3f_3f_calldistance_test13";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_3f_3f_calldistance_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_calldistance_test14
    last_test = "f_4f_4f_calldistance_test14";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_4f_4f_calldistance_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance_test15
    last_test = "f_1f_1f_calldistance_test15";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_1f_1f_calldistance_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance_test16
    last_test = "f_1f_1f_calldistance_test16";
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(2.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_1f_1f_calldistance_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance_test17
    last_test = "f_1f_1f_calldistance_test17";
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(98.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_1f_1f_calldistance_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance_test18
    last_test = "f_1f_1f_calldistance_test18";
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.4));
    ShAttrib<1, SH_CONST, float> expected(float(102.4));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_1f_1f_calldistance_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance_test19
    last_test = "f_1f_1f_calldistance_test19";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.1));
    ShAttrib<1, SH_CONST, float> expected(float(0.4));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_1f_1f_calldistance_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance_test20
    last_test = "f_1f_1f_calldistance_test20";
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.7333));
    ShAttrib<1, SH_CONST, float> expected(float(1.2333));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance(a, b);

    try {
      if (test.check("f_1f_1f_calldistance_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test0
    last_test = "f_3f_3f_calldistance1_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(9.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test1
    last_test = "f_3f_3f_calldistance1_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(17.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test2
    last_test = "f_3f_3f_calldistance1_test2";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(19.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test3
    last_test = "f_3f_3f_calldistance1_test3";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(-5), float(-6));
    ShAttrib<1, SH_CONST, float> expected(float(9.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test4
    last_test = "f_3f_3f_calldistance1_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(15.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test5
    last_test = "f_3f_3f_calldistance1_test5";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(11.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test6
    last_test = "f_3f_3f_calldistance1_test6";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(123.881));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test7
    last_test = "f_3f_3f_calldistance1_test7";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(124.941));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test8
    last_test = "f_3f_3f_calldistance1_test8";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(123.881));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test9
    last_test = "f_3f_3f_calldistance1_test9";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(124.941));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test10
    last_test = "f_3f_3f_calldistance1_test10";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(125.141));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test11
    last_test = "f_3f_3f_calldistance1_test11";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(130.341));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance1_test12
    last_test = "f_1f_1f_calldistance1_test12";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_1f_1f_calldistance1_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistance1_test13
    last_test = "f_3f_3f_calldistance1_test13";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_3f_3f_calldistance1_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_calldistance1_test14
    last_test = "f_4f_4f_calldistance1_test14";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_4f_4f_calldistance1_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance1_test15
    last_test = "f_1f_1f_calldistance1_test15";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_1f_1f_calldistance1_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance1_test16
    last_test = "f_1f_1f_calldistance1_test16";
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(2.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_1f_1f_calldistance1_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance1_test17
    last_test = "f_1f_1f_calldistance1_test17";
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(98.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_1f_1f_calldistance1_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance1_test18
    last_test = "f_1f_1f_calldistance1_test18";
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.4));
    ShAttrib<1, SH_CONST, float> expected(float(102.4));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_1f_1f_calldistance1_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance1_test19
    last_test = "f_1f_1f_calldistance1_test19";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.1));
    ShAttrib<1, SH_CONST, float> expected(float(0.4));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_1f_1f_calldistance1_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistance1_test20
    last_test = "f_1f_1f_calldistance1_test20";
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.7333));
    ShAttrib<1, SH_CONST, float> expected(float(1.2333));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_1(a, b);

    try {
      if (test.check("f_1f_1f_calldistance1_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test0
    last_test = "f_3f_3f_calldistanceinf_test0";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test0", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test1
    last_test = "f_3f_3f_calldistanceinf_test1";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(9.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test1", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test2
    last_test = "f_3f_3f_calldistanceinf_test2";
    ShAttrib<3, SH_CONST, float> a(float(1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(9.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test2", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test3
    last_test = "f_3f_3f_calldistanceinf_test3";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(-3.0));
    ShAttrib<3, SH_CONST, float> b(float(-4), float(-5), float(-6));
    ShAttrib<1, SH_CONST, float> expected(float(3.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test3", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test4
    last_test = "f_3f_3f_calldistanceinf_test4";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(-2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(7.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test4", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test5
    last_test = "f_3f_3f_calldistanceinf_test5";
    ShAttrib<3, SH_CONST, float> a(float(-1.0), float(2.0), float(3.0));
    ShAttrib<3, SH_CONST, float> b(float(4), float(5), float(6));
    ShAttrib<1, SH_CONST, float> expected(float(5.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test5", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test6
    last_test = "f_3f_3f_calldistanceinf_test6";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(86.881));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test6", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test7
    last_test = "f_3f_3f_calldistanceinf_test7";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(93.341));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test7", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test8
    last_test = "f_3f_3f_calldistanceinf_test8";
    ShAttrib<3, SH_CONST, float> a(float(0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(86.881));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test8", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test9
    last_test = "f_3f_3f_calldistanceinf_test9";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(-3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(90.111));
    ShAttrib<1, SH_CONST, float> expected(float(93.341));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test9", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test10
    last_test = "f_3f_3f_calldistanceinf_test10";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(-2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(93.341));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test10", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test11
    last_test = "f_3f_3f_calldistanceinf_test11";
    ShAttrib<3, SH_CONST, float> a(float(-0.2), float(2.7), float(3.23));
    ShAttrib<3, SH_CONST, float> b(float(-0.1), float(-34.2), float(-90.111));
    ShAttrib<1, SH_CONST, float> expected(float(93.341));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test11", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistanceinf_test12
    last_test = "f_1f_1f_calldistanceinf_test12";
    ShAttrib<1, SH_CONST, float> a(float(0.0));
    ShAttrib<1, SH_CONST, float> b(float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_1f_1f_calldistanceinf_test12", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_3f_3f_calldistanceinf_test13
    last_test = "f_3f_3f_calldistanceinf_test13";
    ShAttrib<3, SH_CONST, float> a(float(0.0), float(0.0), float(0.0));
    ShAttrib<3, SH_CONST, float> b(float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_3f_3f_calldistanceinf_test13", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_4f_4f_calldistanceinf_test14
    last_test = "f_4f_4f_calldistanceinf_test14";
    ShAttrib<4, SH_CONST, float> a(float(0.0), float(0.0), float(0.0), float(0.0));
    ShAttrib<4, SH_CONST, float> b(float(0), float(0), float(0), float(0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_4f_4f_calldistanceinf_test14", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistanceinf_test15
    last_test = "f_1f_1f_calldistanceinf_test15";
    ShAttrib<1, SH_CONST, float> a(float(1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(0.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_1f_1f_calldistanceinf_test15", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistanceinf_test16
    last_test = "f_1f_1f_calldistanceinf_test16";
    ShAttrib<1, SH_CONST, float> a(float(-1.0));
    ShAttrib<1, SH_CONST, float> b(float(1.0));
    ShAttrib<1, SH_CONST, float> expected(float(2.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_1f_1f_calldistanceinf_test16", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistanceinf_test17
    last_test = "f_1f_1f_calldistanceinf_test17";
    ShAttrib<1, SH_CONST, float> a(float(100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.0));
    ShAttrib<1, SH_CONST, float> expected(float(98.0));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_1f_1f_calldistanceinf_test17", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistanceinf_test18
    last_test = "f_1f_1f_calldistanceinf_test18";
    ShAttrib<1, SH_CONST, float> a(float(-100.0));
    ShAttrib<1, SH_CONST, float> b(float(2.4));
    ShAttrib<1, SH_CONST, float> expected(float(102.4));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_1f_1f_calldistanceinf_test18", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistanceinf_test19
    last_test = "f_1f_1f_calldistanceinf_test19";
    ShAttrib<1, SH_CONST, float> a(float(0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.1));
    ShAttrib<1, SH_CONST, float> expected(float(0.4));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_1f_1f_calldistanceinf_test19", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  {  // f_1f_1f_calldistanceinf_test20
    last_test = "f_1f_1f_calldistanceinf_test20";
    ShAttrib<1, SH_CONST, float> a(float(-0.5));
    ShAttrib<1, SH_CONST, float> b(float(0.7333));
    ShAttrib<1, SH_CONST, float> expected(float(1.2333));

    ShAttrib<1, SH_TEMP, float> out;
    out = distance_inf(a, b);

    try {
      if (test.check("f_1f_1f_calldistanceinf_test20", out, expected, 0.01) != 0) errors++;
    } catch (const ShException &e) {
      std::cout << "Caught Sh Exception in '" << last_test << "'." << std::endl << e.message() << std::endl;
      errors++;
    } catch (const std::exception& e) {
      std::cerr << "Caught C++ exception in '" << last_test << "' : " << e.what() << std::endl;
      errors++;
    }

  }
  if (errors !=0) {
    std::cout << "Total Errors: " << errors << "/" << total_tests << std::endl;
    return 1;
  }
}

